Package: scDD
Version: 1.34.0
Title: Mixture modeling of single-cell RNA-seq data to identify genes
        with differential distributions
Description: This package implements a method to analyze single-cell
        RNA- seq Data utilizing flexible Dirichlet Process mixture
        models. Genes with differential distributions of expression are
        classified into several interesting patterns of differences
        between two conditions. The package also includes functions for
        simulating data with these patterns from negative binomial
        distributions.
Authors@R: person("Keegan", "Korthauer", role = c("cre", "aut"), 
                  email = "keegan@stat.ubc.ca", 
                  comment = c(ORCID = "0000-0002-4565-1654"))
Depends: R (>= 3.5.0)
NeedsCompilation: yes
Imports: fields, mclust, BiocParallel, outliers, ggplot2, EBSeq, arm,
        SingleCellExperiment, SummarizedExperiment, grDevices,
        graphics, stats, S4Vectors, scran
Suggests: BiocStyle, knitr, gridExtra
License: GPL-2
RoxygenNote: 6.0.1
VignetteBuilder: knitr
biocViews: ImmunoOncology, Bayesian, Clustering, RNASeq, SingleCell,
        MultipleComparison, Visualization, DifferentialExpression
URL: https://github.com/kdkorthauer/scDD
BugReports: https://github.com/kdkorthauer/scDD/issues
git_url: https://git.bioconductor.org/packages/scDD
git_branch: RELEASE_3_22
git_last_commit: 924aec4
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
Packaged: 2025-10-30 06:18:00 UTC; biocbuild
Author: Keegan Korthauer [cre, aut] (ORCID:
    <https://orcid.org/0000-0002-4565-1654>)
Maintainer: Keegan Korthauer <keegan@stat.ubc.ca>

# scDD: An R package to identify differentially distributed genes in scRNA-seq 

## Installation 
The Bioconductor landing page is 
[https://bioconductor.org/packages/scDD](https://bioconductor.org/packages/scDD).
To install, make sure you have the current version of Bioconductor, and 
use the following commands:

```R
install.packages("BiocManager")
BiocManager::install("scDD")
```


## Quick Start
For examples and tips on using the package, please see the vignette PDF 
[here](http://bioconductor.org/packages/devel/bioc/vignettes/scDD/inst/doc/scDD.pdf)
which you can alternatively bring up by typing 

```R
browseVignettes("scDD")
```

after installing and loading the package into R.  

## Getting Help
Please send bug reports and feature requests by sending a message to Bioconductor
Support at [https://support.bioconductor.org](https://support.bioconductor.org)
or by opening a new issue on 
[this page](https://github.com/kdkorthauer/scDD/issues)

## Citation
Please cite the following publication if you use scDD in your work:
> Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions in single-cell RNA-seq experiments. Genome Biology. 
2016 Oct 25;17(1):222. 
[https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-1077-y](https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-1077-y)

You can obtain this citation within R by typing

```R
citation("scDD")
```

#' scDD
#' 
#' Find genes with differential distributions (DD) across two conditions
#' 
#' @details Find genes with differential distributions (DD) across two 
#' conditions.  Models each log-transformed gene as a Dirichlet 
#'   Process Mixture of normals and uses a permutation test to determine 
#'   whether condition membership is independent of sample clustering.
#'   The FDR adjusted (Benjamini-Hochberg) permutation p-value is returned 
#'   along with the classification of each significant gene 
#'   (with p-value less than 0.05 (or 0.025 if also testing for a difference
#'    in the proportion of zeroes)) into one of four categories 
#'   (DE, DP, DM, DB).  For genes that do not show significant influence, 
#'   of condition on clustering, an optional test of whether the 
#'   proportion of zeroes (dropout rate) is different across conditions is 
#'   performed (DZ).
#'   
#' @param SCdat An object of class \code{SingleCellExperiment} that contains 
#' normalized single-cell expression and metadata. The \code{assays} 
#'   slot contains a named list of matrices, where the normalized counts are 
#'   housed in the one named \code{normcounts}.  This matrix should have one
#'    row for each gene and one sample for each column.  
#'   The \code{colData} slot should contain a data.frame with one row per 
#'   sample and columns that contain metadata for each sample.  This data.frame
#'   should contain a variable that represents biological condition, which is 
#'   in the form of numeric values (either 1 or 2) that indicates which 
#'   condition each sample belongs to (in the same order as the columns of 
#'   \code{normcounts}).  Optional additional metadata about each cell can also
#'   be contained in this data.frame, and additional information about the 
#'   experiment can be contained in the \code{metadata} slot as a list.
#' 
#' @param prior_param A list of prior parameter values to be used when modeling
#'  each gene as a mixture of DP normals.  Default 
#'    values are given that specify a vague prior distribution on the 
#'    cluster-specific means and variances.
#'    
#' @param permutations The number of permutations to be used in calculating 
#' empirical p-values.  If set to zero (default),
#'   the full Bayes Factor permutation test will not be performed.  Instead, 
#'   a fast procedure to identify the genes with significantly different
#'   expression distributions will be performed using the nonparametric 
#'   Kolmogorov-Smirnov test, which tests the null hypothesis that 
#'   the samples are generated from the same continuous distribution.  
#'   This test will yield
#'   slightly lower power than the full permutation testing framework 
#'   (this effect is more pronounced at smaller sample 
#'   sizes, and is more pronounced in the DB category), but is orders of 
#'   magnitude faster.  This option
#'   is recommended when compute resources are limited.  The remaining 
#'   steps of the scDD framework will remain unchanged
#'   (namely, categorizing the significant DD genes into patterns that 
#'   represent the major distributional changes, 
#'   as well as the ability to visualize the results with violin plots 
#'   using the \code{sideViolin} function).
#' 
#' @param testZeroes Logical indicating whether or not to test for a 
#' difference in the proportion of zeroes. This will only be done for genes 
#' that have at least one zero value (genes where all cells have a nonzero value
#' will have a `zero.pvalue` of NA).
#' 
#' @param level numeric value between 0 and 1 that specifies the alpha level
#' for significance of a differential gene test (default value 0.05). This is 
#' used to decide whether to classify a gene into one of the differential
#' patterns. If `testZeroes` is FALSE and the adjusted p-value for a given gene 
#' is below `level`, then the gene is categorized. Alternatively, if `testZeroes` 
#' is TRUE, then the adjusted p-value must be below `level/2` in order to be
#' considered significant and categorized. This is done to control for multiple
#' testing since `testZeroes=TRUE` means that each gene is tested for a 
#' difference in nonzeroes and zeroes separately.
#' 
#' @param adjust.perms Logical indicating whether or not to adjust the 
#' permutation tests for the sample
#'   detection rate (proportion of nonzero values).  If true, the 
#'   residuals of a linear model adjusted for 
#'   detection rate are permuted, and new fitted values are 
#'   obtained using these residuals.
#'  
#' @param param a \code{MulticoreParam} or \code{SnowParam} object of 
#' the \code{BiocParallel}
#' package that defines a parallel backend.  The default option is 
#' \code{BiocParallel::bpparam()} which will automatically creates a cluster 
#' appropriate for 
#' the operating system.  Alternatively, the user can specify the number
#' of cores they wish to use by first creating the corresponding 
#' \code{MulticoreParam} (for Linux-like OS) or \code{SnowParam} (for Windows)
#' object, and then passing it into the \code{scDD}
#' function. This could be done to specify a parallel backend on a Linux-like
#' OS with, say 12 
#' cores by setting \code{param=BiocParallel::MulticoreParam(workers=12)}
#'  
#' @param parallelBy For the permutation test (if invoked), the manner in 
#' which to parallelize.  The default option
#'  is \code{"Genes"} which will spawn processes that divide up the genes 
#'  across all cores defined in \code{param} cores, and then loop through the 
#'  permutations. 
#'  The alternate option is \code{"Permutations"} which
#'  loop through each gene and spawn processes that divide up the permutations 
#'  across all cores defined in \code{param}.  
#'  The default option is recommended when analyzing more genes than the number
#'   of permutations.
#' 
#' @param condition A character object that contains the name of the column in 
#' \code{colData} that represents 
#'  the biological group or condition of interest (e.g. treatment versus 
#'  control).  Note that this variable should only contain two 
#'  possible values since \code{scDD} can currently only handle two-group 
#'  comparisons.  The default option assumes that there
#'  is a column named "condition" that contains this variable. 
#'  
#' @param min.size a positive integer that specifies the minimum size of a 
#' cluster (number of cells) for it to be used
#'  during the classification step.  Any clusters containing fewer than 
#'  \code{min.size} cells will be considered an outlier
#'  cluster and ignored in the classfication algorithm.  The default value
#'   is three.
#'   
#' @param min.nonzero a positive integer that specifies the minimum number of
#' nonzero cells in each condition required for the test of differential 
#' distributions.  If a gene has fewer nonzero cells per condition, it will
#' still be tested for DZ (if \code{testZeroes} is TRUE). Default value is
#' NULL (no minimum value is enforced).
#' 
#' @param categorize a logical indicating whether to determine which 
#' categories (DE, DP, DM, DB) each gene belongs to (default = TRUE). This
#' can only be set to FALSE if `permutations` is set to zero, since the full
#' model fitting will automatically be carried out if permutations are run.
#' 
#' @return A \code{SingleCellExperiment} object that contains the data and 
#' sample information from the input object, but where the results objects
#' are now added to the \code{metadata} slot. The metadata slot is now a
#' list with four items: the first (main results object) is a data.frame 
#' with the following columns: 
#' \itemize{
#'   \item `gene`: gene name (matches rownames of SCdat)
#'   \item `DDcategory`: name of the DD (DE, DP, DM, DB, DZ) pattern (or NS = not significant) 
#'   \item `Clusters.combined`: the number of clusters identified overall
#'   \item `Clusters.C1`: the number of clusters identified in condition 1 alone
#'   \item `Clusters.C2`: the number of clusters identified in condition 2 alone
#'   \item `nonzero.pvalue`: permutation (or KS) p-value for testing difference
#'   in nonzero expression values
#'   \item `nonzero.pvalue.adj`: Benjamini-Hochberg adjusted version of the 
#'     `nonzero.pvalue`column
#'   \item `zero.pvalue`: p-value for test of difference in dropout rate 
#'   (only if `testZeroes` is TRUE) 
#'   \item `zero.pvalue`: Benjamini-Hochberg adjusted version of the previous column 
#'   (only if `testZeroes` is TRUE) 
#'   \item `combined.pvalue`: Fisher's combined p-value for a difference in nonzero or zero values
#'   (only if `testZeroes` is TRUE). 
#'   \item `combined.pvalue.adj`: Benjamini-Hochberg adjusted version of the previous column 
#'   (only if `testZeroes` is TRUE) 
#' }
#'  
#' The remaining three elements are matrices (first for condition
#'   1 and 2 combined, 
#'  then condition 1 alone, then condition 2 alone) that contains the cluster
#'   memberships for each sample (cluster 1,2,3,...) in columns and
#'  genes in rows.  Zeroes, which are not involved in the clustering, are
#'   labeled as zero.  See the \code{results} function for a convenient
#'   way to extract these results objects.
#'  
#' @export
#'
#' @importFrom BiocParallel bplapply  
#' 
#' @importFrom BiocParallel register
#' 
#' @importFrom BiocParallel MulticoreParam
#' 
#' @importFrom BiocParallel bpparam
#' 
#' @importFrom parallel detectCores
#' 
#' @importFrom S4Vectors metadata
#' 
#' @import SingleCellExperiment
#' 
#' @import SummarizedExperiment
#' 
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'  
#' @examples 
#'  
#' # load toy simulated example SingleCellExperiment object to find DD genes
#' 
#' data(scDatExSim)
#' 
#' 
#' # check that this object is a member of the SingleCellExperiment class
#' # and that it contains 200 samples and 30 genes
#' 
#' class(scDatExSim)
#' show(scDatExSim)
#' 
#' 
#' # set arguments to pass to scDD function
#' # we will perform 100 permutations on each of the 30 genes
#' 
#' prior_param=list(alpha=0.01, mu0=0, s0=0.01, a0=0.01, b0=0.01)
#' nperms <- 100
#' 
#' 
#' # call the scDD function to perform permutations, classify DD genes, 
#' # and return results
#' # we won't perform the test for a difference in the proportion of zeroes  
#' # since none exists in this simulated toy example data
#' # this step will take significantly longer with more genes and/or 
#' # more permutations
#' 
#' scDatExSim <- scDD(scDatExSim, prior_param=prior_param, permutations=nperms, 
#'             testZeroes=FALSE)

scDD <- function(SCdat, 
                 prior_param=list(alpha=0.10, mu0=0, s0=0.01, a0=0.01, b0=0.01),
                 permutations=0,
                 testZeroes=TRUE, adjust.perms=FALSE, 
                 param=bpparam(), 
                 parallelBy=c("Genes", "Permutations"),
                 condition="condition", min.size=3,
                 min.nonzero=NULL,
                 level=0.05, categorize = TRUE){
  
  # check whether SCdat is a member of the SingleCellExperiment class
  if(!("SingleCellExperiment" %in% class(SCdat))){
    stop("Please provide a valid 'SingleCellExperiment' object.")
  }
  
  if (is.null(assayNames(SCdat)) || !("normcounts" %in% assayNames(SCdat))) {
    stop("Please make sure the 'SingleCellExperiment' object includes ",
         "an assays slot named 'normcounts' that contains normalized ",
         "counts on the original scale")
  }
  
  if (!categorize && permutations != 0){
    stop("Categorization will be carried out if permuations are run.")
  }
  
  parallelBy <- match.arg(parallelBy)
  
  # unpack prior param objects
  alpha = prior_param$alpha
  m0 = prior_param$mu0
  s0 = prior_param$s0
  a0 = prior_param$a0
  b0 = prior_param$b0
  
  # check that condition inputs are valid
  if (length(unique(colData(SCdat)[[condition]])) != 2 | 
      length(colData(SCdat)[[condition]]) != ncol(normcounts(SCdat))){
    stop("Error: Please specify valid condition labels.")
  }
  
  # reference category/condition - the first listed one
  ref <- unique(colData(SCdat)[[condition]])[1]
  
  # check for genes with negative expression values
  if (sum(normcounts(SCdat) < 0) > 0){
    stop(paste0("Error: Negative values for Normalized Expression counts ",
                "detected. Please ensure all counts are non-negative"))
  }
  
  # check for genes that are all (or almost all) zeroes
  if (is.null(min.nonzero)){
    min.nonzero <- min.size
  }
  tofit <- which(
           (rowSums(normcounts(SCdat)[,colData(SCdat)[[condition]]==ref,drop=FALSE]>0) >= 
             max(min.size,2,min.nonzero)) &
           (rowSums(normcounts(SCdat)[,colData(SCdat)[[condition]]!=ref,drop=FALSE]>0) >= 
              max(min.size,2,min.nonzero)))
  
  if (length(tofit) < nrow(normcounts(SCdat))){
    if(testZeroes){
      message(paste0("Notice: ", nrow(normcounts(SCdat))-length(tofit), 
              " genes have less than ", min.nonzero, 
              " nonzero cells per condition. ",
              " Only testing for DZ for these genes."))  
    }else{
      message(paste0("Notice: ", nrow(normcounts(SCdat))-length(tofit), 
                     " genes have less than ", min.nonzero, 
                     " nonzero cells per condition. ",
                     " Skipping these genes."))  
    }
  }
  
  # check for genes for which all nonzero values are identical within at least 
  # one of the conditions. These will cause problems in model fitting
  skipConstant <- which( 
                apply(normcounts(SCdat)[tofit,
                                       colData(SCdat)[[condition]]==ref, drop=FALSE], 1,
                                function(x) length(unique(x[x>0])) == 1) |
                apply(normcounts(SCdat)[tofit,
                                       colData(SCdat)[[condition]]!=ref, drop=FALSE], 1,
                                function(x) length(unique(x[x>0])) == 1) )
  if (length(skipConstant) > 0){
    if(testZeroes){
      message(paste0("Notice: ", length(skipConstant), 
                     " Genes have constant nonzero values. ", 
                     " Only testing for DZ for these genes."))  
    }else{
      message(paste0("Notice: ", length(skipConstant), 
                     " Genes have constant nonzero values. ", 
                     " Skipping these genes."))  
    }
    tofit <- tofit[-skipConstant]
  }
  
  message(paste0("Setting up parallel back-end using ", 
                 param$workers, " cores" ))
  BiocParallel::register(BPPARAM = param)
  
  oa <- c1 <- c2 <- vector("list", nrow(normcounts(SCdat)[tofit,,drop=FALSE]))
  bf <- den <- comps.all <- 
    comps.c1 <- comps.c2 <- rep(NA, nrow(normcounts(SCdat)[tofit,,drop=FALSE]))
  
  # cluster each gene in SCdat
  if (categorize)
    message("Clustering observed expression data for each gene")
  
  if (permutations == 0){

    # function to fit one gene 
    genefit <- function(y){
      cond0 <- colData(SCdat)[[condition]][y>0]
      y <- log(y[y>0])
      
      oa <- mclustRestricted(y, restrict=TRUE, min.size=min.size)
      c1 <- mclustRestricted(y[cond0==ref], restrict=TRUE, min.size=min.size)
      c2 <- mclustRestricted(y[cond0!=ref], restrict=TRUE, min.size=min.size)
    
      return(list(
        oa=oa,
        c1=c1,
        c2=c2
      ))
    }
    
    if (categorize){
      out <- bplapply(1:nrow(normcounts(SCdat)[tofit,,drop=FALSE]), function(x) 
        genefit(normcounts(SCdat)[tofit[x],]))
      oa <- lapply(out, function(x) x[["oa"]])
      c1 <- lapply(out, function(x) x[["c1"]])
      c2 <- lapply(out, function(x) x[["c2"]])
      rm(out); gc()
    
      comps.all <- unlist(lapply(oa, function(x) luOutlier(x$class, min.size)))
      comps.c1  <- unlist(lapply(c1, function(x) luOutlier(x$class, min.size)))
      comps.c2  <- unlist(lapply(c2, function(x) luOutlier(x$class, min.size)))
    }
    
    message("Notice: Number of permutations is set to zero; using 
            Kolmogorov-Smirnov to test for differences in distributions
            instead of the Bayes Factor permutation test")
    
    res_ks <- testKS(normcounts(SCdat)[tofit,,drop=FALSE], 
                     colData(SCdat)[[condition]], inclZero=FALSE)
    
    if (testZeroes){
      sig <- which(res_ks$p < level/2)
    }else{
      sig <- which(res_ks$p < level)
    }
    
    pvals <- res_ks$p.unadj
    
  }else{ 

    # function to fit one gene 
    genefit <- function(y){
      cond0 <- colData(SCdat)[[condition]][y>0]
      y <- log(y[y>0])
      
      oa <- mclustRestricted(y, restrict=TRUE, min.size=min.size)
      c1 <- mclustRestricted(y[cond0==ref], restrict=TRUE, min.size=min.size)
      c2 <- mclustRestricted(y[cond0!=ref], restrict=TRUE, min.size=min.size)
      
      bf <- jointPosterior(y[cond0==ref], c1, alpha, m0, s0, a0, b0) + 
        jointPosterior(y[cond0!=ref], c2, alpha, m0, s0, a0, b0) 
      den <- jointPosterior(y, oa, alpha, m0, s0, a0, b0)
      return(list(
        oa=oa,
        c1=c1,
        c2=c2,
        bf=bf,
        den=den
      ))
    }
    
    out <- bplapply(1:nrow(normcounts(SCdat)[tofit,,drop=FALSE]), function(x) 
      genefit(normcounts(SCdat)[tofit[x],]))
    oa <- lapply(out, function(x) x[["oa"]])
    c1 <- lapply(out, function(x) x[["c1"]])
    c2 <- lapply(out, function(x) x[["c2"]])
    bf <- unlist(lapply(out, function(x) x[["bf"]]))
    den<- unlist(lapply(out, function(x) x[["den"]]))
    rm(out); gc()
    
    comps.all <- unlist(lapply(oa, function(x) luOutlier(x$class, min.size)))
    comps.c1  <- unlist(lapply(c1, function(x) luOutlier(x$class, min.size)))
    comps.c2  <- unlist(lapply(c2, function(x) luOutlier(x$class, min.size)))
  

      # obtain Bayes Factor score numerators for each permutation
      message("Performing permutations to evaluate independence of clustering
              and condition for each gene")
      message(paste0("Parallelizing by ", parallelBy))
      bf.perm <- vector("list", nrow(normcounts(SCdat)[tofit,,drop=FALSE]))
      names(bf.perm) <- rownames(normcounts(SCdat)[tofit,,drop=FALSE])
      
      if(parallelBy=="Permutations"){
        if(adjust.perms){
          C <- apply(normcounts(SCdat)[tofit,,drop=FALSE], 2, 
                     function(x) sum(x>0)/length(x))
          
          t1 <- proc.time()
          for (g in 1:nrow(normcounts(SCdat)[tofit,,drop=FALSE])){
            bf.perm[[g]] <- permMclustCov(normcounts(SCdat)[tofit[g],], 
                                          permutations, C, 
                                          colData(SCdat)[[condition]], 
                                          remove.zeroes=TRUE, 
                                          log.transf=TRUE, restrict=TRUE,
                                          min.size=min.size,
                                          alpha, m0, s0, a0, b0, ref)
            
            if (g%%1000 == 0){
              t2 <- proc.time()
              message(paste0(g, " genes completed at ", date(), ", took ", 
                             round((t2-t1)[3]/60, 2), " minutes")) 
              t1 <- t2
            }
          }
          
        }else{
          t1 <- proc.time()
          for (g in 1:nrow(normcounts(SCdat)[tofit,,drop=FALSE])){
            bf.perm[[g]] <- permMclust(normcounts(SCdat[tofit[g],]), 
                                       permutations,
                                       colData(SCdat)[[condition]], 
                                       remove.zeroes=TRUE, log.transf=TRUE, 
                                       restrict=TRUE,
                                       min.size=min.size, 
                                       alpha, m0, s0, a0, b0, ref)
            
            if (g%%1000 == 0){
              t2 <- proc.time()
              message(paste0(g, " genes completed at ", date(), ", took ", 
                             round((t2-t1)[3]/60, 2), " minutes")) 
              t1 <- t2
            }
          }
      }
      }else if(parallelBy=="Genes"){
        C <- apply(normcounts(SCdat)[tofit,,drop=FALSE], 2, function(x) sum(x>0)/length(x))
        bf.perm <- bplapply(1:nrow(normcounts(SCdat)[tofit,,drop=FALSE]), function(x) 
              permMclustGene(normcounts(SCdat)[tofit[x],], adjust.perms, 
                             permutations, colData(SCdat)[[condition]], 
                             remove.zeroes=TRUE, log.transf=TRUE, restrict=TRUE,
                             min.size=min.size,
                             alpha, m0, s0, a0, b0, C, ref))
      }else{stop("Please specify either 'Permutations' or 'Genes' to 
                 parallelize by using the parallelizeBy argument")}
      
      if (adjust.perms){
        pvals <- sapply(1:nrow(normcounts(SCdat)[tofit,,drop=FALSE]), function(x) 
          sum( bf.perm[[x]] > bf[x] - den[x] ) )/(permutations)
      }else{
        pvals <- sapply(1:nrow(normcounts(SCdat)[tofit,,drop=FALSE]), function(x) 
          sum( bf.perm[[x]] > bf[x]) ) / (permutations)
      }
      
      if (testZeroes){
        sig <- which(p.adjust(pvals, method="BH") < level/2)
      }else{
        sig <- which(p.adjust(pvals, method="BH") < level)
      }
  }
  
  cats.all <- pvals.all <- rep(NA, nrow(normcounts(SCdat)))
  pvals.all[tofit] <- pvals
  
  if (categorize){
    message("Classifying significant genes into patterns")
    dd.cats <- classifyDD(normcounts(SCdat)[tofit,,drop=FALSE], colData(SCdat)[[condition]],
                        sig, oa, c1, c2, alpha=alpha, 
                        m0=m0, s0=s0, a0=a0, b0=b0, 
                        log.nonzero=TRUE, ref=ref, min.size=min.size)
  
    cats <- rep("NS", nrow(normcounts(SCdat)[tofit,,drop=FALSE]))
    cats[sig] <- dd.cats
  
    extraDP <- feDP(normcounts(SCdat)[tofit,,drop=FALSE], colData(SCdat)[[condition]], 
                  sig, oa, c1, c2, log.nonzero=TRUE,
                  testZeroes=testZeroes, adjust.perms=adjust.perms, 
                  min.size=min.size)
    cats[-sig] <- names(extraDP)
  
    # classify additional genes with evidence of DD in 
    # the form of a mean shift found by 'extraDP'
    if(testZeroes){
      NCs <- which(p.adjust(pvals, method="BH") > level/2 & cats == "NC")
    }else{
      NCs <- which(p.adjust(pvals, method="BH") > level & cats == "NC")
    }
    NC.cats <- classifyDD(normcounts(SCdat)[tofit,,drop=FALSE], colData(SCdat)[[condition]],
                        NCs, oa, c1, c2, alpha=alpha, 
                        m0=m0, s0=s0, a0=a0, b0=b0, log.nonzero=TRUE, 
                        ref=ref, min.size=min.size)
    cats[NCs] <- NC.cats
    cats.all[tofit] <- cats
  }
  
  # zero test
  pvals.z <- rep(NA, nrow(normcounts(SCdat)))
  if (testZeroes){
    pvals.z <- testZeroes(normcounts(SCdat), colData(SCdat)[[condition]])
    cats.all[p.adjust(pvals.z, method="BH") < level/2 &
               !(cats.all %in% c("DE", "DP", "DM", "DB"))] <- "DZ"
    if (categorize)
      cats.all[p.adjust(pvals.z, method="BH") >= level/2 &
                 !(cats.all %in% c("DE", "DP", "DM", "DB"))] <- "NS"
  }
  
  # build MAP objects
  if (categorize){
    MAP1 <- matrix(1, nrow=nrow(normcounts(SCdat)), 
                 ncol=sum(colData(SCdat)[[condition]]==ref))
    MAP2 <- matrix(1, nrow=nrow(normcounts(SCdat)), 
                 ncol=sum(colData(SCdat)[[condition]]!=ref))
    MAP <- matrix(1, nrow=nrow(normcounts(SCdat)), 
                ncol=ncol(normcounts(SCdat)))
    rownames(MAP1) <- rownames(MAP2) <- rownames(MAP) <- rownames(SCdat)
    colnames(MAP1) <- colnames(SCdat[,colData(SCdat)[[condition]]==ref])
    colnames(MAP2) <- colnames(SCdat[,colData(SCdat)[[condition]]!=ref])
    colnames(MAP) <- colnames(SCdat)
    MAP1[normcounts(SCdat[, colData(SCdat)[[condition]]==ref])==0] <- 0
    MAP2[normcounts(SCdat[, colData(SCdat)[[condition]]!=ref])==0] <- 0
    MAP[normcounts(SCdat)==0] <- 0
  
    for (g in 1:nrow(normcounts(SCdat)[tofit,,drop=FALSE])){
      MAP1[tofit[g],][normcounts(SCdat[tofit[g], 
                  colData(SCdat)[[condition]]==ref])!=0] <- c1[[g]]$class 
      MAP2[tofit[g],][normcounts(SCdat[tofit[g], 
                  colData(SCdat)[[condition]]!=ref])!=0] <- c2[[g]]$class
      MAP[tofit[g],][normcounts(SCdat[tofit[g], ])!=0] <- oa[[g]]$class
    }
  }else{
    MAP1 <- MAP2 <- MAP <- "Categorize set to FALSE; no clustering provided."
  }
  
  comps.all.ALL <- comps.c1.ALL <- comps.c2.ALL <- rep(NA, 
                                                       nrow(normcounts(SCdat)))
  comps.all.ALL[tofit] <- comps.all
  comps.c1.ALL[tofit] <- comps.c1
  comps.c2.ALL[tofit] <- comps.c2
  
  Genes = data.frame(gene=rownames(SCdat), 
                   DDcategory=cats.all, 
                   Clusters.combined=comps.all.ALL, 
                   Clusters.c1=comps.c1.ALL, 
                   Clusters.c2=comps.c2.ALL,
                   nonzero.pvalue=pvals.all,
                   nonzero.pvalue.adj=p.adjust(pvals.all, method="BH"))
  
  # only give dropout-related p-values if testZeroes = TRUE 
  if(testZeroes){
    fishersCombinedPval = function(x){ 
      if(sum(is.na(x)) == 0){
        pchisq(-2 * sum(log(x)), df=2*length(x),lower=FALSE)
      }else if(sum(is.na(x)) == 1){
        x[!is.na(x)]
      }else{
        NA
      }
    }
    
    # compute combined p-value
    pvals.comb <- apply(cbind(pvals.all, pvals.z), 1, function(x)
      fishersCombinedPval(x))
    
    Genes <- cbind(Genes,
                   zero.pvalue=pvals.z, 
                   zero.pvalue.adj=p.adjust(pvals.z, method="BH"),
                   combined.pvalue=pvals.comb,
                   combined.pvalue.adj=p.adjust(pvals.comb, method="BH"))
  }
  
  rownames(Genes) <- rownames(SCdat)
  
  # place these results objects in the appropriately named assays()
  # slots of the SingleCellExperiment object
  metadata(SCdat)[["Genes"]] <- Genes
  metadata(SCdat)[["Zhat.combined"]] <- MAP
  metadata(SCdat)[["Zhat.c1"]] <- MAP1
  metadata(SCdat)[["Zhat.c2"]] <- MAP2
  
  # return...
  return(SCdat)
}

#' testKS
#'
#' Function to perform KS test
#'
#' @inheritParams singleCellSimu 
#' 
#' @param dat Matrix of single-cell RNA-seq data with genes in rows and samples 
#' in columns.
#'
#' @param condition Vector containing the indicator of which condition each 
#' sample 
#'  (in the columns of \code{dat}) belongs to.
#' 
#' @param DEIndex Vector containing the row numbers of the DE genes
#'
#' @param inclZero Logical indicating whether to include zero in the test of 
#' different distributions
#'
#' @export 
#' 
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'
#' @return List object containing the significant gene indices, their adjusted 
#' p-values, and (if DE genes are supplied)
#' the power and fdr.
#'   
#' @examples 
#' 
#' # load toy simulated example ExpressionSet to find KS genes
#' 
#' data(scDatExSim)
#' 
#' 
#' # load SingleCellExperiment package to facilitate subset operations
#' 
#' library(SingleCellExperiment)
#' 
#' 
#' # check that this object is a member of the ExpressionSet class
#' # and that it contains 200 samples and 30 genes
#' 
#' class(scDatExSim)
#' show(scDatExSim)
#' 
#' # perform KS test and obtain adjusted p-values
#' RES_KS <- testKS(normcounts(scDatExSim), scDatExSim$condition, inclZero=FALSE,
#'                  numDE=20, DEIndex=1:20)


testKS <- function(dat, condition, inclZero=TRUE, numDE=NULL, DEIndex){
  onegene <- function(x, dat, condition, inclZero){
    x1 <- dat[x,][condition==unique(condition)[1]]
    x2 <- dat[x,][condition==unique(condition)[2]]
    
    if (!inclZero){
      x1 <- (x1[x1>0])
      x2 <- (x2[x2>0])
    }
    suppressWarnings(ks.test(x1,x2, exact=FALSE))$p.value
  }
  
  ks.pval.unadj <- unlist(bplapply(seq_len(nrow(dat)), onegene, 
                                   condition=condition, dat=dat,
                                   inclZero=inclZero))
  ks.pval <- p.adjust(ks.pval.unadj, method="BH")
  sig_genes_ks <- which(ks.pval < 0.05)
  names(sig_genes_ks) <- rownames(dat)[sig_genes_ks]
  names(ks.pval) <- rownames(dat)
  
  if(!is.null(numDE)){
    power <- sum(sig_genes_ks %in% DEIndex) / numDE
    fdr <- length(sig_genes_ks[!(sig_genes_ks %in% DEIndex)]) / 
      length(sig_genes_ks)
    return(list(genes=sig_genes_ks, p=ks.pval, p.unadj=ks.pval.unadj, 
                power=power, fdr=fdr))
  }
  return(list(genes=sig_genes_ks, p=ks.pval, p.unadj=ks.pval.unadj))
}

#' calcRP
#'
#'  Calculate parameter R and P in NB distribution
#'
#' @param Emean Empirical mean
#'
#' @param Evar Empirical variance
#' 
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#' 
#' @return RP Vector of two elements, first contains method of moments 
#' estimator for r and second contains 
#'  method of moments estimator for p (parameters of NB distribution)
#'   

calcRP <- function(Emean, Evar){
  RP <- rep(NA,2)
  RP[1]=max(0.01,(Emean)^2/(Evar-Emean));
  RP[2]=max(0.01,1-Emean/Evar);
  if((RP[1]==0.01)&(RP[2]==0.01))
  {
    RP[1]=1
    RP[2]=0.5
  }
  RP[2]=min(RP[2],0.99999999)
  return(RP)
}


#' calcMV
#'
#'  Calculate empirical means and variances of selected genes in a given 
#'  dataset.
#'  
#' @details Calculate empirical means and variances of selected genes in a 
#' given dataset. Optionally, multiply
#'  the means and standard deviations by a fold change value, which can also 
#'  vary by mean value.  If the mean is
#'  below some specified threshold \code{threshold}, use one fold change value 
#'  \code{FC}.  If above the threshold, use the alternate 
#'  fold change value \code{FC.thresh}.  Estimates of mean and variance are 
#'  robust to outliers.
#'
#' @param a Numeric vector of values to calculate empirical mean and variance.
#'
#' @param FC Fold change for the mean and standard deviation.  Default value 
#' is 1.
#' 
#' @param FC.thresh Alternate fold change for the mean and standard deviation 
#' when the (log nonzero) mean is above the value of \code{threshold}.  
#'  Default value is \code{FC}.
#' 
#' @param threshold Mean threshold value which dictates which fold change value
#'  to use for multiplying mean and standard deviation.
#'  Default value is Inf (so \code{FC} is always used).
#'  
#' @param include.zeroes Logical value indicating whether the zero values 
#' should be included in the calculations of the empirical means 
#'    and variances.
#' 
#' @return MV Vector of two elements, first contains the empirical mean 
#' estimate, second contains the empirical variance estimate (optionally 
#'   multiplied by a fold change).
#'   

calcMV <- function(a, FC=1, FC.thresh=NA, threshold=Inf, include.zeroes=FALSE){
  MV <- rep(NA, 2)
  if(outliers::grubbs.test(log(a+1))$p.value<0.01){
    a <- a[-which.max(a)]
  }
  
  if(!include.zeroes){
    a <- a[a!=0]
  }
  
  if (mean(log(a[a!=0])) < threshold){
    MV[1] <- mean(a)*FC
    MV[2] <- var(a)*FC^2
  }else{
    if (is.na(FC.thresh)){stop("Please specify valid value for alternate fold 
                               change FC.thresh!")}
    MV[1] <- mean(a)*FC.thresh
    MV[2] <- var(a)*FC.thresh^2
  }
  return(MV)
}

#' singleCellSimu
#'
#' Called by \code{\link{simulateSet}} to simulate a specified number of genes 
#' from 
#'   one DD category at a time.
#' 
#'
#'
#' @param Dataset1 Numeric matrix of expression values with genes in rows and 
#' samples in columns.
#'
#' @param Method Type of simulation should choose from "DE" "DP" "DM" "DB"
#'
#' @param index Reasonable set of genes for simulation
#'
#' @param FC Fold Change values for DE Simulation
#'
#' @param DP Differetial Proportion vector
#' 
#' @param modeFC Vector of values to use for fold changes between modes for DP,
#'  DM, and DB.
#'
#' @param Validation Show Validation plots or not
#' 
#' @param numGenes numeric value for the number of genes to simulate
#'
#' @param numDE numeric value for the number of genes that will differ between
#'  two conditions
#'  
#' @param generateZero Specification of how to generate the zero values.  
#' If "\code{empirical}" (default), the
#'  observed proportion of zeroes in each gene is used for the simuated data, 
#'  and the nonzeroes are simulated from a 
#'  truncated negative binomial distribution.  If "\code{simulated}", all 
#'  values are simulated out of
#'  a negative binomial distribution, includling the zeroes.  
#'  If "\code{constant}", then each gene has a fixed 
#'  proportion of zeroes equal to \code{constantZero}.
#'  
#' @param constantZero Numeric value between 0 and 1 that indicates the fixed 
#' proportion of zeroes for every gene.
#'  Ignored if \code{generateZero} method is not equal to "\code{constant}". 
#' 
#' @param numSamples numeric value for the number of samples in each condition 
#' to simulate
#' 
#' @param varInflation Optional numeric vector with one element for each 
#' condition that corresponds to the multiplicative 
#'  variance inflation factor to use when simulating data.  Useful for 
#'  sensitivity studies to assess the impact of 
#'  confounding effects on differential variance across conditions. Currently 
#'  assumes all samples within a 
#'  condition are subject to the same variance inflation factor.
#' 
#' @importFrom outliers grubbs.test
#'
#' @return Simulated_Data A list object where the first element contains a 
#' matrix of 
#' the simulated dataset, the second element contains the DEIndex, and the 
#' third 
#' element contains the fold change (between two conditions for DE, between 
#' two modes 
#' for DP, DM, and DB).

singleCellSimu <- function(Dataset1, Method, index, FC, modeFC, DP, 
                          Validation=FALSE, 
                          numGenes=1000, numDE=100, numSamples=100, 
                          generateZero=c("empirical", "simulated", "constant"),
                          constantZero=NULL, varInflation=NULL){
if(!is.null(varInflation)){
  if(!length(varInflation)==2){
    stop("Error: varInflation vector needs to contain one factor for each 
         sample or one factor for each condition")
  }
}
    
if(length(generateZero)>1){
  generateZero <- generateZero[1]
}
### Select numGenes genes from index
samplename <- sort(sample(index,numGenes,replace=TRUE))

FC2 <- rep(1,nrow=numGenes)

f <- sample(c(rep(modeFC, ceiling(numGenes/length(modeFC)))), numGenes, 
            replace=FALSE)
for(i in 1:numGenes){
  a <- as.numeric(Dataset1[samplename[i],])
  FC2[i] <- exp(f[i]*sqrt(log(1+var(a[a!=0])/mean(a[a!=0])^2)))
}

### Calculate means and variances for these genes
Zeropercent_Base <- as.matrix(apply(Dataset1[samplename,,drop=FALSE], 1, 
                                    function(a) length(which(a == 0)) / 
                                      length(a)))           
MV <- matrix(data = 0,nrow = numGenes,ncol = 4)
if(Method %in%  c("DP", "DM")){
  MV[,1:2] <- t(sapply(1:length(samplename), function(x) 
    calcMV(Dataset1[samplename[x],], FC=1, FC.thresh=FC2[x]^(-1/2), 
           threshold = 3, include.zeroes=FALSE)))
  MV[,3:4] <- t(sapply(1:length(samplename), function(x) 
    calcMV(Dataset1[samplename[x],], FC=1, FC.thresh=FC2[x]^(-1/2), 
           threshold = 3, include.zeroes=TRUE)))
}else{
  MV[,1:2] <- t(sapply(1:length(samplename), function(x) 
    calcMV(Dataset1[samplename[x],], FC=1, include.zeroes=FALSE)))
  MV[,3:4] <- t(sapply(1:length(samplename), function(x) 
    calcMV(Dataset1[samplename[x],], FC=1, include.zeroes=TRUE)))
}

### Calculate parameter R and P in NB distribution
if(generateZero %in% c("empirical", "constant")){
  RP <- t(apply(MV[,1:2,drop=FALSE], 1, function(x) calcRP(x[1], x[2])))
}else if (generateZero == "simulated"){
  RP <- t(apply(MV[,3:4,drop=FALSE], 1, function(x) calcRP(x[1], x[2])))
}else{
  stop("Error: Please specify a valid generateZero method!")
}

# if inflating the variance factor with varInflation, apply condition 1's 
#factor to this MV matrix
# and calculate the corresponding RP values
if(!is.null(varInflation)){
  MV.Infl1 <- MV
  MV.Infl1[,c(2,4)] <- MV[,c(2,4)]*varInflation[1] 
  
  MV.Infl2 <- MV
  MV.Infl2[,c(2,4)] <- MV[,c(2,4)]*varInflation[2] 
  
  if(generateZero %in% c("empirical", "constant")){
    RP <- cbind(RP, t(apply(MV.Infl1[,1:2,drop=FALSE], 1, 
                            function(x) calcRP(x[1], x[2]))))
    RP <- cbind(RP, t(apply(MV.Infl2[,1:2,drop=FALSE], 1, 
                            function(x) calcRP(x[1], x[2]))))
  }else if (generateZero == "simulated"){
    RP <- cbind(RP, t(apply(MV.Infl1[,3:4,drop=FALSE], 1, 
                            function(x) calcRP(x[1], x[2]))))
    RP <- cbind(RP, t(apply(MV.Infl2[,3:4,drop=FALSE], 1, 
                            function(x) calcRP(x[1], x[2]))))
  }
}


### Indentify the relationship between mean and variance
if(generateZero %in% c("empirical", "constant")){
  fit <- lm(log(MV[,2])~log(MV[,1]))
} else{
  fit <- lm(log(MV[,4])~log(MV[,3]))
}
coeff <- fit$coefficients


### Simulate data by the chosen method
Simulated_Data <- matrix(data=NA,nrow=numGenes,ncol=2*numSamples)
x <- 1:numGenes
DEIndex <- sample(x,numDE,replace=FALSE)
EEIndex <- x[!(x%in%DEIndex)]


if(Method=="DE")
{
	desim <- simuDE(Dataset1, Simulated_Data, DEIndex, samplename, 
	                Zeropercent_Base, f, FC, coeff, RP, modeFC,
	                generateZero, constantZero, varInflation)
	Simulated_Data <- desim[[1]]
  DE_FC <- desim[[2]]
} else if(Method=="DP"){
  dpsim <- simuDP(Dataset1, Simulated_Data, DEIndex, samplename, 
                  Zeropercent_Base, f, FC2, coeff, RP, modeFC, DP,
                  generateZero, constantZero, varInflation)
  Simulated_Data <- dpsim[[1]]
  DE_FC <- dpsim[[2]]
}else if(Method=="DM"){
  
  dmsim <- simuDM(Dataset1, Simulated_Data, DEIndex, samplename, 
                  Zeropercent_Base, f, FC2, coeff, RP, modeFC,
                  generateZero, constantZero, varInflation)
  Simulated_Data <- dmsim[[1]]
  DE_FC <- dmsim[[2]]
}else if(Method=="DB"){
  
  DBsim <- simuDB(Dataset1, Simulated_Data, DEIndex, samplename, 
                  Zeropercent_Base, f, FC2, coeff, RP, modeFC, DP,
                  generateZero, constantZero, varInflation)
  Simulated_Data <- DBsim[[1]]
  DE_FC <- DBsim[[2]]
}

if(Validation==TRUE){
  validation(MV, DEIndex, Zeropercent_Base, Simulated_Data, numGenes)
}
return(list(Simulated_Data, DEIndex, DE_FC))
}

#' Data: Toy example data list 
#'
#' Toy example data list (one item for each of two conditions) for 100 genes
#'  to illustrate how to use the function
#'  \code{\link{preprocess}}.  
#'
#' @name scDatExList
#'
#' @docType data
#'
#' @usage data(scDatExList)
#'
#' @format A list of two matrices (one for each of two conditions) labeled 
#' "C1" and "C2".  Each matrix contains data for 100 genes
#'   and a variable number of samples (78 in C1 and 64 in C2).
#'   
#' @return An RData object, see Format section for details
#'   
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'
#' @keywords datasets
#'
#' @examples 
#' 
#' # load toy example data list 
#' data(scDatExList)
#'
NULL


#' Data: Toy example data
#'
#' Toy example data in \code{SingleCellExperiment} format for 500 
#' genes to illustrate how to generate simulated data from example data
#'  using \code{\link{simulateSet}}.  
#'
#' @name scDatEx
#'
#' @docType data
#'
#' @usage data(scDatEx)
#'
#' @format An object of class \code{SingleCellExperiment} containing
#'  data for 500 genes for 142 samples
#'  (78 from condition 1 and 64 from condition 2).  Condition labels (1 or 2)
#'   are stored in the colData slot. The assays slot contains both normcounts
#'   and counts for illustration, but these objects are identical.
#' 
#' @return An RData object, see Format section for details
#'   
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}   
#'
#' @keywords datasets
#'
#' @examples 
#' 
#' # load toy example data 
#' data(scDatEx) 
NULL


#' Data: Toy example of simulated data
#'
#' Toy example data in \code{SingleCellExperiment} format for 500 
#' genes to illustrate how to generate simulated data from example data
#'  using \code{\link{simulateSet}}.  Contains 5 genes from each category 
#'  (DE, DP, DM, DB, EE, and EP).
#'
#' @name scDatExSim
#'
#' @docType data
#'
#' @usage data(scDatExSim)
#'
#' @format An object of class \code{SingleCellExperiment} containing 
#' data for 30 genes for 200 samples
#'  (100 from condition 1 and 100 from condition 2).  Condition labels (1 or 2)
#'   are stored in the colData slot.  
#'  Row names of the assayData slot contain the two letter category label that
#'   the gene was simulated from (e.g.  'EE', 'DB', ...)
#'  along with the row number (1-30).
#'    
#' @return An RData object, see Format section for details
#'     
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'
#' @keywords datasets
#'
#' @examples 
#' 
#' # load toy example of simulated data
#' data(scDatExSim)
NULL

#' mclustRestricted
#'
#' Function to determine how many normal mixture components are present.
#' 
#' @details Robust to detecting multiple components that are close together 
#' by enforcing that the distance between two clusters 
#'  of appreciable size (at least 4 samples), have sufficiently high bimodal 
#'  index (cluster mean difference standardized by average
#'  standard deviation and multiplied by a balance factor which is one when 
#'  clusters are perfectly balanced) and not have variances
#'  that differ by more than a ratio of 20. Bimodal index threshold is 
#'  dependent on sample size to ensure consistent performance
#'  in power and type I error of detection of multiple components. 
#' 
#' @param y Numeric vector of values to fit to a normal mixture model with 
#' Mclust.
#' 
#' @param restrict Logical indicating whether or not to enforce the restriction
#'  on cluster separation based on bimodal index
#'   and ratio of largest to smallest variance (see details).  If False, 
#'   then Mclust results as is are returned.
#'   
#' @param min.size a positive integer that specifies the minimum size of a 
#' cluster (number of cells) for it to be used
#'  during the classification step. A clustering with all clusters of 
#'  size less than \code{min.size} is not valid and clusters will be merged if 
#'  this happens.
#'   
#' @importFrom mclust Mclust
#' 
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222.
#'  \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#'  1077-y}
#' 
#' @return List object with (1) vector of cluster membership, 
#' (2) cluster means, (3) cluster variances, (4) number of model parameters,
#'  (5) sample size, (6) BIC of selected model, and 
#'  (6) loglikelihood of selected model. 
#' 



mclustRestricted <- function(y, restrict=TRUE, min.size){
  # add runif(-0.1,0.1) jitter if all y vals are identical
  if (length(unique(y))==1){
    y <- y + runif(length(y), -0.1, 0.1)
  }
  
  mc <- suppressWarnings(Mclust(y, warn=FALSE, modelNames=c("V"), G=1:5, 
                                verbose=FALSE))	
  cl <- mc$classification
  comps <- mc$G
  
  if(comps > length(unique(cl))){
    mc <- suppressWarnings(Mclust(y, warn=FALSE, 
                                  modelNames=c("V"), G=1:(comps-1),
                                  verbose=FALSE))
    cl <- mc$classification
    comps <- mc$G
  }
  
  # Bimodal index threshold for removing a component (minimum of 1.6, 
  # increases with sample size and levels off at 2.2)
  remThresh <- 1/(1+exp(-length(y)/60+0.4)) + 1.2
  
  # Bimodal index threshold for keeping an added component (maximum of 4.0,
  # but is 3.6 at sample size 50
  # increases with sample size and levels off at 3.4
  addThresh <- 1/(1+exp(length(y)/9-4.5)) + 3.4
  
  if (restrict) { 
    if (comps > 1){
      compmeans <- mc$parameters$mean
      meandiff <- diff(compmeans)/max(sqrt(mc$parameters$variance$sigmasq))
      
      max.cl <- which.max(mc$parameters$variance$sigmasq)
      min.cl <- which.min(mc$parameters$variance$sigmasq)
      vardiff <- mc$parameters$variance$sigmasq[max.cl] / 
        mc$parameters$variance$sigmasq[min.cl]
      nmin <- table(cl)[min.cl]
      mincat <- min(table(cl))
      tries <- 0	
      nmax <- table(cl)[max.cl]
      balance <- 2*sqrt(nmin*nmax/(nmin+nmax)^2)
      meandiff <- meandiff*balance
      
      # Error handling checks
      if (length(vardiff)==0){
        vardiff <- 1
      }else if(sum(is.na(vardiff))>0){
        vardiff <- 1
      }
      if (length(nmin)==0){
        nmin <- Inf
      }else if(is.na(nmin)){
        nmin <- Inf
      }
      if (length(meandiff)==0){
        meandiff <- Inf
      }else if(sum(is.na(meandiff))>0){
        meandiff <- Inf
      }
      if (length(mincat)==0){
        mincat <- 1
      }else if(is.na(mincat)){
        mincat <- 1
      }
      
      err <- 0
      # enforce that clusters have to be have sufficient bimodal index -
      # if not, decrease possible components by 1 and refit
      while( (min(meandiff) < remThresh | (vardiff > 20)) & mincat>2 
             & tries <=4 & sum(is.na(mc$class))==0 & err==0){
         err <- 0
        comps_old <- comps
        comps <- comps-1 
        mc <- suppressWarnings(Mclust(y, warn=FALSE, 
                                      modelNames=c("V"), G=1:comps,
                                      verbose=FALSE))
        cl <- mc$classification
        comps <- mc$G
        mincat <- min(table(cl))
        
        tries <- tries + 1
        if (comps > 1 & comps_old-comps==1){
          compmeans <- as.numeric(by(y, cl, mean))
          meandiff <- diff(compmeans)/max(sqrt(mc$parameters$variance$sigmasq))
          balance <- 2*sqrt(nmin*nmax/(nmin+nmax)^2)
          meandiff <- meandiff*balance
          
          max.cl <- which.max(mc$parameters$variance$sigmasq)
          min.cl <- which.min(mc$parameters$variance$sigmasq)
          vardiff <- mc$parameters$variance$sigmasq[max.cl] / 
            mc$parameters$variance$sigmasq[min.cl]
          nmin <- table(cl)[min.cl]
        }else{
          meandiff <- 10
          vardiff <- -Inf
          nmin <- 100
        }
        
        # check for errors in new fit
        if (length(vardiff)==0){
          vardiff <- 1
          err <- 1
        }else if(sum(is.na(vardiff))>0){
          vardiff <- 1
          err <- 1
        }
        if (length(nmin)==0){
          nmin <- Inf
          err <- 1
        }else if(is.na(nmin)){
          nmin <- Inf
          err <- 1
        }
        if (length(meandiff)==0){
          meandiff <- Inf
          err <- 1
        }else if(sum(is.na(meandiff))>0){
          meandiff <- Inf
          err <- 1
        }
        if (length(mincat)==0){
          mincat <- 1
          err <- 1
        }else if(is.na(mincat)){
          mincat <- 1
          err <- 1
        }
        
        # if fit resulted in any errors, revert to previous fit
        if (err == 1){
          comps <- comps+1 
          mc <- suppressWarnings(Mclust(y, warn=FALSE, 
                                        modelNames=c("V"), G=1:comps,
                                        verbose=FALSE))
          cl <- mc$classification
          comps <- mc$G
        }
        
      }
    }else{  # check whether to add a component if only identified one
      comps_old <- comps
      comps <- comps+1 
      mc <- tryCatch({suppressWarnings(Mclust(y, warn=FALSE, 
                                              modelNames=c("V"), G=comps,
                                              verbose=FALSE))},
                      error = function(e) {return(NULL)})
      cl <- mc$classification
      
      if(!is.null(mc) & length(unique(cl))==comps){ 
        mincat <- min(table(cl)) 
        compmeans <- mc$parameters$mean
        meandiff <- diff(compmeans)/max(sqrt(mc$parameters$variance$sigmasq))
        
        max.cl <- which.max(mc$parameters$variance$sigmasq)
        min.cl <- which.min(mc$parameters$variance$sigmasq)
        vardiff <- mc$parameters$variance$sigmasq[max.cl] / 
          mc$parameters$variance$sigmasq[min.cl]
        nmin <- table(cl)[min.cl]
        mincat <- min(table(cl))
        tries <- 0	
        nmax <- table(cl)[max.cl]
        balance <- 2*sqrt(nmin*nmax/(nmin+nmax)^2)
        meandiff <- meandiff*balance
        
        if(!((min(meandiff) > addThresh & (vardiff < 10)) & mincat>2)){
          mc <- suppressWarnings(Mclust(y, warn=FALSE, 
                                        modelNames=c("V"), G=comps_old,
                                        verbose=FALSE))
          cl <- mc$classification
          comps <- mc$G
        }
      }else{ # couldn't fit requested model; revert to previous fit
        mc <- suppressWarnings(Mclust(y, warn=FALSE, 
                                      modelNames=c("V"), G=comps_old,
                                      verbose=FALSE))
        cl <- mc$classification
        comps <- mc$G
      }
    }
  }
  
  # if more than one cluster, and all clusters have less than min.size,
  # merge clusters together
  if (comps > 1 & max(table(cl)) < min.size){
    comps <- comps-1 
    mc <- suppressWarnings(Mclust(y, warn=FALSE, 
                                  modelNames=c("V"), G=1:comps,
                                  verbose=FALSE))
    cl <- mc$classification
    comps <- mc$G
  }
  
  # enforce clusters to have increasing means
  cl2 <- cl
  clust.order <- 1
  if (comps > 1){
    clust.order <- order(mc$parameters$mean)
    nms.clust <- names(mc$parameters$mean[clust.order])
    for (i in 1:comps){
      cl2[cl==i] <- as.numeric(nms.clust[i])
    }
  }
  return(list(class=cl2, mean=mc$parameters$mean[clust.order], 
              var=mc$parameters$variance$sigmasq[clust.order], 
              df=mc$df, n=mc$n, bic=mc$bic, loglik=mc$loglik, 
              model=mc$modelName))
}

#' getPosteriorParams
#' 
#' Given the observations for a single gene and its clustering information, 
#' return the calculated posterior parameters
#' 
#' @inheritParams jointPosterior
#' 
#' @return A list of posterior parameter values under the DP mixture model 
#' framework, given the data and prior parameter values.
#' 
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#' 

getPosteriorParams <- function(y, mcobj, alpha, m0, s0, a0, b0){
  
  r <- length(unique(mcobj$class))
  nk <- NULL
  sumyk <- NULL
  sumyk2 <- NULL
  for (k in 1:r){ 
    nk <- c(nk, sum(mcobj$class==k)) 
    sumyk <- c(sumyk, sum(y[mcobj$class==k]))
    sumyk2 <- c(sumyk2, sum(y[mcobj$class==k]^2))
  }
  
  sk <- s0 + nk
  mk <- (s0*m0 + sumyk) / sk
  ak <- a0 + nk
  bk <- b0 + sumyk2 + s0*m0^2 - sk*mk^2
  
  return(list(mk=mk, sk=sk, ak=ak, bk=bk))
}

#' classifyDD
#'
#' Classify significantly DD genes into the four categories (DE, DP, DM or DB)
#'  based on posterior distributions of cluster mean parameters
#'
#' @inheritParams jointPosterior
#' 
#' @inheritParams scDD
#' 
#' @param pe_mat Matrix with genes in rows and samples in columns.  
#' Column names indicate condition.
#'
#' @param condition Vector of condition indicators (with two possible values).
#' 
#' @param sig_genes Vector of the indices of significantly DD genes 
#' (indicating the row number of \code{pe_mat})
#'  
#' @param oa List item with one item for each gene where the first element 
#' contains the cluster membership for 
#'  each nonzero sample in the overall (pooled) fit.
#'
#' @param c1 List item with one item for each gene where the first element 
#' contains the cluster membership for 
#'  each nonzero sample in condition 1 only fit
#'  
#' @param c2 List item with one item for each gene where the first element 
#' contains the cluster membership for 
#'  each nonzero sample in condition 2 only fit
#'  
#' @param log.nonzero Logical indicating whether to perform log 
#' transformation of nonzero values.
#'
#' @param ref one of two possible values in condition; 
#' represents the referent category.
#' 
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'
#' @return cat Character vector of the same length as \code{sig_genes} that 
#' indicates which category of 
#'  DD each significant gene belongs to (DE, DP, DM, DB, or NC (no call))
#' 

classifyDD <- function(pe_mat, condition, sig_genes, oa, c1, c2, 
                       alpha, m0, s0, a0, b0, log.nonzero=TRUE, 
                      adjust.perms=FALSE, ref, min.size=3){
    ms <- min.size
    mc.oa <- oa
    mc.c1 <- c1
    mc.c2 <- c2
    
    oa <- lapply(oa, function(x) x[[1]])
    c1 <- lapply(c1, function(x) x[[1]])
    c2 <- lapply(c2, function(x) x[[1]])
    
    c.oa <- sapply(sig_genes, function(x) luOutlier(oa[[x]], min.size=ms))
    c.c1 <- sapply(sig_genes, function(x) luOutlier(c1[[x]], min.size=ms))
    c.c2 <- sapply(sig_genes, function(x) luOutlier(c2[[x]], min.size=ms))
    
    cdr <- apply(pe_mat, 2, function(x) sum(x>0)/length(x))
    
    # for each gene
    cat <- rep(NA, length(sig_genes))
    
    s <- 1
    for (g in sig_genes){
      
      y <- pe_mat[g,]
      
      if (log.nonzero){
        cond <- condition[y>0]
        cdr0 <- cdr[y>0]
        y <- log(y[y>0])
      }else{
        cond <- condition
        cdr0 <- cdr
      }
      
      if(length(unique(c1[[g]])) != max(c1[[g]])){
        missing.label <- which(! ((1:max(c1[[g]]) %in% unique(c1[[g]])) ))
        new.labels <- c1[[g]]
        for (l in (missing.label+1):max(c1[[g]])){
          new.labels[new.labels==l] <- l-1
        }		
        c1[[g]] <- new.labels
        mc.c1[[g]]$class <- c1[[g]]
        mc.c1[[g]]$mean <- mc.c1[[g]]$mean[-missing.label]
        mc.c1[[g]]$var <- mc.c1[[g]]$var[-missing.label]
      }
      if(length(unique(c2[[g]])) != max(c2[[g]])){
        missing.label <- which(! ((1:max(c2[[g]]) %in% unique(c2[[g]])) ))
        new.labels <- c2[[g]]
        for (l in (missing.label+1):max(c2[[g]])){
          new.labels[new.labels==l] <- l-1
        }		
        c2[[g]] <- new.labels
        mc.c2[[g]]$class <- c2[[g]]
        mc.c2[[g]]$mean <- mc.c2[[g]]$mean[-missing.label]
        mc.c2[[g]]$var <- mc.c2[[g]]$var[-missing.label]
      }
      if(length(unique(oa[[g]])) != max(oa[[g]])){
        missing.label <- which(! ((1:max(oa[[g]]) %in% unique(oa[[g]])) ))
        new.labels <- oa[[g]]
      for (l in (missing.label+1):max(oa[[g]])){
          new.labels[new.labels==l] <- l-1
      }		
        oa[[g]] <- new.labels
        mc.oa[[g]]$class <- oa[[g]]
        mc.oa[[g]]$mean <- mc.oa[[g]]$mean[-missing.label]
        mc.oa[[g]]$var <- mc.oa[[g]]$var[-missing.label]
      }
      
      
      
      params.c1 <- getPosteriorParams(y[cond==ref], mc.c1[[g]], 
                                      alpha, m0, s0, a0, b0)
      params.c2 <- getPosteriorParams(y[cond!=ref], mc.c2[[g]], 
                                      alpha, m0, s0, a0, b0)
      
      c.c1.no <- findOutliers(c1[[g]], min.size=ms)
      c.c2.no <- findOutliers(c2[[g]], min.size=ms)
      
      # posterior analysis of cluster distances
      num.comparisons <- length(c.c1.no)*length(c.c2.no)
      comparisons <- rep(NA, num.comparisons)
      
      t <- 1
      for (a in c.c1.no){
        for (b in c.c2.no){
          
            samp.diff <- quantile(rt(10000, df=round(params.c1$ak[a]))*
                                    sqrt(params.c1$bk[a]/
                                        (params.c1$ak[a]*params.c1$sk[a])) +
                                    params.c1$mk[a] - 
                                    rt(10000, df=round(params.c2$ak[b]))*
                                    sqrt(params.c2$bk[b]/(params.c2$ak[b]*
                                                        params.c2$sk[b])) 
                                  - params.c2$mk[b],
                                  c(0, 1))
            comparisons[t] <- 1*(  (0 < min(samp.diff) & 0 < max(samp.diff)) | 
                                  (-0 > min(samp.diff) & -0 > max(samp.diff)) )
          
          t <- t+1
        }
      }
      
      if (c.c1[s]==c.c2[s]){ # same number of clusters in each condition
        if (c.c1[s]==1){ # one cluster in each condition
            if (sum(comparisons)>0){
              cat[s] <- "DE"
            }else{
              cat[s] <- "NC"
            }
        }else{
          if (c.oa[s]==c.c1[s]){ # at least two clusters overall, same number 
                                 # within each condition as overall
            if (sum(comparisons)<=c.c1[s]){
              cat[s] <- "DP"
            }else{
              cat[s] <- "NC"
            }
          }else if(c.oa[s]>c.c1[s]){ # equal number of clusters within each 
                              #conditon (at least 2) and more than that overall
            if (sum(comparisons)> c.c1[s]*(c.c1[s]-1)){
              # Require that the multimodal DE genes show 
              # evidence of an overall shift in mean
              # in addition to having at most one pair of component overlaps
              if(adjust.perms){
                comparison <- summary(lm(y ~ cdr0 + factor(cond)))$coef[3,4]
              }else{
                comparison <- t.test(y~factor(cond))$p.value	
              }
              if (comparison < 0.01){
                cat[s] <- "DE"
              }else{
                cat[s] <- "NC"
              }
            }else{
              cat[s] <- "NC"
            }
          }else{
            cat[s] <- "NC"
          }
        }
      }else{ # not equal cluster number in each condition
        if (sum(comparisons)==length(comparisons)){
          cat[s] <- "DB"
        }else{
          cat[s] <- "DM"
        }
      }
      s <- s + 1
    }
    names(cat) <- names(sig_genes)
    return(cat)
  } 

#' testZeroes
#' 
#' Test for a difference in the proportion of zeroes between conditions 
#' for a specified set of genes
#' 
#' @details Test for a difference in the proportion of zeroes between 
#' conditions that is not explained by the 
#'   detection rate.  Utilizes Bayesian logistic regression.
#' 
#' @param dat Matrix of single cell expression data with genes in rows and 
#' samples in columns.  
#' 
#' @param cond Vector of condition labels
#' 
#' @param these vector of row numbers (gene numbers) to test for a difference
#'  in the proportion of zeroes.
#' 
#' @return Vector of FDR adjusted p-values
#' 
#'
#' @importFrom arm bayesglm  

testZeroes <- function(dat, cond, these=1:nrow(dat)){
  detection <- colSums(dat>0)/nrow(dat)
  
  onegene <- function(j, dat, detection, cond, these){
    y=dat[these[j],]
    if (sum(y==0) > 0){
      M1 <- suppressWarnings(arm::bayesglm(y>0 ~ detection + factor(cond), 
                                           family=binomial(link="logit"),
                                           Warning=FALSE))

      if (nrow(summary(M1)$coefficients) == 3) {
        return(summary(M1)$coefficients[3, 4])
      } else {
        return(NA)
      }
    }else{
      return(NA)
    }
  }
  
  pval <- unlist(bplapply(seq_along(these), onegene, dat=dat, 
                          detection=detection, cond=cond, these=these))
                      
  return(pval)
}

#' feDP
#'
#' Function to identify additional DP genes, since clustering process can be 
#' consistent within each condition 
#'   and still have differential proportion within each mode.  
#'   The Bayes factor score also tends to be small when
#'   the correct number of clusters is not correctly detected; 
#'   in that case differential proportion will manifest
#'   as a mean shift.
#'   
#' @details The Fisher's Exact test is used to test for independence of 
#' condition membership and clustering when 
#'   the clustering is the same across conditions as it is overall 
#'   (and is multimodal). When clustering within 
#'   condition is not multimodal or is different across conditions 
#'   (most often the case), an FDR-adjusted t-test
#'   is performed to detect overall mean shifts.
#'
#' @inheritParams classifyDD
#' 
#' @inheritParams scDD
#'
#' @return cat Character vector of the same length as \code{sig_genes} 
#' that indicates which nonsignificant genes by
#'  the permutation test belong to the DP category
#' 
feDP <- function(pe_mat, condition, sig_genes, oa, c1, c2, log.nonzero=TRUE, 
                 testZeroes=FALSE, adjust.perms=FALSE, min.size=3){
  if(testZeroes){
    pval.thresh <- 0.025
  }else{
    pval.thresh <- 0.05
  }
  
  oa <- lapply(oa, function(x) x[[1]])
  c1 <- lapply(c1, function(x) x[[1]])
  c2 <- lapply(c2, function(x) x[[1]])
  
  ns_genes <- (1:nrow(pe_mat))[-sig_genes]
  c.oa <- sapply(ns_genes, function(x) luOutlier(oa[[x]], min.size))
  c.c1 <- sapply(ns_genes, function(x) luOutlier(c1[[x]], min.size))
  c.c2 <- sapply(ns_genes, function(x) luOutlier(c2[[x]], min.size))
  
  cdr <- apply(pe_mat, 2, function(x) sum(x>0)/length(x))
  cat <- rep(NA, length(ns_genes))
  pval.ns <- rep(NA, length(ns_genes))
  s <- 1
  
  ref <- unique(condition)[1]
  
  for (g in ns_genes){
    y <- pe_mat[g,]
    cond <- condition[y>0]
    cdr0 <- cdr[y>0]
    y <- log(y[y>0])
    
    # add runif(-0.1,0.1) jitter if all y vals are identical
    if (length(unique(y[cond==ref]))==1 | length(unique(y[cond!=ref]))==1){
      y <- y + runif(length(y), -0.1, 0.1)
    }
    
    # detect shifts in mean (to catch DP genes with an incorrect # components)
    if(adjust.perms){
      pval.ns[s] <- summary(lm(y ~ cdr0 + factor(cond)))$coef[3,4]
    }else{
      pval.ns[s] <- t.test(y~factor(cond))$p.value	
    }
  
    # check whether clustering process is consistent within each
    # condition as overall
    if (c.c1[s]==c.c2[s] & c.c1[s]==c.oa[s] & c.oa[s]>1){
      # non-outlying cluster names
      c.oa.no <- findOutliers(oa[[g]], min.size)
      c.c1.no <- findOutliers(c1[[g]], min.size)
      c.c2.no <- findOutliers(c2[[g]], min.size)
      
      test <- 1*(fisher.test(table(oa[[g]][oa[[g]] %in% c.oa.no], 
                                   cond[oa[[g]] %in% c.oa.no]))$p.value < 0.05)
      if (test==1){
        cat[s] <- "DP"
      }else{
        cat[s] <- "NS"
      }
    }else{
      cat[s] <- "NS"
    }
  s <- s+1
  }
  
  pval.ns <- p.adjust(pval.ns, method="BH")
  cat[pval.ns < pval.thresh & cat != "DP"] <- "NC"
  cat[pval.ns < pval.thresh & c.c1 == c.c2 & c.c1 == c.oa & c.c1 > 1] <- "DP"			

  names(pval.ns) <- cat
  return(pval.ns)
}

#' results
#' 
#' extract results objects after running scDD analysis
#' 
#' @details Convenient helper function to extract the results (gene 
#' classifications, pvalues, and clustering information). Results 
#' data.frames/matrices are stored in the 
#' \code{metadata} slot and can also be accessed without the help of this 
#' convenience function by calling \code{metadata(SCdat)}.
#'   
#' @param SCdat An object of class \code{SingleCellExperiment} that contains 
#' normalized single-cell expression and metadata, and the output of the
#' \code{scDD} function.
#' 
#' @param type A character variable specifying which output is desired, 
#'  with possible values "Genes", "Zhat.c1", "Zhat.c2", and 
#'  "Zhat.overall".  The default value is "Genes", which contains a 
#'  a data frame with nine columns: 
#' gene name (matches rownames of SCdat), permutation p-value for testing of 
#' independence of 
#'  condition membership with clustering, Benjamini-Hochberg adjusted version 
#'  of the previous column, p-value for test of difference in dropout rate
#'   (only for non-DD genes), 
#'  Benjamini-Hochberg adjusted version of the previous column, name of the 
#'  DD (DE, DP, DM, DB) pattern or DZ (otherwise NS = not significant), the 
#'  number of clusters identified overall, the number of clusters identified in 
#'  condition 1 alone, and the number of clusters identified in condition 
#'  2 alone.
#'  
#'  If \code{type} is "Zhat.c1", then a \code{matrix} is returned
#'  that contains the fitted cluster memberships (partition estimates Z)
#'  for each sample (cluster number given by 1,2,3,...) in columns and
#'  gene in rows only for condition 1.  The same information is returned 
#'  only for condition 2, and for the overall clustering, when \code{type}
#'  is set to "Zhat.c2" or "Zhat.overall", respectively.  
#'   Zeroes, which are not involved in the clustering, are
#'   labeled as zero.    
#'   
#' @return A \code{data.frame} which contains either the gene classification 
#'  and p-value results, or cluster membership information, as detailed in the
#'  description of the \code{type} input parameter.
#'  
#' @export
#'  
#' @examples 
#'  
#' # load toy simulated example SingleCellExperiment object to find DD genes  
#' data(scDatExSim)
#' 
#' # set arguments to pass to scDD function
#' 
#' prior_param=list(alpha=0.01, mu0=0, s0=0.01, a0=0.01, b0=0.01)
#' 
#' # call the scDD function to perform permutations and classify DD genes
#' 
#' scDatExSim <- scDD(scDatExSim, prior_param=prior_param, testZeroes=FALSE)
#' 
#' # extract main results object
#' 
#' RES <- results(scDatExSim)

results <- function(SCdat, type=c("Genes", "Zhat.c1" , "Zhat.c2", 
                                  "Zhat.combined")){
  type <- match.arg(type)
  return(metadata(SCdat)[[type]])
}

#' sideViolin
#'
#' Plots two histograms side by side with smoothed density overlay
#'
#' 
#' @param y Numeric vector of data to plot.
#'
#' @param cond Vector of condition labels corresponding to elements of \code{x}.
#' 
#' @param MAP List of MAP partition estimates with conditions as list items and
#'  samples as elements 
#'  (integer indicating which cluster each observation belongs to; zeroes 
#'  belong to cluster 1)
#'
#' @param logT Logical that indicates whether to take the log(x+1)
#'  transformation.
#' 
#' @param title.gene Character vector that contains the gene name
#'  that you are plotting.
#' 
#' @param conditionLabels Character vector containing the names of
#'  the two conditions.
#' 
#' @param axes.titles Logical indicating whether or not to include
#'  axes labels on plots.  
#'  
#' @return ggplot object
#' 
#' @export
#' 
#' @import ggplot2
#'
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'
#' @examples 
#' 
#' # load toy simulated example ExpressionSet to find DD genes
#' 
#' data(scDatExSim)
#' 
#' 
#' # load SingleCellExperiment package to facilitate subset operations 
#' 
#' library(SingleCellExperiment)
#' 
#' 
#' # plot side by side violin plots for Gene 1 (DE)
#' 
#' sideViolin(normcounts(scDatExSim)[1,], scDatExSim$condition, 
#'            title.gene=rownames(scDatExSim)[1])
#' 
#' 
#' # plot side by side violin plots for Gene 6 (DP)
#' 
#' sideViolin(normcounts(scDatExSim)[6,], scDatExSim$condition, 
#'            title.gene=rownames(scDatExSim)[6])
#' 
#' 
#' # plot side by side violin plots for Gene 11 (DM)
#' 
#' sideViolin(normcounts(scDatExSim)[11,], scDatExSim$condition, 
#'            title.gene=rownames(scDatExSim)[11])
#' 
#' 
#' # plot side by side violin plots for Gene 16 (DB)
#' 
#' sideViolin(normcounts(scDatExSim)[16,], scDatExSim$condition, 
#'            title.gene=rownames(scDatExSim)[16])
#' 
#' # plot side by side violin plots for Gene 21 (EP)
#' 
#' sideViolin(normcounts(scDatExSim)[21,], scDatExSim$condition, 
#'            title.gene=rownames(scDatExSim)[21])
#' 
#' 
#' # plot side by side violin plots for Gene 26 (EE)
#' 
#' sideViolin(normcounts(scDatExSim)[26,], scDatExSim$condition, 
#'            title.gene=rownames(scDatExSim)[26])
#' 
#' 


sideViolin <- function(y, cond, MAP=NULL, logT=TRUE, title.gene="", 
                       conditionLabels=unique(cond), axes.titles=TRUE){
  ref <- unique(cond)[1]
  
  shps1 <- shps2 <- c("a", "c", "d", "e", "f")
  if(!is.null(MAP)){
    shps1 <- shps1[MAP[[1]] + 1]
    shps2 <- shps2[MAP[[2]] + 1]
  }else{
    shps1 <- rep(shps1[1], sum(cond==ref))
    shps2 <- rep(shps2[1], sum(cond!=ref))
  }
  
  if (logT){
    shps1[y[cond==ref]==0] <- "b"
    shps2[y[cond!=ref]==0] <- "b"
    y <- log(y+1)
  }
  
  if (length(conditionLabels)==2){
    cond[cond==ref] <- conditionLabels[1]
    cond[cond!=ref] <- conditionLabels[2]
  }
  
  if(axes.titles){
    xlabel <- ggplot2::element_text()
    ylabel <- ggplot2::element_text()
  }else{
    xlabel <- ylabel <- ggplot2::element_blank()
  }
  
  shps=c(shps1, shps2)
  daty <- data.frame(y, cond, shps)
  
  g <- ggplot(daty, aes(factor(cond), y), aes(shape=shps))
  g + geom_jitter(alpha=0.5, color="black", 
                  position = position_jitter(width = 0.15),
                      aes(shape=shps), show.legend=FALSE) +
    geom_violin(data=daty[daty$y>0, ], alpha=0.5, aes(fill=factor(cond)), 
                show.legend=FALSE, scale="count") + 
    theme_classic() +
    ggtitle(paste0(title.gene)) +
    theme(plot.title = element_text(size=20, face="bold", vjust=2)) + 
    labs(x="Condition", y="log(EC + 1)") +
    theme(axis.text.x=element_text(size=14, vjust=0.5), 
          axis.text.y=element_text(size=14, vjust=0.5), 
          axis.title.x = xlabel,
          axis.title.y = ylabel)
}

#' simulateSet
#'
#' Simulation of a complete dataset, where the number of each type of 
#' differential distributions and equivalent distributions is specified.
#'
#' @inheritParams singleCellSimu
#' 
#' @inheritParams scDD
#' 
#' @inheritParams findFC
#' 
#' @param nDE Number of DE genes to simulate
#' 
#' @param nDP Number of DP genes to simulate
#' 
#' @param nDM Number of DM genes to simulate
#' 
#' @param nDB Number of DB genes to simulate
#' 
#' @param nEE Number of EE genes to simulate
#' 
#' @param nEP Number of EP genes to simulate
#' 
#' @param plots Logical indicating whether or not to generate fold change and 
#' validation plots
#' 
#' @param random.seed Numeric value for a call to \code{set.seed} for 
#' reproducibility.
#' 
#' @param plot.file Character containing the file string if the plots are to be
#'  sent to a pdf instead of to the standard output.
#'  
#' @param param a \code{MulticoreParam} or \code{SnowParam} object of 
#' the \code{BiocParallel}
#' package that defines a parallel backend.  The default option is 
#' \code{BiocParallel::bpparam()} which will automatically creates a cluster 
#' appropriate for 
#' the operating system.  Alternatively, the user can specify the number
#' of cores they wish to use by first creating the corresponding 
#' \code{MulticoreParam} (for Linux-like OS) or \code{SnowParam} (for Windows)
#' object, and then passing it into the \code{scDD}
#' function. This could be done to specify a parallel backend on a Linux-like
#' OS with, say 12 
#' cores by setting \code{param=BiocParallel::MulticoreParam(workers=12)}
#' 
#' @inheritParams singleCellSimu
#' 
#' @inheritParams findIndex
#' 
#' @import SingleCellExperiment
#' 
#' @importFrom BiocParallel register
#' 
#' @import SingleCellExperiment
#' 
#' @export
#' 
#'
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'  
#' @return  An object of class \code{SingleCellExperiment} that contains 
#' simulated single-cell expression and metadata. The \code{assays} 
#'   slot contains a named list of matrices, where the simulated counts are 
#'   housed in the one named \code{normcounts}.  This matrix should have one
#'    row for each gene (\code{nDE + nDP + nDM + nDB + nEE
#'    + nEP} rows) and one sample for each column (\code{numSamples} columns).  
#'   The \code{colData} slot contains a data.frame with one row per 
#'   sample and a column that represents biological condition, which is 
#'   in the form of numeric values (either 1 or 2) that indicates which 
#'   condition each sample belongs to (in the same order as the columns of 
#'   \code{normcounts}). The \code{rowData} slot contains information about the
#'   category of the gene (EE, EP, DE, DM, DP, or DB), as well as the simulated
#'   foldchange value.
#' 
#' @examples 
#' 
#' # Load toy example ExpressionSet to simulate from
#' 
#' data(scDatEx)
#' 
#' 
#' # check that this object is a member of the ExpressionSet class
#' # and that it contains 142 samples and 500 genes
#' 
#' class(scDatEx)
#' show(scDatEx)
#' 
#' 
#' # set arguments to pass to simulateSet function
#' # we will simuate 30 genes total; 5 genes of each type;
#' # and 100 samples in each of two conditions
#' 
#' nDE <- 5
#' nDP <- 5
#' nDM <- 5
#' nDB <- 5
#' nEE <- 5
#' nEP <- 5
#' numSamples <- 100
#' seed <- 816
#' 
#' 
#' # create simulated set with specified numbers of DE, DP, DM, DM, EE, and 
#' # EP genes,
#' # specified number of samples, DE genes are 2 standard deviations apart, and 
#' # multimodal genes have modal distance of 4 standard deviations
#' 
#' SD <- simulateSet(scDatEx, numSamples=numSamples, nDE=nDE, nDP=nDP, nDM=nDM,
#'                   nDB=nDB, nEE=nEE, nEP=nEP, sd.range=c(2,2), modeFC=4, 
#'                   plots=FALSE, 
#'                   random.seed=seed)

simulateSet <- function(SCdat, numSamples=100, 
                         nDE=250, nDP=250, nDM=250, nDB=250, 
                         nEE=5000, nEP=4000, sd.range=c(1,3), modeFC=c(2,3,4), 
                         plots=TRUE, plot.file=NULL, random.seed=284,
                         varInflation=NULL, condition="condition",
                         param=bpparam()){
if(!is.null(plot.file)){
  pdf(file=paste0(plot.file))
}

# reference category/condition - the first listed one
ref <- unique(colData(SCdat)[[condition]])[1]  

message(paste0("Setting up parallel back-end using ", 
               param$workers, " cores" ))
BiocParallel::register(BPPARAM = param)
  
message("Identifying a set of genes to simulate from...")  
index <- findIndex(SCdat, condition)
message("Simulating DE fold changes...")  
FC <- findFC(SCdat, index, sd.range=sd.range, N=6, overExpressionProb = 0.5, 
             plot.FC=plots, condition)

constantZero <- NULL
generateZero <- "empirical"

message("Simulating individual genes...")

# pull off matrix of expression values for condition 1
Dataset1 <- normcounts(SCdat[,colData(SCdat)[[condition]]==ref])

set.seed(random.seed)

# initialize pe_mat and fcs
pe_mat <- NULL
fcs <- NULL

### DE
if (nDE > 0){
  SD1 <- singleCellSimu(Dataset1, Method = "DE", index, FC, modeFC, 
                        Validation = FALSE, numGenes=nDE, numDE=nDE,
                        numSamples=numSamples, generateZero=generateZero,
                        constantZero=constantZero, varInflation)
  Simulated_Data <- SD1[[1]]
  rnms <- rep("EE", nrow(Simulated_Data))
  rnms[SD1[[2]]] <- "DE"
  rownames(Simulated_Data) <- rnms
  pe_mat <- Simulated_Data
  fcs <- SD1[[3]]
}

### DP
if (nDP > 0){
  SD2 <- singleCellSimu(Dataset1, Method = "DP", index, FC, modeFC, 
                        DP = c(0.33,0.66), Validation = FALSE,
                        numGenes=nDP, numDE=nDP, numSamples=numSamples,
                        generateZero=generateZero, constantZero=constantZero, 
                        varInflation=varInflation)
  Simulated_Data_DP <- SD2[[1]]
  rnms <- rep("EE", nrow(Simulated_Data_DP))
  rnms[SD2[[2]]] <- "DP"
  rownames(Simulated_Data_DP) <- rnms
  pe_mat <- rbind(pe_mat, Simulated_Data_DP)
  fcs <- c(fcs, SD2[[3]])
}

### DM
if (nDM > 0){
  SD3 <- singleCellSimu(Dataset1, Method = "DM", index, FC, modeFC, 
                        Validation = FALSE,
                        numGenes=nDM, numDE=nDM, numSamples=numSamples, 
                        generateZero=generateZero, constantZero=constantZero, 
                        varInflation)
  Simulated_Data_DM <- SD3[[1]]
  rnms <- rep("EE", nrow(Simulated_Data_DM))
  rnms[SD3[[2]]] <- "DM"
  rownames(Simulated_Data_DM) <- rnms
  pe_mat <- rbind(pe_mat, Simulated_Data_DM)
  fcs <- c(fcs, SD3[[3]])
}

### DB
if (nDB > 0){
  SD4 <- singleCellSimu(Dataset1, Method = "DB", index, FC, modeFC, 
                        DP = c(0.5,0.5), Validation = FALSE,
                        numGenes=nDB, numDE=nDB, numSamples=numSamples, 
                        generateZero=generateZero, constantZero=constantZero, 
                        varInflation)
  Simulated_Data_DB <- SD4[[1]]
  rnms <- rep("EE", nrow(Simulated_Data_DB))
  rnms[SD4[[2]]] <- "DB"
  rownames(Simulated_Data_DB) <- rnms
  pe_mat <- rbind(pe_mat, Simulated_Data_DB)
  fcs <- c(fcs, SD4[[3]])
}

### EP
if (nEP > 0){
  SD5 <- singleCellSimu(Dataset1, Method = "DP", index, FC, modeFC, 
                        DP = c(0.50,0.50), Validation = FALSE,
                        numGenes=nEP, numDE=0, numSamples=numSamples, 
                        generateZero=generateZero, constantZero=constantZero, 
                        varInflation)
  Simulated_Data_EP <- SD5[[1]]
  rnms <- rep("EP", nrow(Simulated_Data_EP))
  rnms[SD5[[2]]] <- "DP"
  rownames(Simulated_Data_EP) <- rnms
  pe_mat <- rbind(pe_mat, Simulated_Data_EP)
  fcs <- c(fcs, SD5[[3]])
}

### EE
if (nEE > 0){
  SD6<- singleCellSimu(Dataset1, Method = "DE", index, FC, modeFC, 
                       Validation = plots, 
                       numGenes=nEE, numDE=0, numSamples=numSamples, 
                       generateZero=generateZero, constantZero=constantZero, 
                       varInflation=varInflation)
  Simulated_Data_EE <- SD6[[1]]
  rnms <- rep("EE", nrow(Simulated_Data_EE))
  rnms[SD6[[2]]] <- "DE"
  rownames(Simulated_Data_EE) <- rnms
  pe_mat <- rbind(pe_mat, Simulated_Data_EE)
  fcs <- c(fcs, rep(NA, nEE))
}

names(fcs) <- rownames(pe_mat)

if (nDE + nDP + nDM + nDB + nEE + nEP == 0){
  stop("Error: This function simulates gene expression data, but the number of
       genes to simulate was set to zero.  Please specify a nonzero number of 
       either DE, DP, DM, DB, EE, or EP genes.")
}

if (!is.null(plot.file)){
  dev.off()
}

# continuity correction
unifmat <- matrix(runif(nrow(pe_mat)*ncol(pe_mat)), nrow=nrow(pe_mat), 
                  ncol=ncol(pe_mat))
pe_mat2 <- pe_mat + unifmat
pe_mat2[pe_mat==0] <- 0

SD <- list(Simulated_Data=pe_mat2, FC=fcs)
condition <- c(rep(1, numSamples), rep(2, numSamples))
fcs <- data.frame(Category=names(fcs),
                  FC=as.numeric(fcs))
rownames(SD[[1]]) <- paste0(rownames(SD[[1]]), 1:nrow(SD[[1]]), sep="")
rownames(fcs) <- rownames(SD[[1]])
colnames(SD[[1]]) <- names(condition) <- paste0("Sample",
     1:ncol(SD[[1]]), sep="")
sce <- SingleCellExperiment(assays=list(normcounts=SD[[1]]), 
          colData=data.frame(condition),
          rowData=fcs)

message(paste0("Done! Simulated ", nDE, " DE, ", nDP, " DP, ", nDM, " DM, ",
               nDB, " DB, ", nEE, " EE, and ", nEP, " EP genes "))
return(sce)
}

#' sideHist
#'
#' Plots two histograms side by side with smoothed density overlay
#'
#' 
#' @param x First numeric vector of data to plot.
#'
#' @param y Second numeric vector of data to plot.
#'
#' @param logT Logical that indicates whether to take the log(x+1) 
#' transformation.
#' 
#' @param title.gene Character vector that contains the gene name that you 
#' are plotting
#' 
#' @return NULL (creates a baseR plot)
#'
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}

sideHist <- function(x, y, logT=TRUE, title.gene=""){

# grab some pretty ggplot colors
ggplotColours <- function(n=6, h=c(0, 360) +15){
  if ((diff(h)%%360) < 1) h[2] <- h[2] - 360/n
  hcl(h = (seq(h[1], h[2], length = n)), c = 100, l = 65)
}

valsA <- y
valsB <- x

if (logT){
  valsA <- log(valsA+1)
  valsB <- log(valsB+1)
}

binwidth <- 0.35
bin.points <- seq(range(c(valsA,valsB))[1]-0.5, 
                  range(c(valsA,valsB))[2]+0.5, by=binwidth)

A <- hist(valsA, breaks=bin.points, plot=FALSE)
B <- hist(valsB, breaks=bin.points, plot=FALSE)

gcol <- ggplotColours(2)

densrange <-  c(-max(c(B$density, A$density)), max(c(A$density, B$density)))

plot(NULL, type = "n", xlim = densrange,
     ylim = c(range(c(A$breaks, B$breaks))), ylab="log(EC + 1)", 
     xlab="density", xaxt="n",
     main = paste0("Gene ", title.gene))
axis(1, at=seq(-2,2,by=0.1), labels=abs(seq(-2,2,by=0.1)))
rect(0, A$breaks[1:(length(A$breaks) - 1)], A$density, 
     A$breaks[2:length(A$breaks)], col=gcol[1])
rect(0, B$breaks[1:(length(B$breaks) - 1)], -B$density, 
     B$breaks[2:length(B$breaks)], col=gcol[2])
lines(density(valsA, adjust=1.25)$y, 
      density(valsA, adjust=1.25)$x, col="darkgrey", lwd=2)
lines(-density(valsB, adjust=1.25)$y, 
      density(valsB, adjust=1.25)$x, col="darkgrey", lwd=2)

}

#' findIndex
#'
#' Find a reasonable set of genes (one mode and at least 25% nonzero values) 
#' to use for simulation.
#'  
#' @inheritParams scDD 
#' 
#' @import SingleCellExperiment
#'
#' @importFrom mclust Mclust mclustBIC
#' 
#' @importFrom BiocParallel bplapply
#' 
#' @importFrom BiocParallel MulticoreParam
#' 
#' @importFrom BiocParallel bpparam
#' 
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'
#' @return Vector of indices for a reasonable set of genes that can be used 
#' for simulation.


findIndex <- function(SCdat, condition="condition"){

# reference category/condition - the first listed one
ref <- unique(colData(SCdat)[[condition]])[1]
  
# separate ExpressionSet by condition  
Dataset1 <- SCdat[,colData(SCdat)[[condition]]==ref]
Dataset2 <- SCdat[,colData(SCdat)[[condition]]!=ref]
  
### Find zero-percent
zeropercent <- matrix(data=0, nrow=dim(Dataset1)[1], ncol=2)
rownames(zeropercent) <- rownames(Dataset1)
zeropercent[,1] <- apply(normcounts(Dataset1), 1, 
                         function(x) sum(x==0)/length(x))
zeropercent[,2] <- apply(normcounts(Dataset2), 1, 
                         function(x) sum(x==0)/length(x))

### log-transformation before Mclust
logdata1 <- t(apply(normcounts(Dataset1), 1, log))
logdata2 <- t(apply(normcounts(Dataset2), 1, log))
logdata1[logdata1==-Inf] <- 0
logdata2[logdata2==-Inf] <- 0
rownames(logdata1) <- rownames(logdata2) <- rownames(Dataset1)

### Select the genes with less than 75% expression values are 0 and with 1 mode
nonzeroindex <- which((zeropercent[,1]<0.75)&(zeropercent[,2]<0.75))
NumofMode <- matrix(data=0,
                    nrow=nrow(normcounts(Dataset1[nonzeroindex,])),ncol=2)
rownames(NumofMode) <- rownames(Dataset1)[nonzeroindex]

a <- logdata1[nonzeroindex, ]
b <- logdata2[nonzeroindex, ]

mcmat <- function(ROW, MAT){
  y <- MAT[ROW,]
  mclust::Mclust(y[y!=0])$G
}
NumofMode[,1] <- unlist(BiocParallel::bplapply(1:nrow(a), mcmat, MAT=a))
NumofMode[,2] <- unlist(BiocParallel::bplapply(1:nrow(b), mcmat, MAT=b))
  
onemodeindex <- which(NumofMode[,2]==1 & NumofMode[,1]==1)
index <- nonzeroindex[onemodeindex]
return(index)
}

#' simuDP
#'
#' Simulation for Differential Proportion Case
#'
#' @inheritParams singleCellSimu
#' @inheritParams simuDE
#'
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#' 
#' @return Simulated_Data Simulated dataset for DP


simuDP <- function(Dataset1, Simulated_Data, DEIndex, samplename, 
                   Zeropercent_Base, f, FC, coeff, RP, modeFC, DP,
                   generateZero, constantZero, varInflation){
 
  numGenes <- nrow(Simulated_Data)
  numSamples <- ncol(Simulated_Data)/2
  numDE <- length(DEIndex)

  # calculate means and variances with fold changes
  MVC2 <- matrix(data=0,nrow=numGenes,ncol=2)
  if(generateZero %in% c("empirical", "constant")){
    MVC2[,1:2] <- t(sapply(1:length(samplename), function(x) 
      calcMV(Dataset1[samplename[x],], FC=FC[x], FC.thresh=FC[x]^(1/2), 
             threshold = 3, include.zeroes=FALSE)))
  }else{
    MVC2[,1:2] <- t(sapply(1:length(samplename), function(x) 
      calcMV(Dataset1[samplename[x],], FC=FC[x], FC.thresh=FC[x]^(1/2), 
      threshold = 3, include.zeroes=TRUE)))
  }
  
  # calculate r and p parameters of NB
  RPC2 <- t(apply(MVC2[,1:2,drop=FALSE], 1, function(x) calcRP(x[1], x[2])))
  
  # calculate r and p parameters of inflated variance NB and 
  #add to the RPC2 matrix
  if(!is.null(varInflation)){
    MVC2.Infl1 <- MVC2
    MVC2.Infl1[,1] <- MVC2[,1]*
                          (1 + MVC2[,2]/(MVC2[,1]^2))^((varInflation[1]-1)/2) 
    MVC2.Infl1[,2] <- MVC2[,2]*
                ( ((1 + MVC2[,2]/(MVC2[,1]^2))^(2*varInflation[1])-
                (1 + MVC2[,2]/(MVC2[,1]^2))^varInflation[1]) / 
                ((1 + MVC2[,2]/(MVC2[,1]^2))^2-(1 + MVC2[,2]/(MVC2[,1]^2))) )
    
    MVC2.Infl2 <- MVC2
    MVC2.Infl2[,1] <- MVC2[,1]*
                          (1 + MVC2[,2]/(MVC2[,1]^2))^((varInflation[2]-1)/2) 
    MVC2.Infl2[,2] <- MVC2[,2]*
      ( ((1 + MVC2[,2]/(MVC2[,1]^2))^(2*varInflation[2])-
      (1 + MVC2[,2]/(MVC2[,1]^2))^varInflation[2]) / 
      ((1 + MVC2[,2]/(MVC2[,1]^2))^2-(1 + MVC2[,2]/(MVC2[,1]^2))) )
    
    RPC2 <- cbind(RPC2, t(apply(MVC2.Infl1[,1:2,drop=FALSE], 1, 
                                function(x) calcRP(x[1], x[2]))))
    RPC2 <- cbind(RPC2, t(apply(MVC2.Infl2[,1:2,drop=FALSE], 1, 
                                function(x) calcRP(x[1], x[2]))))
  }
  
  
  ### Simulate data in condition1
  for(i in 1:numGenes){
    dp <- DP
    flip <- as.logical(rbinom(1,1, 0.5))
    if(flip){
      dp <- rev(dp)
    }
    if(generateZero=="empirical"){
      p <- round(numSamples*(1-Zeropercent_Base[i,1]))
    } else if (generateZero=="constant"){
      p <- round((1-constantZero)*numSamples)
    }
    
    if(generateZero %in% c("empirical", "constant")){
      temp <- matrix(data=0,nrow=p,ncol=2)
      if(is.null(varInflation)){
        for(j in 1:p){
          while(temp[j,1]==0){temp[j,1] <- rnbinom(1,RP[i,1],1-RP[i,2])}
          while(temp[j,2]==0){temp[j,2] <- rnbinom(1,RPC2[i,1],1-RPC2[i,2])}
        }
      }else{
        for(j in 1:p){
          while(temp[j,1]==0){temp[j,1] <- rnbinom(1,RP[i,3],1-RP[i,4])}
          while(temp[j,2]==0){temp[j,2] <- rnbinom(1,RPC2[i,3],1-RPC2[i,4])}
        }
      }
      # place nonzeroes randomly
      n1 <- round(p*dp[1],digits=0)
      randp <- sample(1:numSamples, p, replace=FALSE)
      Simulated_Data[i,randp] <-  c(sample(temp[,1],n1,replace=FALSE), 
                                    sample(temp[,2],p-n1,replace=FALSE))
      if(p<numSamples){
        Simulated_Data[i,(1:numSamples)[-randp]] <-0
      }
    }else{
      temp <- matrix(data=0,nrow=numSamples,ncol=2)
      if(is.null(varInflation)){
        temp[,1] <- rnbinom(numSamples,RP[i,1],1-RP[i,2])
        temp[,2] <- rnbinom(numSamples,RPC2[i,1],1-RPC2[i,2])
      }else{
        temp[,1] <- rnbinom(numSamples,RP[i,3],1-RP[i,4])
        temp[,2] <- rnbinom(numSamples,RPC2[i,3],1-RPC2[i,4])
      }
  
      # sample from each mode
      n1 <- round(numSamples*dp[1],digits=0)
      Simulated_Data[i,1:numSamples] <-  c(sample(temp[,1],n1,replace=FALSE), 
                                sample(temp[,2],numSamples-n1,replace=FALSE))
    }
  
  ### Simulate for condition2
    if(generateZero=="empirical"){
      p <- round(numSamples*(1-Zeropercent_Base[i,1]))
    } else if (generateZero=="constant"){
      p <- round((1-constantZero)*numSamples)
    }
    
    if(generateZero %in% c("empirical", "constant")){  
      if(i%in%DEIndex){
       temp <- matrix(data=0,nrow=p,ncol=2)
       if(is.null(varInflation)){
          for(j in 1:p){
            while(temp[j,1]==0){temp[j,1] <- rnbinom(1,RP[i,1],1-RP[i,2])}
            while(temp[j,2]==0){temp[j,2] <- rnbinom(1,RPC2[i,1],1-RPC2[i,2])}
          }
       }else{
         for(j in 1:p){
           while(temp[j,1]==0){temp[j,1] <- rnbinom(1,RP[i,5],1-RP[i,6])}
           while(temp[j,2]==0){temp[j,2] <- rnbinom(1,RPC2[i,5],1-RPC2[i,6])}
         }
       }
        n1 <- round(p*dp[2],digits=0)
        randp <- sample(1:numSamples, p, replace=FALSE)
        Simulated_Data[i,numSamples+randp] <- c(sample(temp[,1],n1,
                                                       replace=FALSE), 
                                               sample(temp[,2],p-n1,
                                                      replace=FALSE))
        if(p<numSamples){
         Simulated_Data[i,((numSamples+1):(2*numSamples))[-randp]] <-0
        }
      }else{
        temp <- matrix(data=0,nrow=p,ncol=2)
        if(is.null(varInflation)){
          for(j in 1:p){
            while(temp[j,1]==0){temp[j,1] <- rnbinom(1,RP[i,1],1-RP[i,2])}
            while(temp[j,2]==0){temp[j,2] <- rnbinom(1,RPC2[i,1],1-RPC2[i,2])}
          }
        }else{
          for(j in 1:p){
            while(temp[j,1]==0){temp[j,1] <- rnbinom(1,RP[i,5],1-RP[i,6])}
            while(temp[j,2]==0){temp[j,2] <- rnbinom(1,RPC2[i,5],1-RPC2[i,6])}
          }
        }
        n1 <- round(p*dp[1],digits=0)
        randp <- sample(1:numSamples, p, replace=FALSE)
        Simulated_Data[i,numSamples+randp] <-  c(sample(temp[,1],n1,
                                                        replace=FALSE), 
                                                 sample(temp[,2],p-n1,
                                                        replace=FALSE))
        if(p<numSamples){
          Simulated_Data[i,((numSamples+1):(2*numSamples))[-randp]] <-0
        }
      }
    }else{
      if(i%in%DEIndex){
        temp <- matrix(data=0,nrow=numSamples,ncol=2)
        if(is.null(varInflation)){
          temp[,1] <- rnbinom(numSamples,RP[i,1],1-RP[i,2])
          temp[,2] <- rnbinom(numSamples,RPC2[i,1],1-RPC2[i,2])
        }else{
          temp[,1] <- rnbinom(numSamples,RP[i,5],1-RP[i,5])
          temp[,2] <- rnbinom(numSamples,RPC2[i,6],1-RPC2[i,6])
        }
        n1 <- round(numSamples*dp[2],digits=0)
        Simulated_Data[i,((numSamples+1):(2*numSamples))] <- c(sample(temp[,1],
                                        n1,replace=FALSE), 
                                        sample(temp[,2],
                                        numSamples-n1,replace=FALSE))
      }else{
        temp <- matrix(data=0,nrow=numSamples,ncol=2)
        if(is.null(varInflation)){
          temp[,1] <- rnbinom(numSamples,RP[i,1],1-RP[i,2])
          temp[,2] <- rnbinom(numSamples,RPC2[i,1],1-RPC2[i,2])
        }else{
          temp[,1] <- rnbinom(numSamples,RP[i,5],1-RP[i,6])
          temp[,2] <- rnbinom(numSamples,RPC2[i,5],1-RPC2[i,6]) 
        }
        n1 <- round(numSamples*dp[1],digits=0)
        Simulated_Data[i,((numSamples+1):(2*numSamples))] <- c(sample(temp[,1],
                                          n1,replace=FALSE), 
                                          sample(temp[,2],
                                          numSamples-n1,replace=FALSE))
      }
    }
  }
  return(list(Simulated_Data, f=f))
}

#' permMclustCov
#'
#' Function to  obtain bayes factor for permutations of one gene's residuals
#' 
#' @details Obtains bayes factor numerator for data vector \code{y} 
#' representing one gene 
#' 
#' @param y Numeric data vector for one gene
#' 
#' @inheritParams jointPosterior 
#' 
#' @inheritParams scDD
#' 
#' @param nperms Number of permutations of residuals to evaulate
#' 
#' @param condition Vector of condition indicators for each sample
#' 
#' @param C Matrix of confounder variables, where there is one row for each
#'  sample and one column for each covariate.
#' 
#' @param remove.zeroes Logical indicating whether zeroes need to be removed 
#' from \code{y}
#' 
#' @param log.transf Logical indicating whether the data is in the raw scale 
#' (if so, will be log-transformed)
#' 
#' @param restrict Logical indicating whether to perform restricted Mclust 
#' clustering where close-together clusters are joined.
#' 
#' @param ref one of two possible values in condition; represents the 
#' referent category.
#' 
#' @importFrom BiocParallel bplapply
#' 
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'
#' @return Bayes factor numerator for the current permutation

permMclustCov <- function(y, nperms, C, condition, remove.zeroes=TRUE, 
                          log.transf=TRUE, restrict=FALSE, 
                          alpha, m0, s0, a0, b0, ref, min.size){
  orig.y <- y
  
  if(remove.zeroes & log.transf){
    C <- C[y>0]
    cond <- condition[y>0]
    y <- log(y[y>0])
  }else if(log.transf){
    C <- C[y>0]
    cond <- condition
    y <- log(y)
  }else if(remove.zeroes){
    C <- C[y>0]
    cond <- condition[y>0]
    y <- y[y>0]
  }
  
  # fit reduced model
  X <- model.matrix(~ C)
  model <- lm(y ~ C)
  params <- summary(model)$coef[,1]
  
  
  getPerm <- function(model, X, params, orig.y, condition, restrict, 
                      remove.zeroes, log.transf){
    new.resid <- sample(residuals(model), replace=FALSE)
    new.y0 <- as.vector(exp(X %*% params + new.resid))
    new.y <- orig.y
    new.y[new.y > 0] <- new.y0
    
    y1 <- new.y[condition==ref]
    y2 <- new.y[condition!=ref]
    if(remove.zeroes & log.transf){
      y1 <- log(y1[y1>0])
      y2 <- log(y2[y2>0])
    }else if(log.transf){
      y1 <- log(y1)
      y2 <- log(y2)
    }else if(remove.zeroes){
      y1 <- y1[y1>0]
      y2 <- y2[y2>0]
    }
    
    oa <- mclustRestricted(c(y1,y2), restrict=restrict, min.size=min.size)
    c1 <- mclustRestricted(y1, restrict=restrict, min.size=min.size)
    c2 <- mclustRestricted(y2, restrict=restrict, min.size=min.size)
    
    bf.p <- jointPosterior(y1, c1, alpha, m0, s0, a0, b0) + 
      jointPosterior(y2, c2, alpha, m0, s0, a0, b0) -
      jointPosterior(c(y1,y2), oa, alpha, m0, s0, a0, b0)
    return(bf.p)
  }

  bf.p <- unlist(bplapply(1:nperms, function(x) 
    getPerm(model, X, params, orig.y, condition, 
            restrict, remove.zeroes, log.transf)))
  
  return(bf.p)
}


#' permMclust
#'
#' Function to  obtain bayes factor numerator for permutations of one gene
#' 
#' @details Obtains bayes factor numerator for data vector
#'  \code{y} representing one gene 
#' 
#' @inheritParams jointPosterior
#' 
#' @inheritParams scDD
#' 
#' @param y Numeric data vector for one gene
#' 
#' @param nperms Number of permutations of residuals to evaulate
#' 
#' @param condition Vector of condition indicators for each sample
#' 
#' @param remove.zeroes Logical indicating whether 
#' zeroes need to be removed from \code{y}
#' 
#' @param log.transf Logical indicating whether the data is 
#' in the raw scale (if so, will be log-transformed)
#' 
#' @param ref one of two possible values in condition; 
#' represents the referent category.
#' 
#' @param restrict Logical indicating whether to perform restricted Mclust
#'  clustering where close-together clusters are joined.
#' 
#' @importFrom BiocParallel bplapply
#' 
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R,
#'  Kendziorski C. A statistical approach for identifying differential 
#'  distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'
#' @return Bayes factor numerator for the current permutation

permMclust <- function(y, nperms, condition, remove.zeroes=TRUE, 
                       log.transf=TRUE, restrict=FALSE, 
                       alpha, m0, s0, a0, b0, ref, min.size){
  
  y.orig <- y
  
  getPerm <- function(y, condition, restrict, remove.zeroes, log.transf){
    if(remove.zeroes & log.transf){
      cond <- condition[y>0]
      y <- log(y[y>0])
    }else if(log.transf){
      cond <- condition
      y <- log(y)
    }else if(remove.zeroes){
      cond <- condition[y>0]
      y <- y[y>0]
    }
    new <- sample(1:length(y), replace=FALSE)
    new.y <- y[new]
    y1 <- new.y[cond==ref]
    y2 <- new.y[cond!=ref]
    
    c1 <- mclustRestricted(y1, restrict=restrict, min.size=min.size)
    c2 <- mclustRestricted(y2, restrict=restrict, min.size=min.size)
    
    bf.p <- jointPosterior(y1, c1, alpha, m0, s0, a0, b0) + 
      jointPosterior(y2, c2, alpha, m0, s0, a0, b0) 
    return(bf.p)
  }
  
  bf.p <- unlist(bplapply(1:nperms, function(x) 
    getPerm(y.orig, condition, restrict, remove.zeroes, log.transf)))
  
  return(bf.p)
}

#' permMclustGene
#'
#' Function to obtain bayes factor for all permutations of one gene 
#' (not parallelized; to be used when parallelizing over Genes)
#' 
#' @details Obtains bayes factor for data vector \code{y} representing one gene 
#' 
#' @param y Numeric data vector for one gene
#'
#' @param ref one of two possible values in condition;
#'  represents the referent category.
#' 
#' @inheritParams jointPosterior 
#' 
#' @inheritParams scDD
#' 
#' @inheritParams permMclustCov
#' 
#' @importFrom BiocParallel bplapply
#' 
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R,
#'  Kendziorski C. A statistical approach for identifying differential
#'   distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'
#' @return Bayes factor numerator for the current permutation
permMclustGene <- function(y, adjust.perms, nperms, condition, 
                           remove.zeroes=TRUE, log.transf=TRUE, restrict=TRUE, 
                           alpha, m0, s0, a0, b0, C, ref, min.size){
  orig.y <- y
  
  if(remove.zeroes & log.transf){
    C <- C[y>0]
    cond <- condition[y>0]
    y <- log(y[y>0])
  }else if(log.transf){
    C <- C[y>0]
    cond <- condition
    y <- log(y)
  }else if(remove.zeroes){
    C <- C[y>0]
    cond <- condition[y>0]
    y <- y[y>0]
  }
  
  if (adjust.perms){
    # fit reduced model
    X <- model.matrix(~ C)
    model <- lm(y ~ C)
    params <- summary(model)$coef[,1]
  }
  
  # for loop to go through all nperms permutations (not 
  # parallelized since this function is to be
  # used when there are multiple genes running at a time)
  bf.p <- rep(NA, nperms)
  for (b in 1:nperms){
    if (adjust.perms){
      new.resid <- sample(residuals(model), replace=FALSE)
      new.y0 <- as.vector(exp(X %*% params + new.resid))
      new.y <- orig.y
      new.y[new.y > 0] <- new.y0
      y1 <- new.y[condition==ref]
      y2 <- new.y[condition!=ref]
      
      if(remove.zeroes & log.transf){
        y1 <- log(y1[y1>0])
        y2 <- log(y2[y2>0])
      }else if(log.transf){
        y1 <- log(y1)
        y2 <- log(y2)
      }else if(remove.zeroes){
        y1 <- y1[y1>0]
        y2 <- y2[y2>0]
      }
      
      oa <- mclustRestricted(c(y1,y2), restrict=restrict, min.size=min.size)
      c1 <- mclustRestricted(y1, restrict=restrict, min.size=min.size)
      c2 <- mclustRestricted(y2, restrict=restrict, min.size=min.size)
      
      bf.p[b] <- jointPosterior(y1, c1, alpha, m0, s0, a0, b0) + 
                 jointPosterior(y2, c2, alpha, m0, s0, a0, b0) -
                 jointPosterior(c(y1,y2), oa, alpha, m0, s0, a0, b0)
    }else{
      # don't adjust permutations for covariates; don't 
      # need to calculate denominator
      # of BF since it will be the same in observed and permuted 
      # sets with no residual adjustment
      new <- sample(1:length(y), replace=FALSE)
      new.y <- y[new]
      y1 <- new.y[cond==ref]
      y2 <- new.y[cond!=ref]
      
      c1 <- mclustRestricted(y1, restrict=restrict, min.size=min.size)
      c2 <- mclustRestricted(y2, restrict=restrict, min.size=min.size)
      
      bf.p[b] <- jointPosterior(y1, c1, alpha, m0, s0, a0, b0) + 
                 jointPosterior(y2, c2, alpha, m0, s0, a0, b0) 
    }
  }
  return(bf.p)
}


#' permZero
#'
#' Function to generate random permutations of nonzero values.
#' 
#' @details Generates random permutations for all genes, where the zeroes are 
#' kept fixed (i.e. only permute the nonzero condition labels).
#' 
#' @param m Number of permuted sets to generate.
#' 
#' @param size Number of samples present in the dataset
#' 
#' @param zmat Matrix of indicators of whether the original data value is 
#' zero or not.  Should contain the 
#'   same number of rows and columns as original data matrix.
#' 
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'
#' @return a list of length 'm' (nperms) where each item is a 'ngenes' by 
#' 'size' matrix

permZero <- function(m, size, zmat) { # Obtain m unique combinations of 1:size
  
  # Function to obtain a new permutation.
  newperm <- function(zeroes) {
    # Generate a permutation
    p <- sample(1:(size-length(zeroes)))
    
    # put back into zero context
    newp <- (1:size)
    if (length(zeroes)>0){
      newp[-zeroes] <- newp[-zeroes][p]
      newp[zeroes] <- zeroes
    } else {
      newp <- newp[p]
    }
    newp                   # Return this (new) permutation
  }
  
  # Obtain m unique permutations.
  permlist <- vector("list", m)
  for (perms in 1:m){
    permlist[[perms]] <- t(apply(zmat, 1, function(x) 
      newperm(if (sum(x==1)>0){ which(x==1) }else{NULL})))
  } 
  return(permlist)
}
# Returns a list of length 'm' (nperms) where each 
# item is a 'ngenes' by 'size' matrix

#' validation
#'
#' Draw validation plots to show that the simulated dataset emulates 
#' characteristics of observed dataset.
#'
#' @inheritParams singleCellSimu
#'
#' @param MV Mean and Variance matrix for observed data
#'
#' @param DEIndex Index for genes chosen to be DE (can be NULL)
#'
#' @param Zeropercent_Base Zero percentage for corresponding gene expression 
#' values 
#'
#' @param Simulated_Data Simulated dataset
#' 
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'
#' @return Validation plots


validation <- function(MV, DEIndex, Zeropercent_Base, Simulated_Data, numGenes){
MV_Simu <- matrix(data=0,nrow=numGenes,ncol=4)

MV_Simu[,1]=apply(Simulated_Data, 1, function(x) mean(x[x!=0]))
MV_Simu[,2]=apply(Simulated_Data, 1, function(x) var(x[x!=0]))
MV_Simu[,3]=apply(Simulated_Data, 1, mean)
MV_Simu[,4]=apply(Simulated_Data, 1, var)

par(mfrow=c(1,1))
plot(MV[,1], MV[,2], log="xy", main="Mean-Variance Relationship", 
     xlab="Nonzero Mean", ylab="Nonzero Variance",
     pch=20, cex=0.75, col="darkgrey")


par(mfrow=c(2,2))
plot(MV[,1],MV_Simu[,1],log="xy",main="Nonzero Mean", xlab="Empirical", 
     ylab="Simulated",
     pch=20, cex=0.25, col="darkgrey")
abline(0,1,lty=2)
if(length(DEIndex>0)){ 
  points(MV[DEIndex,1],MV_Simu[DEIndex,1],col="red") 
}

plot(MV[,2],MV_Simu[,2],log="xy",main="Nonzero Variance", xlab="Empirical", 
     ylab="Simulated",
     pch=20, cex=0.25, col="darkgrey")
abline(0,1,lty=2)
if(length(DEIndex>0)){ 
  points(MV[DEIndex,2],MV_Simu[DEIndex,2],col="red")
}

plot(MV[,3],MV_Simu[,3],log="xy",main="Overall Mean", xlab="Empirical", 
     ylab="Simulated",
     pch=20, cex=0.25, col="darkgrey")
abline(0,1,lty=2)
if(length(DEIndex>0)){ 
  points(MV[DEIndex,3],MV_Simu[DEIndex,2],col="red") 
}

plot(MV[,4],MV_Simu[,4],log="xy",main="Overall Variance", xlab="Empirical", 
     ylab="Simulated",
     pch=20, cex=0.25, col="darkgrey")
abline(0,1,lty=2)
if(length(DEIndex>0)){ 
  points(MV[DEIndex,4],MV_Simu[DEIndex,4],col="red")
}

}

#' jointPosterior
#'
#' Function to obtain the normalized joint posterior of the data and partition. 
#' 
#' @details Calculates the normalized joint posterior of the data and partition
#'  under the Product Partition Model formulation
#'   of the Dirichlet Process Mixture model.
#' 
#' @param y Numeric data vector for one gene (log-transformed non-zeroes)
#' 
#' @param mcobj Object returned by \code{\link{mclustRestricted}}
#' 
#' @param alpha Value for the Dirichlet concentration parameter
#' 
#' @param m0 Prior mean value for generating distribution of cluster means
#' 
#' @param s0 Prior precision value for generating distribution of cluster means
#' 
#' @param a0 Prior shape parameter value for the generating distribution of 
#' cluster precision
#' 
#' @param b0 Prior scale parameter value for the generating distribution of 
#' cluster precision
#' 
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'
#' @return log joint posterior value


jointPosterior <- function(y, mcobj, alpha, m0, s0, a0, b0){
  
  r <- length(unique(mcobj$class))
  nk <- NULL
  sumyk <- NULL
  sumyk2 <- NULL
  for (k in 1:r){ 
    nk <- c(nk, sum(mcobj$class==k)) 
    sumyk <- c(sumyk, sum(y[mcobj$class==k]))
    sumyk2 <- c(sumyk2, sum(y[mcobj$class==k]^2))
  }
  
  sk <- s0 + nk
  mk <- (s0*m0 + sumyk) / sk
  ak <- a0 + nk
  bk <- b0 + sumyk2 + s0*m0^2 - sk*mk^2
  J <- sum(nk)
  
  
  # including prior for partition	
  logpost <- 0
  for (k in 1:r){ 
    logpost <- logpost + lgamma(nk[k]) + lgamma(ak[k]/2) - 
      (ak[k]/2)*log(bk[k]/2) - 0.5*log(sk[k]) 
  }
  logpost <- logpost + r*log(alpha) + lgamma(alpha) - J*lgamma(a0/2) + 
    (J*a0/2)*log(b0/2) + J*0.5*log(s0) - (J/2)*log(2*pi)- lgamma(alpha + J)
  
  return(logpost)
}

#' simuDB
#'
#' Simulation for Differential "Both" Case - both Differential
#'  Modality and Differential Mean
#'
#' @inheritParams singleCellSimu 
#' @inheritParams simuDE
#' 
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential
#'  distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'
#' @return Simulated_Data Simulated dataset for DB




simuDB <- function(Dataset1, Simulated_Data, DEIndex, samplename, 
                   Zeropercent_Base, f, FC, coeff, RP, modeFC, DP,
                     generateZero, constantZero, varInflation){
  
  numGenes <- nrow(Simulated_Data)
  numSamples <- ncol(Simulated_Data)/2
  numDE <- length(DEIndex)
  
  ### Simulate data for EE and condition 1 in DE first
  for(i in 1:numGenes){
    if(generateZero=="empirical"){
      p <- round(numSamples*(1-Zeropercent_Base[i,1]))
    } else if (generateZero=="constant"){
      p <- round((1-constantZero)*numSamples)
    }
    
    if(generateZero %in% c("empirical", "constant")){
      temp <- matrix(data=0,nrow=p,ncol=1)
      if(is.null(varInflation)){
        for(j in 1:p){
          while(temp[j]==0){temp[j] <- rnbinom(1,RP[i,1],1-RP[i,2])}
        }
      }else{
        for(j in 1:p){
          while(temp[j]==0){temp[j] <- rnbinom(1,RP[i,3],1-RP[i,4])}
        }
      }
      randp <- sample(1:numSamples, p, replace=FALSE)
      Simulated_Data[i,randp] <- temp
      if(p<numSamples){
        Simulated_Data[i,(1:numSamples)[-randp]] <-0
      }
    }else{
      if(is.null(varInflation)){
        Simulated_Data[i,1:numSamples] <- rnbinom(numSamples,RP[i,1],1-RP[i,2])
      }else{
        Simulated_Data[i,1:numSamples] <- rnbinom(numSamples,RP[i,3],1-RP[i,4])
      }
    }
  }
  
  
  cutoff <- -Inf  # optional cutoff to specify; 
                  # will influence direction of second mode

  # calculate means and variances with fold changes
  MVC2 <- matrix(data=0,nrow=numGenes,ncol=5)
  if(generateZero %in% c("empirical", "constant")){
    MVC2[,1:2] <- t(sapply(1:length(samplename), function(x) 
      calcMV(Dataset1[samplename[x],], FC=FC[x]^(1/2), FC.thresh=FC[x]^(-1/2), 
             threshold = cutoff, include.zeroes=FALSE)))
    MVC2[,3:4] <- t(sapply(1:length(samplename), function(x) 
      calcMV(Dataset1[samplename[x],], FC=FC[x], FC.thresh=FC[x]^(1/2), 
             threshold = cutoff, include.zeroes=FALSE)))
  }else{
    MVC2[,1:2] <- t(sapply(1:length(samplename), function(x) 
      calcMV(Dataset1[samplename[x],], FC=FC[x]^(1/2), FC.thresh=FC[x]^(-1/2), 
             threshold = cutoff, include.zeroes=TRUE)))
    MVC2[,3:4] <- t(sapply(1:length(samplename), function(x) 
      calcMV(Dataset1[samplename[x],], FC=FC[x], FC.thresh=FC[x]^(1/2), 
             threshold = cutoff, include.zeroes=TRUE)))
  }
  MVC2[,5] <- apply(Dataset1[samplename,,drop=FALSE], 1, 
                    function(x) sum(log(mean(x[x>0]))>=cutoff))
  
  
  # calculate r and p parameters of NB
  RPC2 <- cbind( t(apply(MVC2[,1:2,drop=FALSE], 1, function(x) 
    calcRP(x[1], x[2]))),
                 t(apply(MVC2[,3:4,drop=FALSE], 1, function(x) 
                   calcRP(x[1], x[2]))))
  
  # calculate r and p parameters of inflated variance NB
  # and add to the RPC2 matrix
  if(!is.null(varInflation)){
    MVC2.Infl1 <- MVC2
    MVC2.Infl1[,1] <- MVC2[,1]*(1 +
                                MVC2[,2]/(MVC2[,1]^2))^((varInflation[1]-1)/2) 
    MVC2.Infl1[,2] <- MVC2[,2]*( ((1 + 
                          MVC2[,2]/(MVC2[,1]^2))^(2*varInflation[1])-
                          (1 + MVC2[,2]/(MVC2[,1]^2))^varInflation[1]) / 
                          ((1 + MVC2[,2]/(MVC2[,1]^2))^2-(1 + MVC2[,2]/
                                                            (MVC2[,1]^2))) )
    
    MVC2.Infl2 <- MVC2
    MVC2.Infl2[,1] <- MVC2[,1]*(1 +
                                  MVC2[,2]/(MVC2[,1]^2))^((varInflation[2]-1)/2)
    MVC2.Infl2[,2] <- MVC2[,2]*( ((1 + 
                          MVC2[,2]/(MVC2[,1]^2))^(2*varInflation[2])-
                          (1 + MVC2[,2]/(MVC2[,1]^2))^varInflation[2]) / 
                          ((1 + MVC2[,2]/(MVC2[,1]^2))^2-(1 + MVC2[,2]/
                                                            (MVC2[,1]^2))) )
    
    RPC2 <- cbind(RPC2, cbind( t(apply(MVC2[,1:2,drop=FALSE], 1, function(x) 
                                 calcRP(x[1], x[2]))),
                               t(apply(MVC2[,3:4,drop=FALSE], 1, function(x) 
                                 calcRP(x[1], x[2])))))
    RPC2 <- cbind(RPC2, cbind( t(apply(MVC2[,1:2,drop=FALSE], 1, function(x) 
                                 calcRP(x[1], x[2]))),
                               t(apply(MVC2[,3:4,drop=FALSE], 1, function(x) 
                                 calcRP(x[1], x[2])))))
  }
  
  ### Simulate data in condition 1
  for(i in 1:numGenes){
    if(generateZero=="empirical"){
      p <- round(numSamples*(1-Zeropercent_Base[i,1]))
    } else if (generateZero=="constant"){
      p <- round((1-constantZero)*numSamples)
    }
    
    if(generateZero %in% c("empirical", "constant")){
      temp <- matrix(data=0,nrow=p,ncol=1)
      if(MVC2[i,5]==0){  # gene is below cutoff
        if(is.null(varInflation)){
          for(j in 1:p){
            while(temp[j]==0){temp[j] <- rnbinom(1,RPC2[i,1],1-RPC2[i,2])}
          }
        }else{
          for(j in 1:p){
            while(temp[j]==0){temp[j] <- rnbinom(1,RPC2[i,5],1-RPC2[i,6])}
          } 
        }
        randp <- sample(1:numSamples, p, replace=FALSE)
        Simulated_Data[i,randp] <- temp
        if(p<numSamples){
          Simulated_Data[i,(1:numSamples)[-randp]] <-0
        }
      }else{  # gene is above cutoff
        if(is.null(varInflation)){
          for(j in 1:p){
            while(temp[j]==0){temp[j] <- rnbinom(1,RP[i,1],1-RP[i,2])}
          }
        }else{
          for(j in 1:p){
            while(temp[j]==0){temp[j] <- rnbinom(1,RP[i,3],1-RP[i,4])}
          }
        }
        randp <- sample(1:numSamples, p, replace=FALSE)
        Simulated_Data[i,randp] <- temp
        if(p<numSamples){
          Simulated_Data[i,(1:numSamples)[-randp]] <-0
        }
      }
    } else{
      if(MVC2[i,5]==0){  # gene is below cutoff 
        if(is.null(varInflation)){
          Simulated_Data[i,1:numSamples] <- rnbinom(numSamples,
                                                    RPC2[i,1],1-RPC2[i,2])
        }else{
          Simulated_Data[i,1:numSamples] <- rnbinom(numSamples,
                                                    RPC2[i,5],1-RPC2[i,6])
        }
      }else{  # gene is above cutoff
        if(is.null(varInflation)){
          Simulated_Data[i,1:numSamples] <- rnbinom(numSamples,
                                                    RP[i,1],1-RP[i,2])
        }else{
          Simulated_Data[i,1:numSamples] <- rnbinom(numSamples,
                                                    RP[i,3],1-RP[i,4])
        }
      }
    }
  }

  
  ### Simulate for condition2
  for(i in 1:numGenes){
    if(generateZero=="empirical"){
      p <- round(numSamples*(1-Zeropercent_Base[i,1]))
    } else if (generateZero=="constant"){
      p <- round((1-constantZero)*numSamples)
    }
    
    if(generateZero %in% c("empirical", "constant")){
      if(i%in%DEIndex){ 
        temp <- matrix(data=0,nrow=p,ncol=2)
        if(MVC2[i,5]==0){ # gene is below cutoff
          if(is.null(varInflation)){
            for(j in 1:p){
              while(temp[j,1]==0){temp[j,1] <- rnbinom(1,RP[i,1],1-RP[i,2])}
              while(temp[j,2]==0){temp[j,2] <- rnbinom(1,RPC2[i,3],
                                                       1-RPC2[i,4])}
            }
          }else{
            for(j in 1:p){
              while(temp[j,1]==0){temp[j,1] <- rnbinom(1,RP[i,5],1-RP[i,6])}
              while(temp[j,2]==0){temp[j,2] <- rnbinom(1,RPC2[i,11],
                                                       1-RPC2[i,12])}
            }
          }
        }else{  # gene is above cutoff
          if(is.null(varInflation)){
            for(j in 1:p){
              while(temp[j,1]==0){temp[j,1] <- rnbinom(1,RPC2[i,1],
                                                       1-RPC2[i,2])}
              while(temp[j,2]==0){temp[j,2] <- rnbinom(1,RPC2[i,3],
                                                       1-RPC2[i,4])}
            }
          }else{
            for(j in 1:p){
              while(temp[j,1]==0){temp[j,1] <- rnbinom(1,RPC2[i,9],
                                                       1-RPC2[i,10])}
              while(temp[j,2]==0){temp[j,2] <- rnbinom(1,RPC2[i,11],
                                                       1-RPC2[i,12])}
            }
          }
        }
        
        n1 <- round(p*DP[1],digits=0)
        randp <- sample(1:numSamples, p, replace=FALSE)
        Simulated_Data[i,numSamples+randp] <-  c(sample(temp[,1],n1,
                                                        replace=FALSE), 
                                                 sample(temp[,2],p-n1,
                                                        replace=FALSE))
        if(p<numSamples)
        {Simulated_Data[i,((numSamples+1):(2*numSamples))[-randp]] <-0}
        
      }else{  #EE genes (simulate just like in C1)
        temp <- matrix(data=0,nrow=p,ncol=1)
        if(MVC2[i,5]==0){ # gene is below cutoff
          if(is.null(varInflation)){
            for(j in 1:p){
              while(temp[j,1]==0){temp[j,1] <- rnbinom(1,RPC2[i,1],
                                                       1-RPC2[i,2])}
            }
          }else{
            for(j in 1:p){
              while(temp[j,1]==0){temp[j,1] <- rnbinom(1,RPC2[i,9],
                                                       1-RPC2[i,10])}
            }
          }
        }else{ # gene is above
          if(is.null(varInflation)){
            for(j in 1:p){
              while(temp[j,1]==0){temp[j,1] <- rnbinom(1,RP[i,1],
                                                       1-RP[i,2])}
            }
          }else{
            for(j in 1:p){
              while(temp[j,1]==0){temp[j,1] <- rnbinom(1,RP[i,5],
                                                       1-RP[i,6])}
            }
          }
        }
        
        randp <- sample(1:numSamples, p, replace=FALSE)
        Simulated_Data[i,randp+numSamples] <- temp
        if(p<numSamples){
          Simulated_Data[i,((numSamples+1):(2*numSamples))[-randp]] <-0
        }
      }
    }else{
      if(i%in%DEIndex){ 
        temp <- matrix(data=0,nrow=numSamples,ncol=2)
        if(MVC2[i,5]==0){ # gene is below cutoff
          if(is.null(varInflation)){
            temp[,1] <- rnbinom(numSamples,RP[i,1],1-RP[i,2])
            temp[,2] <- rnbinom(numSamples,RPC2[i,3],1-RPC2[i,4])
          }else{
            temp[,1] <- rnbinom(numSamples,RP[i,5],1-RP[i,6])
            temp[,2] <- rnbinom(numSamples,RPC2[i,11],1-RPC2[i,12])
          }
        }else{  # gene is above cutoff
          if(is.null(varInflation)){
            temp[,1] <- rnbinom(numSamples,RPC2[i,1],1-RPC2[i,2])
            temp[,2] <- rnbinom(numSamples,RPC2[i,3],1-RPC2[i,4])
          }else{
            temp[,1] <- rnbinom(numSamples,RPC2[i,9],1-RPC2[i,10])
            temp[,2] <- rnbinom(numSamples,RPC2[i,11],1-RPC2[i,12])
          }
        }
        
        n1 <- round(numSamples*DP[1],digits=0)
        Simulated_Data[i,((numSamples+1):(2*numSamples))] <-c(
          sample(temp[,1],n1,replace=FALSE), 
          sample(temp[,2],numSamples-n1,replace=FALSE))
        
      }else{  #EE genes (simulate just like in C1)
        if(MVC2[i,5]==0){ # gene is below cutoff
          if(is.null(varInflation)){
            temp <- rnbinom(numSamples,RPC2[i,1],1-RPC2[i,2])
          }else{
            temp <- rnbinom(numSamples,RPC2[i,9],1-RPC2[i,10])
          }
        }else{ # gene is above cutoff
          if(is.null(varInflation)){
            temp <- rnbinom(numSamples,RP[i,1],1-RP[i,2])
          }else{
            temp <- rnbinom(numSamples,RP[i,5],1-RP[i,6])
          }
        }
      }
    }
  }
  return(list(Simulated_Data, f=f))
}

#' preprocess
#'
#' Function to preprocess SingleCellExperiment object (1) to
#' only keep genes with a certain number of nonzero entries,
#' and (2) optionally apply a normalization procedure.
#'
#' @param SCdat An object of class \code{SingleCellExperiment} that contains 
#'  single-cell expression and metadata. The \code{assays} 
#'   slot contains a named list of matrices, where the normalized counts are 
#'   housed in the one named \code{normcounts}, and unnormalized counts are 
#'   stored in the one names \code{counts}. If either \code{scran_norm} or 
#'   \code{median_norm} is set to TRUE, the \code{normcounts} slot will be 
#'   created from the \code{counts} slot. The counts and normalized counts 
#'   matrices should have one
#'    row for each gene and one sample for each column.  
#'   The \code{colData} slot should contain a data.frame with one row per 
#'   sample and columns that contain metadata for each sample.  This data.frame
#'   should contain a variable that represents biological condition, which is 
#'   in the form of numeric values (either 1 or 2) that indicates which 
#'   condition each sample belongs to (in the same order as the columns of 
#'   \code{normcounts}).  Optional additional metadata about each cell can also
#'   be contained in this data.frame, and additional information about the 
#'   experiment can be contained in the \code{metadata} slot as a list.
#' 
#' @param zero.thresh A numeric value between 0 and 1 that represents
#'  the maximum proportion
#'  of zeroes per gene allowable in the processed dataset
#'  
#' @param scran_norm Logical indicating whether or not to normalize the data
#'  using scran Normalization from \code{scran}
#'  
#' @param median_norm Logical indicating whether or not to normalize the data
#'  using Median Normalization from \code{EBSeq}
#'  
#' @param condition A character object that contains the name of the column in 
#' \code{colData} that represents 
#'  the biological group or condition of interest (e.g. treatment versus 
#'  control).  Note that this variable should only contain two 
#'  possible values since \code{scDD} can currently only handle two-group 
#'  comparisons.  The default option assumes that there
#'  is a column named "condition" that contains this variable. 
#' 
#' @export
#' 
#' @importFrom EBSeq MedianNorm
#' 
#' @importFrom EBSeq GetNormalizedMat
#' 
#' @importFrom scran computeSumFactors
#' 
#' @import SummarizedExperiment
#'
#' @import SingleCellExperiment
#' 
#'
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222.
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'
#' @return An object of class \code{SingleCellExperiment} with genes removed if
#' they have more than \code{zero.thresh} zeroes, and the \code{normcounts} 
#' assay added if either \code{scran_norm} or \code{median_norm} is set to TRUE
#' and only \code{counts} is provided. If \code{normcounts} already exists and
#' either \code{scran_norm} or \code{median_norm} is set to TRUE, then the new
#' normalized counts are placed in the \code{normcounts} assay slot, and the
#' original values are moved to a new slot called \code{normcounts-orig}.
#'  
#' @examples 
#'  
#'  # load toy example SingleCellExperiment object
#'  
#'  data(scDatEx)
#'  
#'  # apply the preprocess function to filter out genes if they have more than
#'  # 75% zero
#'  
#'  scDatEx <- preprocess(scDatEx, zero.thresh=0.75)
#'  
#'  # apply the preprocess function again, but this time threshold on the 
#'  # proportion of zeroes and apply scran normalization
#'  # set the zero.thresh argument to 0.75 so that genes with more than 75% 
#'  # zeroes are filtered out 
#'  # set the scran_norm argument to TRUE to return scran normalized counts
#'  
#'  scDatEx.scran <- preprocess(scDatEx, zero.thresh=0.75, scran_norm=TRUE)
#'  
#'  # set the median_norm argument to TRUE to return Median normalized counts
#'  
#'  scDatEx.median <- preprocess(scDatEx, zero.thresh=0.75, median_norm=TRUE)

preprocess <- function(SCdat,
                       condition="condition",
                       zero.thresh=0.9,
                       scran_norm=FALSE,
                       median_norm=FALSE){
  
  # check whether SCdat is a member of the SingleCellExperiment class
  if(!("SingleCellExperiment" %in% class(SCdat))){
    stop("Please provide a valid 'SingleCellExperiment' object.")
  }
  
  # check that condition inputs are valid
  if (length(unique(colData(SCdat)[[condition]])) != 2 | 
      length(colData(SCdat)[[condition]]) != dim(SCdat)[2]){
    stop("Error: Please specify valid condition labels.")
  }
  
  if(median_norm & scran_norm){
    stop(paste0("Specified conflicting options for normalization. Only one ",
                " of scran_norm and median_norm can be set to TRUE"))
  }
  
  if (sum(median_norm, scran_norm) == 1 &
        !("counts" %in% assayNames(SCdat)) ){
    stop(paste0("If median or scran norm is specified, the input object ",
                "must contain raw counts in 'counts'."))
  }
  
  if (sum(median_norm, scran_norm) == 1 &
       "normcounts" %in% assayNames(SCdat) ){
    warning(paste0("median or scran norm is specified and the 'normcounts' ",
                "assay already exists; replacing 'normcounts' in output ",
                "with the specified normalization method. Original contents ",
                "of 'normcounts' are now in 'normcounts-orig'."))
    assay(SCdat, "normcounts-orig") <- normcounts(SCdat)
  }
    
  if (sum(median_norm, scran_norm) == 0 &
     !("normcounts" %in% assayNames(SCdat))){
    stop(paste0("If median or scran norm is not specified, the input object ",
                " must contain normalized counts in 'normcounts'"))
  }
  
  
  if (sum(median_norm, scran_norm) == 0){
    pe_mat <- normcounts(SCdat)
  }else{
    pe_mat <- assay(SCdat, "counts")
  }
  
  # reference category/condition - the first listed one
  ref <- unique(colData(SCdat)[[condition]])[1]
  cond <- colData(SCdat)[[condition]]
 
  # threshold on zero percentage (within each condition)
  pz1 <- apply(pe_mat[,cond==ref], 1, function(x) sum(x==0)/length(x))
  pz2 <- apply(pe_mat[,cond!=ref], 1, function(x) sum(x==0)/length(x))
  SCdat <- SCdat[pz1 <= zero.thresh & pz2 <= zero.thresh,]
  
  # normalize
  if (median_norm){ 
    message("Performing Median Normalization")
    libsize <- MedianNorm(assay(SCdat, "counts"))
    normcounts(SCdat) <- GetNormalizedMat(assay(SCdat, "counts"),
                                          libsize)
  }else if(scran_norm){
    message("Performing scran Normalization")
    SCdat <-  computeSumFactors(SCdat, assay.type="counts")
    normcounts(SCdat) <- GetNormalizedMat(assay(SCdat, "counts"),
                                          sizeFactors(SCdat))
  }
  
  return(SCdat)
}

## ----style-knitr, eval=TRUE, echo=FALSE, results="asis"--------------------
BiocStyle::latex()

## ----patternPlot, echo=FALSE, fig.show="hide", fig.width=7, fig.height=5----
### Note that the following code can be ignored for the purposes of
# analysis with scDD; it is simply used to generate the cartoon of 
# interesting DD patterns (illustration purposes only)
par(mfrow=c(2,2), tcl=-0.5, mai=c(0.4,0.4,0.5,0.3))
x <- seq(0, 6, by=0.05)

## traditional de 
# mu1 is 2 
# mu2 is 4
cord.x <- c(0,x,6) 
cord.y <- c(0,dnorm(x, 2, 0.75),0) 
curve(dnorm(x, 2 , 0.75),xlim=c(0,6),main="Traditional DE",
      xaxt="n", xlab="", ylab="", yaxt="n") 
polygon(cord.x,cord.y,col=rgb(0,0,1,1/4))
cord.x <- c(0,x,6) 
cord.y <- c(0,dnorm(x, 4, 0.75),0) 
lines(x, dnorm(x, 4 , 0.75))
polygon(cord.x,cord.y,col=rgb(1,0,0,1/4))
axis(side=1, at=c(2,4), labels=c(expression(mu[1]), expression(mu[2])),
     pos=0, cex.axis=1.5)
mtext("(A)", side = 3, line=0.5, adj=-0.1, cex=1.2, font=2)

x <- seq(0, 10, by=0.05)
## differential proportion
cord.x <- c(0,x,10) 
cord.y <- c(0,0.3*dnorm(x, 7, 1) + 0.7*dnorm(x, 3, 1),0) 
curve(0.3*dnorm(x, 7, 1) + 0.7*dnorm(x, 3, 1),xlim=c(0,10),main="DP",
      xaxt="n", xlab="", ylab="", yaxt="n") 
polygon(cord.x,cord.y,col=rgb(0,0,1,1/4))
cord.x <- c(0,x,10) 
cord.y <- c(0,0.3*dnorm(x, 3, 1) + 0.7*dnorm(x, 7, 1),0) 
lines(x, 0.3*dnorm(x, 3, 1) + 0.7*dnorm(x, 7, 1))
polygon(cord.x,cord.y,col=rgb(1,0,0,1/4))
axis(side=1, at=c(3,7), labels=c(expression(mu[1]), 
                                 expression(mu[2])), pos=0, cex.axis=1.5)
mtext("(B)", side = 3, line=0.5, adj=-0.1, cex=1.2, font=2)

## differential modes (DM)
cord.x <- c(0,x,6) 
cord.y <- c(0,dnorm(x, 2, 0.75),0) 
curve(dnorm(x, 2 , 0.75),xlim=c(0,6),main="DM", xaxt="n", 
      xlab="", ylab="", yaxt="n") 
polygon(cord.x,cord.y,col=rgb(0,0,1,1/4))
cord.x <- c(0,x,6) 
cord.y <- c(0,0.3*dnorm(x, 2, 0.6) + 0.7*dnorm(x, 4, 0.6),0) 
lines(x, 0.3*dnorm(x, 2, 0.6) + 0.7*dnorm(x, 4, 0.6))
polygon(cord.x,cord.y,col=rgb(1,0,0,1/4))
axis(side=1, at=c(2,4), labels=c(expression(mu[1]), 
                                 expression(mu[2])), pos=0, cex.axis=1.5)
mtext("(C)", side = 3, line=0.5, adj=-0.1, cex=1.2, font=2)

## Both DM and DP
cord.x <- c(0,x,10) 
cord.y <- c(0,0.5*dnorm(x, 2.5, 1) + 0.5*dnorm(x, 7.5, 1),0) 
curve(0.5*dnorm(x, 2.5, 1) + 0.5*dnorm(x, 7.5, 1),
      xlim=c(0,10),main="DB", xaxt="n", xlab="", ylab="", yaxt="n",
      ylim=c(0,max(0.5*dnorm(x, 2.5, 1) + 0.5*dnorm(x, 7.5, 1)))) 
polygon(cord.x,cord.y,col=rgb(0,0,1,1/4))
cord.x <- c(0,x,10) 
cord.y <- c(0,0.8*dnorm(x, 5, 2),0) 
lines(x, 0.8*dnorm(x, 5, 2))
polygon(cord.x,cord.y,col=rgb(1,0,0,1/4))
axis(side=1, at=c(2.5, 5, 7.5), labels=c(expression(mu[1]), 
                                         expression(mu[3]), 
                                         expression(mu[2])), 
     pos=0, cex.axis=1.5)
mtext("(D)", side = 3, line=0.5, adj=-0.1, cex=1.2, font=2)

## ----load lib, message=FALSE-----------------------------------------------
library(scDD)

## ----load exDat------------------------------------------------------------
data(scDatExSim)

## ----check class-----------------------------------------------------------
class(scDatExSim)
dim(scDatExSim)

## ----prior-----------------------------------------------------------------
prior_param=list(alpha=0.01, mu0=0, s0=0.01, a0=0.01, b0=0.01)

## ----main engine-----------------------------------------------------------
scDatExSim <- scDD(scDatExSim, prior_param=prior_param, testZeroes=FALSE)

## ----main results----------------------------------------------------------
RES <- results(scDatExSim)
head(RES)

## ----partition results-----------------------------------------------------
PARTITION.C1 <- results(scDatExSim, type="Zhat.c1")
PARTITION.C1[1:5,1:5]

## ----main engine perm------------------------------------------------------
scDatExSim <- scDD(scDatExSim, prior_param=prior_param, 
                 testZeroes=FALSE, permutations=100)

## ----load exdat2-----------------------------------------------------------
data(scDatEx)

## ----check class2----------------------------------------------------------
class(scDatEx)
dim(scDatEx)

## ----set num---------------------------------------------------------------
nDE <- 5
nDP <- 5
nDM <- 5
nDB <- 5
nEE <- 5
nEP <- 5
numSamples <- 100
seed <- 816

## ----simset----------------------------------------------------------------
SD <- simulateSet(scDatEx, numSamples=numSamples, 
                  nDE=nDE, nDP=nDP, nDM=nDM, nDB=nDB, 
                  nEE=nEE, nEP=nEP, sd.range=c(2,2), modeFC=4, plots=FALSE, 
                  random.seed=seed)

# load the SingleCellExperiment package to use rowData method
library(SingleCellExperiment)
head(rowData(SD))

## ----load summarizedexp, message=FALSE-------------------------------------
library(SingleCellExperiment)

## ----load exdatlist--------------------------------------------------------
data(scDatExList)

## ----create condition------------------------------------------------------
condition <- c(rep(1, ncol(scDatExList$C1)), rep(2,  ncol(scDatExList$C2)))

## ----rownames--------------------------------------------------------------
# Example of row and column names
head(rownames(scDatExList$C1))
head(colnames(scDatExList$C2))

names(condition) <- c(colnames(scDatExList$C1), colnames(scDatExList$C2))

## ----create sce------------------------------------------------------------
sce <- SingleCellExperiment(assays=list(normcounts=cbind(scDatExList$C1, 
                                                         scDatExList$C2)),
                                colData=data.frame(condition))
show(sce)

## ----load exdat3e----------------------------------------------------------
data(scDatEx)
show(scDatEx)

## ----preprocess------------------------------------------------------------
scDatEx <- preprocess(scDatEx, zero.thresh=0.9)
show(scDatEx)

## ----threshe---------------------------------------------------------------
scDatEx.scran <- preprocess(scDatEx, zero.thresh=0.5, scran_norm=TRUE)
show(scDatEx.scran)

## ----load exdat4-----------------------------------------------------------
data(scDatExSim)

## ----load sumExp, message=FALSE--------------------------------------------
library(SingleCellExperiment)

## ----plot DE, eval=TRUE, message=FALSE-------------------------------------
de <- sideViolin(normcounts(scDatExSim)[1,], scDatExSim$condition, 
           title.gene=rownames(scDatExSim)[1])

## ----plot DP, eval=TRUE, message=FALSE-------------------------------------
dp <- sideViolin(normcounts(scDatExSim)[6,], scDatExSim$condition, 
           title.gene=rownames(scDatExSim)[6])

## ----plot DM, eval=TRUE, message=FALSE-------------------------------------
dm <- sideViolin(normcounts(scDatExSim)[11,], scDatExSim$condition, 
           title.gene=rownames(scDatExSim)[11])

## ----plot DB, eval=TRUE, message=FALSE-------------------------------------
db <- sideViolin(normcounts(scDatExSim)[16,], scDatExSim$condition, 
           title.gene=rownames(scDatExSim)[16])

## ----plot EP, eval=TRUE, message=FALSE-------------------------------------
ep <- sideViolin(normcounts(scDatExSim)[21,], scDatExSim$condition, 
           title.gene=rownames(scDatExSim)[21])

## ----plot EE, eval=TRUE, message=FALSE-------------------------------------
ee <- sideViolin(normcounts(scDatExSim)[26,], scDatExSim$condition, 
           title.gene=rownames(scDatExSim)[26])

## ----plotGrid, fig.show='hide', fig.width=8.5, fig.height=11, message=FALSE----
library(gridExtra)
grid.arrange(de, dp, dm, db, ep, ee, ncol=2)

## ----sessionInfo, eval=TRUE------------------------------------------------
sessionInfo()

#' simuDE
#'
#' Simulation for Classic Differentially Expressed Case.
#' 
#' @details Method called by main function \code{\link{singleCellSimu}} to 
#' simulate genes 
#'  that have different means in each condition. Not intended to be called 
#'  directly by user.
#'
#' @inheritParams singleCellSimu
#'
#' @param Simulated_Data Required input empty matrix to provide structure 
#' information of 
#'  output matrix with simulated data
#'
#' @param DEIndex Index for DE genes
#'
#' @param samplename The name for genes that chosen for simulation
#'
#' @param Zeropercent_Base Zero percentage for corresponding gene 
#' expression values 
#'
#' @param coeff Relationship coefficients for Mean and Variance
#'
#' @param RP matrix for NB parameters for genes in samplename
#' 
#' @param f Fold change values (number of SDs) for each gene 
#' 
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'
#' @return Simulated_Data Simulated dataset for DE

simuDE <- function(Dataset1, Simulated_Data, DEIndex, samplename, 
                   Zeropercent_Base, f, FC, coeff, RP, modeFC,
                   generateZero, constantZero, varInflation){
  
numGenes <- nrow(Simulated_Data)
numSamples <- ncol(Simulated_Data)/2
numDE <- length(DEIndex)

### Simulate data for condition 1 first
for(i in 1:numGenes){
  if(generateZero=="empirical"){
    p <- round(numSamples*(1-Zeropercent_Base[i,1]))
  } else if (generateZero=="constant"){
    p <- round((1-constantZero)*numSamples)
  }
  
  if(generateZero %in% c("empirical", "constant")){
    temp <- matrix(data=0,nrow=p,ncol=1)
    if(is.null(varInflation)){
      for(j in 1:p){
        while(temp[j]==0){temp[j] <- rnbinom(1,RP[i,1],1-RP[i,2])}
      }
    }else{
      for(j in 1:p){
        while(temp[j]==0){temp[j] <- rnbinom(1,RP[i,3],1-RP[i,4])}
      }
    }
    ## randomly place the nonzeroes
    randp <- sample(1:numSamples, p, replace=FALSE)
    Simulated_Data[i,randp] <- temp
    if(p<numSamples)
    {Simulated_Data[i,(1:numSamples)[-randp]] <-0}
  } else{
    Simulated_Data[i,1:numSamples] <- rnbinom(numSamples,RP[i,1],1-RP[i,2])
    if(!is.null(varInflation)){
      Simulated_Data[i,1:numSamples] <- rnbinom(numSamples,RP[i,3],1-RP[i,4])
    }
  }
}

### Simulate data for condition 2 in DE
FCSimu <- FC[samplename]

f <- rep(NA, length(FCSimu))
for(i in 1:numGenes){
  a <- as.numeric(Dataset1[samplename[i],])
  if(mean(log(a[a!=0])) < 3 & FCSimu[i] < 1){
    FCSimu[i] <- 1/FCSimu[i]
  }else if(mean(log(a[a!=0])) > 7 & FCSimu[i] > 1){
    FCSimu[i] <- 1/FCSimu[i]
  }

  f[i] <- log(FCSimu[i] / sqrt(log(1+var(a[a!=0])/mean(a[a!=0])^2)))
}

# calculate empirical means and variances with fold change
MVC2 <- matrix(data=0,nrow=numGenes,ncol=2)
if(generateZero %in% c("empirical", "constant")){
  MVC2[,1:2] <- t(sapply(1:length(samplename), function(x) 
    calcMV(Dataset1[samplename[x],], FC=FCSimu[x], include.zeroes=FALSE)))
}else{
  MVC2[,1:2] <- t(sapply(1:length(samplename), function(x) 
    calcMV(Dataset1[samplename[x],], FC=FCSimu[x], include.zeroes=TRUE)))
}

# calculate r and p parameters of NB
RPC2 <- t(apply(MVC2[,1:2,drop=FALSE], 1, function(x) calcRP(x[1], x[2])))


if(!is.null(varInflation)){
  MVC2.Infl1 <- MVC2
  MVC2.Infl1[,1] <- MVC2[,1]*(1 + MVC2[,2]/(MVC2[,1]^2))^((varInflation[1]-1)/2)
  MVC2.Infl1[,2] <- MVC2[,2]*( ((1 + MVC2[,2]/(MVC2[,1]^2))^(2*varInflation[1])-
                                  (1 + MVC2[,2]/(MVC2[,1]^2))^varInflation[1]) /
                               ((1 + MVC2[,2]/(MVC2[,1]^2))^2-(1 + MVC2[,2]/
                                                                (MVC2[,1]^2))) )
  
  MVC2.Infl2 <- MVC2
  MVC2.Infl2[,1] <- MVC2[,1]*(1 + MVC2[,2]/(MVC2[,1]^2))^((varInflation[2]-1)/2)
  MVC2.Infl2[,2] <- MVC2[,2]*( ((1 + MVC2[,2]/(MVC2[,1]^2))^(2*varInflation[2])-
                                  (1 + MVC2[,2]/(MVC2[,1]^2))^varInflation[2]) /
                                 ((1 + MVC2[,2]/(MVC2[,1]^2))^2-(1 + MVC2[,2]/
                                                                (MVC2[,1]^2))) )
  
  RPC2 <- cbind(RPC2, t(apply(MVC2.Infl1[,1:2,drop=FALSE], 1, 
                              function(x) calcRP(x[1], x[2]))))
  RPC2 <- cbind(RPC2, t(apply(MVC2.Infl2[,1:2,drop=FALSE], 1, 
                              function(x) calcRP(x[1], x[2]))))
}

# now simulate genes in condition 2
for(i in 1:numGenes){
  if(generateZero=="empirical"){
    p <- round(numSamples*(1-Zeropercent_Base[i,1]))
  } else if (generateZero=="constant"){
    p <- round((1-constantZero)*numSamples)
  }
  
  if(generateZero %in% c("empirical", "constant")){
    if(i%in%DEIndex){ 
      temp <- matrix(data=0,nrow=p,ncol=1)
      if(is.null(varInflation)){
        for(j in 1:p){
          while(temp[j]==0) {temp[j] <- rnbinom(1,RPC2[i,1],1-RPC2[i,2])}
        }
      }else{
        for(j in 1:p){
          while(temp[j]==0) {temp[j] <- rnbinom(1,RPC2[i,5],1-RPC2[i,6])}
        }
      }
      ## randomly place the nonzeroes
      randp <- sample(1:numSamples, p, replace=FALSE)
      Simulated_Data[i,randp+numSamples] <- temp
      if(p<numSamples)
      {Simulated_Data[i,((numSamples+1):(2*numSamples))[-randp]] <-0}
    }else{
      temp <- matrix(data=0,nrow=p,ncol=1)
      if(is.null(varInflation)){
        for(j in 1:p){
          while(temp[j]==0){ temp[j] <- rnbinom(1,RP[i,1],1-RP[i,2])}
        }
      }else{
        for(j in 1:p){
          while(temp[j]==0){ temp[j] <- rnbinom(1,RP[i,5],1-RP[i,6])}
        }
      }
      ## randomly place the nonzeroes
      randp <- sample(1:numSamples, p, replace=FALSE)
      Simulated_Data[i,randp+numSamples] <- temp
      if(p<numSamples){
        Simulated_Data[i,((numSamples+1):(2*numSamples))[-randp]] <-0
        }
    }
  }else{
    if(i%in%DEIndex){
      if(!is.null(varInflation)){
        Simulated_Data[i,((numSamples+1):(2*numSamples))] <- rnbinom(numSamples,
                                                        RPC2[i,1],1-RPC2[i,2])
      }else{
        Simulated_Data[i,((numSamples+1):(2*numSamples))] <- rnbinom(numSamples,
                                                        RPC2[i,5],1-RPC2[i,6])
      }
    }else{
      if(!is.null(varInflation)){
        Simulated_Data[i,((numSamples+1):(2*numSamples))] <- rnbinom(numSamples,
                                                        RP[i,1],1-RP[i,2])
      }else{
        Simulated_Data[i,((numSamples+1):(2*numSamples))] <- rnbinom(numSamples,
                                                        RP[i,5],1-RP[i,6])
      }
    }
  }
}
return(list(Simulated_Data, f=round(f)))
}

#' findFC
#'
#' Find the appropriate Fold Change vectors for simulation that will be use in
#'  classic differential expression case.
#' 
#' @details This code is a modified version of Sam Younkin's simulate FC 
#' function.  Major things that were changed are 
#'   (1) standard deviations are calculated only on the nonzeroes, (2) the
#'    sampling of FCs is uniform on the log scale 
#'   instead of the raw scale, and (3) the binning is done by quantiles 
#'   instead of evenly spaced along the average expression
#'   values.
#'   
#' @inheritParams singleCellSimu
#'
#' @inheritParams scDD
#' 
#' @param sd.range Numeric vector of length two which describes the interval
#'  (lower, upper) of standard deviations
#'  of fold changes to randomly select. 
#'   
#' @param N Integer value for the number of bins to divide range of fold 
#' changes for calculating standard deviations
#' 
#' @param overExpressionProb Numeric value between 0 and 1 which describes 
#' the ratio of over to under expression 
#'  values to sample.
#'  
#' @param plot.FC Logical indicating whether or not to plot the observed 
#' and simulated log2 fold changes.
#'
#' @importFrom fields stats.bin
#' 
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'
#' @return FC.vec Return Fold Change Vectors




findFC <- function(SCdat, index, sd.range = c(1,3), N = 4, 
                   overExpressionProb = 0.5, plot.FC=FALSE, 
                   condition="condition"){

  # reference category/condition - the first listed one
  ref <- unique(colData(SCdat)[[condition]])[1]
  
# separate ExpressionSet by condition  
Dataset1 <- SCdat[,colData(SCdat)[[condition]]==ref]
Dataset2 <- SCdat[,colData(SCdat)[[condition]]!=ref]

### Find Mean Difference
x1bar <- apply(normcounts(Dataset1)[index,], 1, function(x) 
  if(sum(x!=0)>0){ mean(x[x!=0]) }else{0})
x2bar <- apply(normcounts(Dataset2)[index,], 1, function(x) 
  if(sum(x!=0)>0){ mean(x[x!=0]) }else{0})

### Find FC by MA_Plot
createFindFC <- function(x1bar, x2bar, sd.range=sd.range, N=N, 
                         overExpressionProb=overExpressionProb){
    x <- 1/2*log2(x1bar*x2bar)
    y <- log2(x2bar/x1bar)
    bindata <- fields::stats.bin(x, y, breaks=quantile(x, seq(0,1,by=1/N)))
    f <- function(x1, x2){
        if( x1 == 0 | x2 == 0 ){
            FC <- NA
        }else{
            binnum <- max(sum(1/2*log2(x1*x2) >= bindata$breaks+0.0005),1)
            sd <- bindata$stats["Std.Dev.",binnum]
            if( is.na(sd) & binnum == 1 ){
                message("Bin 1 has sd = NA.  Using sd from bin 2.")
                sd <- bindata$stats["Std.Dev.",binnum+1]
            }else if( is.na(sd) & binnum == N){
                message(paste0("Bin ", N, " has sd = NA.  Using sd from bin ",
                               N-1, "."))
                sd <- bindata$stats["Std.Dev.",N-1]
            }else if( is.na(sd) & binnum == (N+1)){
              message(paste0("Bin ", N+1, " has sd = NA.  Using sd from bin ",
                             N, "."))
              sd <- bindata$stats["Std.Dev.",N]
            }else if( is.na(sd)){
              message(paste0("Bin ", N, " has sd = NA.  Using sd from bin ",
                             N-1, "."))
              sd <- bindata$stats["Std.Dev.",N-1]
            }
            lowerFC <- sd.range[1]*sd
            upperFC <- sd.range[2]*sd
            FC.range <- 2^(c(lowerFC,upperFC))
            if( runif(1) < overExpressionProb ){
                FC <- exp(runif(1, min = log(FC.range[1]), 
                                max = log(FC.range[2])))
            }else{
                FC <- exp(runif(1, max = log(1/FC.range[1]), 
                                min = log(1/FC.range[2])))
            }
        }
        return(FC)
    }
    return(f)
}
findFC <- createFindFC(x1bar = x1bar, x2bar = x2bar, sd.range=sd.range, 
                       N=N, overExpressionProb=overExpressionProb)
FC.vec <- mapply(findFC, x1 = x1bar, x2 = x2bar)

if(plot.FC){
  par(mfrow=c(1,1))
  plot(1/2*log2(x1bar*x2bar), log2(FC.vec), pch=20, cex=0.5, col="red", 
       xlab="Mean Log2 Expression", ylab="Log2 FC", main="Observed (grey)
       and Sampled DE (red) Fold Changes")
  points(1/2*log2(x1bar*x2bar), log2(x1bar/x2bar), pch=20, cex=0.5, col="grey")
  points(1/2*log2(x1bar*x2bar), log2(FC.vec), pch=20, cex=0.5, col="red")
}
FC <- rep(NA, nrow(normcounts(Dataset1)))
FC[index] <- FC.vec
return(FC)
}

#' luOutlier
#'
#' Count the number of clusters with at least \code{min.size} samples
#' 
#' @details Function to obtain a count of the number of clusters that is robust 
#' to outliers.  Requires at least \code{min.size} samples to be considered
#'  in the robust count.
#' 
#' @param x Numeric vector of cluster membership (1st item (named \code{class})
#'  in list returned by \code{\link{mclustRestricted}})
#' 
#' @param min.size Numeric value for the minimum number of samples a cluster 
#' must have to be considered in the robust count.  Default is 3.
#'   
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential
#'  distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'   
#' @return The robust count of the number of unique clusters excluding those 
#' with less than \code{min.size} samples.

luOutlier <- function(x, min.size=3){
  return(sum(table(x)>=min.size))
}


#' lu
#'
#' Shortcut for \code{length(unique())}
#' 
#' @details Function to obtain a count of the number of clusters 
#' 
#' @param x Numeric vector of cluster membership (1st item (named \code{class})
#'  in list returned by \code{\link{mclustRestricted}})
#'
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'
#' @return The count of the number of unique clusters.

lu <- function(x){
  return(length(unique(x)))
}


#' findOutliers
#'
#' Find the clusters that are considered outliers
#' 
#' @details Function to obtain a count of the number of clusters that is 
#' robust to outliers.  Requires at least \code{min.size} samples to 
#' be considered
#'  in the robust count.
#' 
#' @param clustering Numeric vector of cluster membership (1st item (named
#'  \code{class}) in list returned by \code{\link{mclustRestricted}})
#' 
#' @param min.size Numeric value for the minimum number of samples a cluster
#'  must have to be considered in the robust count.  Default is 3.
#'   
#' @references Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
#' Kendziorski C. A statistical approach for identifying differential 
#' distributions
#' in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
#' \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
#' 1077-y}
#'
#' @return The robust count of the number of unique clusters excluding those 
#' with less than \code{min.size} samples.

findOutliers <- function(clustering, min.size=3){
  good <- names(table(clustering))[table(clustering)>=min.size]
  return(as.numeric(good))
}

%\VignetteIndexEntry{scDD Quickstart}
%\VignettePackage{scDD}
%\VignetteEngine{knitr::knitr}

\documentclass{article}
\usepackage{underscore}

<<style-knitr, eval=TRUE, echo=FALSE, results="asis">>=
BiocStyle::latex()
@

  \bioctitle[scDD]{Identifying differential 
  distributions in single-cell RNA-seq experiments with scDD}
    \author{Keegan Korthauer\thanks{\email{keegan@jimmy.harvard.edu}}}

\begin{document}

\maketitle
\begin{abstract}
The \Rpackage{scDD} package models single-cell gene expression data 
(from single-cell RNA-seq) using flexible nonparamentric Bayesian mixture 
models in order to explicitly handle heterogeneity within cell populations. 
In bulk RNA-seq data, where each measurement is an average over thousands of 
cells, distributions of expression over samples are most often unimodal. 
In single-cell RNA-seq data, however, even when cells represent genetically 
homogeneous populations, multimodal distributions of gene expression values 
over samples are common \cite{korthauer2016}. This type of heterogeneity is 
often treated as a nuisance factor in studies of differential expression in 
single-cell RNA-seq experiments. Here, we explicitly accommodate it in order 
to improve power to detect differences in expression distributions that are 
more complicated than a mean shift.
\end{abstract}

\packageVersion{\Sexpr{BiocStyle::pkg_ver("scDD")}}
Report issues on \url{https://github.com/kdkorthauer/scDD/issues}

\newpage
\tableofcontents
\newpage

\section{Background}

Our aim is two-fold: (1) to detect which genes have different expression 
distributions across two biological conditions and (2) to classify those 
differences into informative patterns. Note that in (1) we explicitly say 
differences in 'distributions' rather than differences in 'average', which 
would correspond to traditional DE (differential expression) analysis in 
bulk RNA-seq. By examining the entire distribution, we are able to detect more
subtle differences as well as describe complex patterns, such as the existence
of subgroups of cells within and across condition that express a given gene
at a different level.

We start by assuming that the log-transformed nonzero expression values arise
out of a Dirichlet Process Mixture of normals model. This allows us to 
characterize expression distributions in terms of the number of modes 
(or clusters). To detect differences in these distributions across conditions,
an approximate Bayes Factor score is used which compares the conditional 
likelihood under the hypothesis of Equivalent distributions (ED) where one 
clustering process governs both conditions jointly, with the hypothesis of 
Differential distributions (DD) where each condition is generated from its 
own clustering process. In the full framework, significance of the scores 
for each gene are evaluated via empirical p-values after permutation. 
Optionally, a fast implementation obtains the p-values from the non-parametric 
Kolmogorov-Smirnov test. Zero values are considered by also implementing a 
$\chi^2$ test of whether the proportion of zero values differs by condition 
(adjusted for overall sample detection rate). More details are provided in 
\cite{korthauer2016}.

After the detection step is carried out, the significantly DD genes are 
classified into four informative patterns based on the number of clusters 
detected and whether they overlap. These patterns, depicted in 
Figure~\ref{figure/patternPlot-1},
include (a) DE (differential expression of unimodal genes), (b) DP 
(differential proportion for multimodal genes), (c) DM (differential modality),
and (d) DB (both differential modality and different component means). 
Genes where a differential proportion of zeroes were identified are classified
as DZ (differential zero). Genes that are identified as significantly 
differentially distributed but do not fall into one of the above categories
are abbreviated NC (for no call). This includes genes with the same number of
components with similar component means, but differential variance. 
For reasons detailed in \cite{korthauer2016}, we do not aim to interpret this
type of pattern.


<<patternPlot, echo=FALSE, fig.show="hide", fig.width=7, fig.height=5>>=
### Note that the following code can be ignored for the purposes of
# analysis with scDD; it is simply used to generate the cartoon of 
# interesting DD patterns (illustration purposes only)
par(mfrow=c(2,2), tcl=-0.5, mai=c(0.4,0.4,0.5,0.3))
x <- seq(0, 6, by=0.05)

## traditional de 
# mu1 is 2 
# mu2 is 4
cord.x <- c(0,x,6) 
cord.y <- c(0,dnorm(x, 2, 0.75),0) 
curve(dnorm(x, 2 , 0.75),xlim=c(0,6),main="Traditional DE",
      xaxt="n", xlab="", ylab="", yaxt="n") 
polygon(cord.x,cord.y,col=rgb(0,0,1,1/4))
cord.x <- c(0,x,6) 
cord.y <- c(0,dnorm(x, 4, 0.75),0) 
lines(x, dnorm(x, 4 , 0.75))
polygon(cord.x,cord.y,col=rgb(1,0,0,1/4))
axis(side=1, at=c(2,4), labels=c(expression(mu[1]), expression(mu[2])),
     pos=0, cex.axis=1.5)
mtext("(A)", side = 3, line=0.5, adj=-0.1, cex=1.2, font=2)

x <- seq(0, 10, by=0.05)
## differential proportion
cord.x <- c(0,x,10) 
cord.y <- c(0,0.3*dnorm(x, 7, 1) + 0.7*dnorm(x, 3, 1),0) 
curve(0.3*dnorm(x, 7, 1) + 0.7*dnorm(x, 3, 1),xlim=c(0,10),main="DP",
      xaxt="n", xlab="", ylab="", yaxt="n") 
polygon(cord.x,cord.y,col=rgb(0,0,1,1/4))
cord.x <- c(0,x,10) 
cord.y <- c(0,0.3*dnorm(x, 3, 1) + 0.7*dnorm(x, 7, 1),0) 
lines(x, 0.3*dnorm(x, 3, 1) + 0.7*dnorm(x, 7, 1))
polygon(cord.x,cord.y,col=rgb(1,0,0,1/4))
axis(side=1, at=c(3,7), labels=c(expression(mu[1]), 
                                 expression(mu[2])), pos=0, cex.axis=1.5)
mtext("(B)", side = 3, line=0.5, adj=-0.1, cex=1.2, font=2)

## differential modes (DM)
cord.x <- c(0,x,6) 
cord.y <- c(0,dnorm(x, 2, 0.75),0) 
curve(dnorm(x, 2 , 0.75),xlim=c(0,6),main="DM", xaxt="n", 
      xlab="", ylab="", yaxt="n") 
polygon(cord.x,cord.y,col=rgb(0,0,1,1/4))
cord.x <- c(0,x,6) 
cord.y <- c(0,0.3*dnorm(x, 2, 0.6) + 0.7*dnorm(x, 4, 0.6),0) 
lines(x, 0.3*dnorm(x, 2, 0.6) + 0.7*dnorm(x, 4, 0.6))
polygon(cord.x,cord.y,col=rgb(1,0,0,1/4))
axis(side=1, at=c(2,4), labels=c(expression(mu[1]), 
                                 expression(mu[2])), pos=0, cex.axis=1.5)
mtext("(C)", side = 3, line=0.5, adj=-0.1, cex=1.2, font=2)

## Both DM and DP
cord.x <- c(0,x,10) 
cord.y <- c(0,0.5*dnorm(x, 2.5, 1) + 0.5*dnorm(x, 7.5, 1),0) 
curve(0.5*dnorm(x, 2.5, 1) + 0.5*dnorm(x, 7.5, 1),
      xlim=c(0,10),main="DB", xaxt="n", xlab="", ylab="", yaxt="n",
      ylim=c(0,max(0.5*dnorm(x, 2.5, 1) + 0.5*dnorm(x, 7.5, 1)))) 
polygon(cord.x,cord.y,col=rgb(0,0,1,1/4))
cord.x <- c(0,x,10) 
cord.y <- c(0,0.8*dnorm(x, 5, 2),0) 
lines(x, 0.8*dnorm(x, 5, 2))
polygon(cord.x,cord.y,col=rgb(1,0,0,1/4))
axis(side=1, at=c(2.5, 5, 7.5), labels=c(expression(mu[1]), 
                                         expression(mu[3]), 
                                         expression(mu[2])), 
     pos=0, cex.axis=1.5)
mtext("(D)", side = 3, line=0.5, adj=-0.1, cex=1.2, font=2)
@

\incfig{figure/patternPlot-1}{0.65\textwidth}
{Illustration of informative DD patterns}{}

The rest of this vignette outlines the main functionality of the 
\Rpackage{scDD} package. This includes:

\begin{itemize}
  \item Identifying genes that are expressed differently between two biological
  conditions and classifying them into informative patterns.
  \item Simulating single-cell RNA-seq data with differential expression that
  exhibits multimodal patterns.
  \item Preprocessing and formatting of single-cell RNA-seq data to facilitate
  analysis
  \item Visualizing the expression patterns using a violin plotting scheme
\end{itemize}

\section{Identify and Classify DD genes}
In this section, we demonstrate how to use the main function \Rfunction{scDD} 
to find genes with differential distributions and classify them into the 
patterns of interest described in the previous section. 

First, we need to load the \Rpackage{scDD} package. For each of the following
sections in this vignette, we assume this step has been carried out.
<<load lib, message=FALSE>>=
library(scDD)
@

Next, we load the toy simulated example \Rclass{SingleCellExperiment} object that we
will use for identifying and classifying DD genes.
<<load exDat>>=
data(scDatExSim)
@

Verify that this object is a member of the \Rclass{SingleCellExperiment} class 
and that it contains 200 samples and 30 genes. The \Rcode{colData} slot 
(which contains a dataframe of metadata for the cells) should have a column 
that contains the biological condition or grouping of interest. In this 
example data, that variable is the 'condition' variable. Note that the 
input gene set needs to be in \Rclass{SingleCellExperiment} format, and should 
contain normalized counts. In practice, it is also advisable to filter 
the input gene set to remove genes that have an extremely high proportion
of zeroes (see Section 6). More specifically, the test for differential
distributions of the expressed measurements will not be carried out on 
genes where only one or fewer cells had a nonzero measurement (these 
genes will still be tested for differential proportion of zeroes (DZ) 
if the \Rcode{testZeroes} parameter is set to \Rcode{TRUE}, however).

<<check class>>=
class(scDatExSim)
dim(scDatExSim)
@

Next, specify the hyperparameter arguments that we'll pass to the 
\Rfunction{scDD} function. These values reflect heavy-tailed distributions
over the paramaters and are robust to many different settings in simulation
(see \cite{korthauer2016} for more details).

<< prior >>=
prior_param=list(alpha=0.01, mu0=0, s0=0.01, a0=0.01, b0=0.01)
@
 
Finally, call the \Rfunction{scDD} function to test for differential 
distributions, classify DD genes, and return the results. If the biological
condition or grouping variable in the \Rcode{colData} slot is named 
something other than 'condition', you'll need to specify the name of the 
variable as an argument to the \Rfunction{scDD} function (set the 
\Rcode{condition} argument equal to the name of the relevant column). 
We won't perform the test for a difference in the proportion of zeroes 
since none exists in this simulated toy example data, but this option 
can be invoked by changing the \Rcode{testZeroes} option to \Rcode{TRUE}. 
Note that the default option is to use a fast test of differential 
distributions that involves the Kolmogorov-Smirnov test instead of the 
full permutation testing framework. This provides a fast implementation
of the method at the cost of potentially slightly decreased power compared
to the full scDD framework described in the manuscript (see Section 4 for 
more details).

Note that if you are only interested in obtaining the results of the test for
significance, and not in the classification of genes to the patterns mentioned
above, you can achieve further computational speedup by setting 
\Rcode{categorize} to \Rcode{FALSE}.

<<main engine>>=
scDatExSim <- scDD(scDatExSim, prior_param=prior_param, testZeroes=FALSE)
@

Four results objects are added to the \Robject{scDatExSim} SingleCellExperiment 
object in the \Rclass{metadata} slot. For convenience, the results objects can
be extracted with the \Rfunction{results} function. 

The main results object is the \Rcode{"Genes"} object which is a 
\Rclass{data.frame} containing the following columns: 
\begin{itemize}
  \item \Rcode{gene}: gene name (matches rownames of SCdat)
  \item \Rcode{DDcategory}: name of the DD pattern (DE, DP, DM, DB, DZ), 
  or NC (no call), or NS (not significant). 
  \item \Rcode{Clusters.combined}: the number of clusters identified 
  when pooling condition 1 and 2 together
  \item \Rcode{Clusters.c1}: the number of clusters identified in 
  condition 1 alone
  \item \Rcode{Clusters.c2}: the number of clusters identified in 
  condition 2 alone
  \item \Rcode{nonzero.pvalue}: p-value for KS test of differential 
  distributions of expressed cells
  \item \Rcode{nonzero.pvalue.adj}: Benjamini-Hochberg adjusted p-value 
  for KS test of differential distributions
  \item \Rcode{zero.pvalue}: p-value for test of difference in dropout rate
  (only if \Rcode{testZeroes==TRUE})
  \item \Rcode{zero.pvalue.adj}: Benjamini-Hochberg adjusted p-value for 
  test of difference in dropout rate (only if \Rcode{testZeroes==TRUE})
  \item \Rcode{combined.pvalue}: Fisher's combined p-value for a difference
  in nonzero or zero values (only if \Rcode{testZeroes==TRUE})
  \item \Rcode{combined.pvalue.adj}: Benjamini-Hochberg adjusted Fisher's 
  combined p-value for a difference
  in nonzero or zero values (only if \Rcode{testZeroes==TRUE})
\end{itemize}

This can be extracted using the following call to \Rfunction{results}:

<<main results>>=
RES <- results(scDatExSim)
head(RES)
@

The remaining three results objects are matrices (first for condition 1 and 
  2 combined, then condition 1 alone, then condition 2 alone) that contain  
  the cluster memberships (partition estimates) 
  for each sample (for clusters 1,2,3,...) in columns 
  and genes in rows. Zeroes, which are not involved in the clustering, 
  are labeled as zero. These can be extracted by specifying an alternative
  \Robject{type} when calling the \Rfunction{results} function. For example,
  we can extract the partition estimates for condition 1 with the following:

<<partition results>>=
PARTITION.C1 <- results(scDatExSim, type="Zhat.c1")
PARTITION.C1[1:5,1:5]
@

\section{Alternate test for Differential Distributions}

The first step in the scDD framework that identifies Differential 
Distributions was designed to have optimal power to detect differences in
expression distributions, but the utilization of a permutation test on the
Bayes Factor can be computationally demanding. While this is not an issue
when machines with multiple cores are available since the code takes advantage
of parallel processing, we also provide the option to use an alternate test to
detect distributional differences that avoides the use of a permutation test. 
This option (default) uses the Kolmogorov-Smirnov test, which examines the null
hypothesis that two samples are generated from the same continuous 
distribution. While the use of this test yielded slighlty lower power in 
simulations than the full permutation testing framework at lower sample sizes
(50-75 cells in each condition) and primarily affected the DB pattern genes, 
it does not require permutations and thus is orders of magnitude faster. The
overall power to detect DD genes in simulation was still comparable or 
favorable to exisiting methods for differential expression analysis of 
scRNA-seq experiments. 

The remaining steps of the scDD framework remain unchanged if the alternate
test is used. That is, the Dirichlet process mixture model is still fit to
the observed expression measurements so that the significant DD genes can be
categorized into patterns that represent the major distributional changes, 
and results can still be visualized with violin plots using the 
\Rfunction{sideViolin} function described in the Plotting section. 

The option to use the full permutation testing procedure instead of the 
Kolmogorov-Smirnov test is invoked by setting the number of permutations to
something other than zero (the \Rcode{permutations} argument in 
\Rfunction{scDD}) when calling the main \Rfunction{scDD} function as follows:

<<main engine perm>>=
scDatExSim <- scDD(scDatExSim, prior_param=prior_param, 
                 testZeroes=FALSE, permutations=100)
@

The line above will run 100 permutations of every gene.  In practice, it is
recommended that at least 1000 permutations are carried out if using the full
permutation testing option. Note that this option will take significantly 
longer than the default option to use the alternate KS test, and computation
time will increase with more genes and/or more permutations, but multiple 
cores will automatically be utilized (if available) via the 
\Rpackage{BiocParallel} package. By default, an OS appropriate back-end 
using the number of cores on the machine minus 2 is chosen automatically. 
Alternatively, you can specificy the number of 
cores to use by passing in a \Rcode{param} argument in the \Rcode{scDD} 
function call (where the \Rcode{param} argument is an object of class 
\Rcode{MulticoreParm} for Linux-like OS or \Rcode{SnowParam} for Windows). 
For example, to use 12 cores on a Linux-like OS, specify 
\Rcode{param=MulticoreParam(workers=12)}.

The results returned by \Rfunction{scDD} remain exactly as described 
in the previous section, with the exception that the \Rcode{nonzero.pvalue} 
and \Rcode{nonzero.pvalue.adj} columns of the \Rfunction{Genes} data frame 
now contain the p-values and Benjamini-Hochberg adjusted p-values of the
perumtation test of the Bayes Factor for independence of condition membership
with clustering. 

\section{Simulation}

Here we show how to generate a simulated single-cell RNA-seq dataset which 
contains multi-modal genes. The \Rfunction{simulateSet} function simulates 
data from a two-condition experiment with a specified number of genes that 
fall into each of the patterns of interest. For DD genes, these include DE
(differential expression of unimodal genes), DP (differential proportion 
for multimodal genes), DM (differential modality), and DB (both differential 
modality and mean expression levels), and for ED genes these include EE 
(equivalent expression for unimodal genes) and EP (equivalent proportion
for multimodal genes). The simulation parameters are based on observed data
from two conditions, so the function requires an \Rclass{SingleCellExperiment} 
formatted dataset as input. The output of the function is also a 
\Rclass{SingleCellExperiment} object with information about the true category
of each gene and its simulated fold change stored in the \Rcode{rowData} slot.

First, we load the toy example \Rclass{SingleCellExperiment} to simulate from
<<load exdat2>>=
data(scDatEx)
@

We'll verify that this object is a member of the \Rclass{SingleCellExperiment} class 
and that it contains 142 samples and 500 genes
<< check class2>>=
class(scDatEx)
dim(scDatEx)
@
Next we need to set the arguments that will be passed to the 
\Rfunction{simulateSet} function. In this example we will simulate 30 genes
total, with 5 genes of each type and 100 samples in each of two conditions. 
We also set a random seed for reproducibility.

<< set num >>=
nDE <- 5
nDP <- 5
nDM <- 5
nDB <- 5
nEE <- 5
nEP <- 5
numSamples <- 100
seed <- 816
@

Finally, we'll create the simulated set with specified numbers of DE, DP, DM,
DM, EE, and EP genes and specified number of samples, where DE gene fold 
changes represent 2 standard deviations of the observed fold change 
distribution, and multimodal genes have cluster mean distance of 4 
standard deviations.
<<simset>>=
SD <- simulateSet(scDatEx, numSamples=numSamples, 
                  nDE=nDE, nDP=nDP, nDM=nDM, nDB=nDB, 
                  nEE=nEE, nEP=nEP, sd.range=c(2,2), modeFC=4, plots=FALSE, 
                  random.seed=seed)

# load the SingleCellExperiment package to use rowData method
library(SingleCellExperiment)
head(rowData(SD))
@               

The \Rcode{normcounts} assay \Robject{SD} object (of class 
\Rclass{SingleCellExperiment}) contains 
simulated expression values. The \Rcode{rowData} slot stores the 
fold change/modal distance values and gene expression categories,
which are useful in assessing performance of a differential
expression method.

\section{Formatting and Preprocessing}

Before beginning an analysis using \Rpackage{scDD}, you will need to carry out
a few preprocessing steps. This includes normalization, filtering of genes 
that are mostly zero, and getting the data into format that is expected by 
the \Rfunction{scDD} function. The following subsections will detail 
these steps.

\subsection{Constructing a SingleCellExperiment object}

In this subsection, we provide a quick example of how to construct an object 
of the \Rclass{SingleCellExperiment} class. 
For more detailed instructions, refer 
to the \Rpackage{SingleCellExperiment} package documentation.

Here we will convert the toy example data object \Robject{scDatExList} into a 
\Rclass{SingleCellExperiment} object. This object is a list of two matrices 
(one for each condition) of  normalized counts. Each matrix has genes in rows
and cells in columns, and is named "C1" or "C2" (for condition 1 or 2).

First, load the \Rpackage{SingleCellExperiment} package:

<<load summarizedexp, message=FALSE>>=
library(SingleCellExperiment)
@

Next, load the toy example data list:
<<load exdatlist>>=
data(scDatExList)
@

Next, create a vector of condition membership labels (these should be 1 or 2).
In our example data list, we have 78 cells in condition 1, and 64 cells in 
condition 2.

<<create condition>>=
condition <- c(rep(1, ncol(scDatExList$C1)), rep(2,  ncol(scDatExList$C2)))
@

The rows and columns of the expression matrix should have unique names. This is 
already the case for our toy example dataset.  
The names of the columns should also correspond to the names of the condition 
membership labels in \Robject{condition}.

<<rownames>>=
# Example of row and column names
head(rownames(scDatExList$C1))
head(colnames(scDatExList$C2))

names(condition) <- c(colnames(scDatExList$C1), colnames(scDatExList$C2))
@

Once our labeling is intact, we can call the \Rfunction{SingleCellExperiment} 
function and specify the two relevant pieces of information. 
The \Rcode{normcounts} assays slot should contain one matrix, so we use 
\Rcode{rbind} here to combine both conditions. Optionally, 
additional experiment information can be stored in additional slots; see the
\Rpackage{SingleCellExperiment} package for more details.
<<create sce>>=
sce <- SingleCellExperiment(assays=list(normcounts=cbind(scDatExList$C1, 
                                                         scDatExList$C2)),
                                colData=data.frame(condition))
show(sce)
@

\subsection{Filtering and Normalization}

In this subsection, we demonstrate the utility of the \Rfunction{preprocess} 
function, which can be helpful if working with raw counts, or data which 
contains genes that are predominantly zero (common in single-cell RNA-seq 
experiments). This function takes as input a list of data matrices, one for
each condition.

First, load the toy example data and verify it is a 
\Rclass{SingleCellExperiment} object:
<<load exdat3e>>=
data(scDatEx)
show(scDatEx)
@

Now, apply the \Rfunction{preprocess} function with the \Robject{zero.thresh} argument set to 0.9 so that genes are filtered out if 
they are 90 (or more) percent zero.

<<preprocess>>=
scDatEx <- preprocess(scDatEx, zero.thresh=0.9)
show(scDatEx)
@

We can see that no genes were removed, since all have fewer than 90 percent 
of zeroes to begin with.

Now, apply the preprocess function again, but this time use a more stringent
threshold on the proportion of zeroes and apply normalization using size 
factors calculated using the \Rpackage{scran}. In this
example, we set the \Robject{zero.thresh} argument to 0.50 so that genes with 
more than 50 percent zeroes are filtered out and we set the 
\Robject{scran_norm} argument to \Rcode{TRUE} to return \Rpackage{scran} 
normalized counts. 

<<threshe>>= 
scDatEx.scran <- preprocess(scDatEx, zero.thresh=0.5, scran_norm=TRUE)
show(scDatEx.scran)
@

We can see that 38 genes were removed due to having more than 50 percent zeroes.
The warning message here is letting us know that our SingleCellExperiment 
object already contained a \Rcode{normcounts} assay, and that by specifying 
\Rcode{scran_norm=TRUE}, we are replacing that with the scran normalized counts 
and moving the original values to a new slot called \Rcode{normcounts-orig}. 

Also included is the option to use median normalization, invoked by setting
\Robject{median_norm} to \Rcode{TRUE}.

\section{Plotting}

Next we demonstrate the plotting routine that is implemented in the 
\Rfunction{sideViolin} function. This function produces side-by-side 
violin plots (where the curves represent a smoothed kernel density estimate)
of the log-transformed data. A count of 1 is added before log-transformation
so that zeroes can be displayed, but they are not included in the density 
estimation. Each condition is represented by one violin plot. Individual 
data points are plotted (with jitter) on top. 

We illustrate this function by displaying the six types of simulated genes 
using the toy example simulated dataset. First, load the toy simulated dataset:

<<load exdat4>>=
data(scDatExSim)
@

Next, load the \Rpackage{SingleCellExperiment} package to facilitate 
subset operations on \Rcode{SingleCellExperiment} class objects:
<<load sumExp, message=FALSE>>=
library(SingleCellExperiment)
@

The following lines will produce the figures in Figure~\ref{figure/plotGrid-1}.

Plot side by side violin plots for Gene 1 (DE):
<<plot DE, eval=TRUE, message=FALSE>>=
de <- sideViolin(normcounts(scDatExSim)[1,], scDatExSim$condition, 
           title.gene=rownames(scDatExSim)[1])
@

Plot side by side violin plots for Gene 6 (DP):
<<plot DP, eval=TRUE, message=FALSE>>=
dp <- sideViolin(normcounts(scDatExSim)[6,], scDatExSim$condition, 
           title.gene=rownames(scDatExSim)[6])
@

Plot side by side violin plots for Gene 11 (DM):
<<plot DM, eval=TRUE, message=FALSE>>=
dm <- sideViolin(normcounts(scDatExSim)[11,], scDatExSim$condition, 
           title.gene=rownames(scDatExSim)[11])
@

Plot side by side violin plots for Gene 16 (DB):
<<plot DB, eval=TRUE, message=FALSE>>=
db <- sideViolin(normcounts(scDatExSim)[16,], scDatExSim$condition, 
           title.gene=rownames(scDatExSim)[16])
@

Plot side by side violin plots for Gene 21 (EP):
<<plot EP, eval=TRUE, message=FALSE>>=
ep <- sideViolin(normcounts(scDatExSim)[21,], scDatExSim$condition, 
           title.gene=rownames(scDatExSim)[21])
@

Plot side by side violin plots for Gene 26 (EE):
<<plot EE, eval=TRUE, message=FALSE>>=
ee <- sideViolin(normcounts(scDatExSim)[26,], scDatExSim$condition, 
           title.gene=rownames(scDatExSim)[26])
@

The plot objects returned by \Rfunction{sideViolin} are standard 
\Rpackage{ggplot2} objects, and thus can be manipulated into multipanel
figures with the help of the \Rpackage{gridExtra} or \Rpackage{cowplot} 
packages. Here we use \Rfunction{grid.arrange} from the \Rpackage{gridExtra}
package to visualize all the plots generated above. The end result is shown 
in Figure~\ref{figure/plotGrid-1}.


<<plotGrid, fig.show='hide', fig.width=8.5, fig.height=11, message=FALSE>>=
library(gridExtra)
grid.arrange(de, dp, dm, db, ep, ee, ncol=2)
@

\incfig{figure/plotGrid-1}{0.92\textwidth}{Example Simulated DD genes}{} 

\section{Session Info}
Here is the output of \Rfunction{sessionInfo} on the system where 
this document was compiled:

<<sessionInfo, eval=TRUE>>=
sessionInfo()
@

\bibliography{vignette}
\end{document}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/permutations.R
\name{permMclustGene}
\alias{permMclustGene}
\title{permMclustGene}
\usage{
permMclustGene(y, adjust.perms, nperms, condition, remove.zeroes = TRUE,
  log.transf = TRUE, restrict = TRUE, alpha, m0, s0, a0, b0, C, ref,
  min.size)
}
\arguments{
\item{y}{Numeric data vector for one gene}

\item{adjust.perms}{Logical indicating whether or not to adjust the 
permutation tests for the sample
  detection rate (proportion of nonzero values).  If true, the 
  residuals of a linear model adjusted for 
  detection rate are permuted, and new fitted values are 
  obtained using these residuals.}

\item{nperms}{Number of permutations of residuals to evaulate}

\item{condition}{A character object that contains the name of the column in 
\code{colData} that represents 
 the biological group or condition of interest (e.g. treatment versus 
 control).  Note that this variable should only contain two 
 possible values since \code{scDD} can currently only handle two-group 
 comparisons.  The default option assumes that there
 is a column named "condition" that contains this variable.}

\item{remove.zeroes}{Logical indicating whether zeroes need to be removed 
from \code{y}}

\item{log.transf}{Logical indicating whether the data is in the raw scale 
(if so, will be log-transformed)}

\item{restrict}{Logical indicating whether to perform restricted Mclust 
clustering where close-together clusters are joined.}

\item{alpha}{Value for the Dirichlet concentration parameter}

\item{m0}{Prior mean value for generating distribution of cluster means}

\item{s0}{Prior precision value for generating distribution of cluster means}

\item{a0}{Prior shape parameter value for the generating distribution of 
cluster precision}

\item{b0}{Prior scale parameter value for the generating distribution of 
cluster precision}

\item{C}{Matrix of confounder variables, where there is one row for each
sample and one column for each covariate.}

\item{ref}{one of two possible values in condition;
represents the referent category.}

\item{min.size}{a positive integer that specifies the minimum size of a 
cluster (number of cells) for it to be used
 during the classification step.  Any clusters containing fewer than 
 \code{min.size} cells will be considered an outlier
 cluster and ignored in the classfication algorithm.  The default value
  is three.}
}
\value{
Bayes factor numerator for the current permutation
}
\description{
Function to obtain bayes factor for all permutations of one gene 
(not parallelized; to be used when parallelizing over Genes)
}
\details{
Obtains bayes factor for data vector \code{y} representing one gene
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R,
 Kendziorski C. A statistical approach for identifying differential
  distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SidebySideHists.R
\name{sideHist}
\alias{sideHist}
\title{sideHist}
\usage{
sideHist(x, y, logT = TRUE, title.gene = "")
}
\arguments{
\item{x}{First numeric vector of data to plot.}

\item{y}{Second numeric vector of data to plot.}

\item{logT}{Logical that indicates whether to take the log(x+1) 
transformation.}

\item{title.gene}{Character vector that contains the gene name that you 
are plotting}
}
\value{
NULL (creates a baseR plot)
}
\description{
Plots two histograms side by side with smoothed density overlay
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ex-data.R
\docType{data}
\name{scDatEx}
\alias{scDatEx}
\title{Data: Toy example data}
\format{An object of class \code{SingleCellExperiment} containing
 data for 500 genes for 142 samples
 (78 from condition 1 and 64 from condition 2).  Condition labels (1 or 2)
  are stored in the colData slot. The assays slot contains both normcounts
  and counts for illustration, but these objects are identical.}
\usage{
data(scDatEx)
}
\value{
An RData object, see Format section for details
}
\description{
Toy example data in \code{SingleCellExperiment} format for 500 
genes to illustrate how to generate simulated data from example data
 using \code{\link{simulateSet}}.
}
\examples{

# load toy example data 
data(scDatEx) 
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Cluster_actions.R
\name{lu}
\alias{lu}
\title{lu}
\usage{
lu(x)
}
\arguments{
\item{x}{Numeric vector of cluster membership (1st item (named \code{class})
in list returned by \code{\link{mclustRestricted}})}
}
\value{
The count of the number of unique clusters.
}
\description{
Shortcut for \code{length(unique())}
}
\details{
Function to obtain a count of the number of clusters
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/joint.posterior.R
\name{jointPosterior}
\alias{jointPosterior}
\title{jointPosterior}
\usage{
jointPosterior(y, mcobj, alpha, m0, s0, a0, b0)
}
\arguments{
\item{y}{Numeric data vector for one gene (log-transformed non-zeroes)}

\item{mcobj}{Object returned by \code{\link{mclustRestricted}}}

\item{alpha}{Value for the Dirichlet concentration parameter}

\item{m0}{Prior mean value for generating distribution of cluster means}

\item{s0}{Prior precision value for generating distribution of cluster means}

\item{a0}{Prior shape parameter value for the generating distribution of 
cluster precision}

\item{b0}{Prior scale parameter value for the generating distribution of 
cluster precision}
}
\value{
log joint posterior value
}
\description{
Function to obtain the normalized joint posterior of the data and partition.
}
\details{
Calculates the normalized joint posterior of the data and partition
 under the Product Partition Model formulation
  of the Dirichlet Process Mixture model.
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Single_Cell_Simu.R
\name{calcRP}
\alias{calcRP}
\title{calcRP}
\usage{
calcRP(Emean, Evar)
}
\arguments{
\item{Emean}{Empirical mean}

\item{Evar}{Empirical variance}
}
\value{
RP Vector of two elements, first contains method of moments 
estimator for r and second contains 
 method of moments estimator for p (parameters of NB distribution)
}
\description{
Calculate parameter R and P in NB distribution
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classify.dd.R
\name{classifyDD}
\alias{classifyDD}
\title{classifyDD}
\usage{
classifyDD(pe_mat, condition, sig_genes, oa, c1, c2, alpha, m0, s0, a0, b0,
  log.nonzero = TRUE, adjust.perms = FALSE, ref, min.size = 3)
}
\arguments{
\item{pe_mat}{Matrix with genes in rows and samples in columns.
Column names indicate condition.}

\item{condition}{Vector of condition indicators (with two possible values).}

\item{sig_genes}{Vector of the indices of significantly DD genes 
(indicating the row number of \code{pe_mat})}

\item{oa}{List item with one item for each gene where the first element 
contains the cluster membership for 
 each nonzero sample in the overall (pooled) fit.}

\item{c1}{List item with one item for each gene where the first element 
contains the cluster membership for 
 each nonzero sample in condition 1 only fit}

\item{c2}{List item with one item for each gene where the first element 
contains the cluster membership for 
 each nonzero sample in condition 2 only fit}

\item{alpha}{Value for the Dirichlet concentration parameter}

\item{m0}{Prior mean value for generating distribution of cluster means}

\item{s0}{Prior precision value for generating distribution of cluster means}

\item{a0}{Prior shape parameter value for the generating distribution of 
cluster precision}

\item{b0}{Prior scale parameter value for the generating distribution of 
cluster precision}

\item{log.nonzero}{Logical indicating whether to perform log 
transformation of nonzero values.}

\item{adjust.perms}{Logical indicating whether or not to adjust the 
permutation tests for the sample
  detection rate (proportion of nonzero values).  If true, the 
  residuals of a linear model adjusted for 
  detection rate are permuted, and new fitted values are 
  obtained using these residuals.}

\item{ref}{one of two possible values in condition; 
represents the referent category.}

\item{min.size}{a positive integer that specifies the minimum size of a 
cluster (number of cells) for it to be used
 during the classification step.  Any clusters containing fewer than 
 \code{min.size} cells will be considered an outlier
 cluster and ignored in the classfication algorithm.  The default value
  is three.}
}
\value{
cat Character vector of the same length as \code{sig_genes} that 
indicates which category of 
 DD each significant gene belongs to (DE, DP, DM, DB, or NC (no call))
}
\description{
Classify significantly DD genes into the four categories (DE, DP, DM or DB)
 based on posterior distributions of cluster mean parameters
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Test_KS.R
\name{testKS}
\alias{testKS}
\title{testKS}
\usage{
testKS(dat, condition, inclZero = TRUE, numDE = NULL, DEIndex)
}
\arguments{
\item{dat}{Matrix of single-cell RNA-seq data with genes in rows and samples 
in columns.}

\item{condition}{Vector containing the indicator of which condition each 
sample 
 (in the columns of \code{dat}) belongs to.}

\item{inclZero}{Logical indicating whether to include zero in the test of 
different distributions}

\item{numDE}{numeric value for the number of genes that will differ between
two conditions}

\item{DEIndex}{Vector containing the row numbers of the DE genes}
}
\value{
List object containing the significant gene indices, their adjusted 
p-values, and (if DE genes are supplied)
the power and fdr.
}
\description{
Function to perform KS test
}
\examples{

# load toy simulated example ExpressionSet to find KS genes

data(scDatExSim)


# load SingleCellExperiment package to facilitate subset operations

library(SingleCellExperiment)


# check that this object is a member of the ExpressionSet class
# and that it contains 200 samples and 30 genes

class(scDatExSim)
show(scDatExSim)

# perform KS test and obtain adjusted p-values
RES_KS <- testKS(normcounts(scDatExSim), scDatExSim$condition, inclZero=FALSE,
                 numDE=20, DEIndex=1:20)
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/permutations.R
\name{permZero}
\alias{permZero}
\title{permZero}
\usage{
permZero(m, size, zmat)
}
\arguments{
\item{m}{Number of permuted sets to generate.}

\item{size}{Number of samples present in the dataset}

\item{zmat}{Matrix of indicators of whether the original data value is 
zero or not.  Should contain the 
  same number of rows and columns as original data matrix.}
}
\value{
a list of length 'm' (nperms) where each item is a 'ngenes' by 
'size' matrix
}
\description{
Function to generate random permutations of nonzero values.
}
\details{
Generates random permutations for all genes, where the zeroes are 
kept fixed (i.e. only permute the nonzero condition labels).
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ex-data.R
\docType{data}
\name{scDatExList}
\alias{scDatExList}
\title{Data: Toy example data list}
\format{A list of two matrices (one for each of two conditions) labeled 
"C1" and "C2".  Each matrix contains data for 100 genes
  and a variable number of samples (78 in C1 and 64 in C2).}
\usage{
data(scDatExList)
}
\value{
An RData object, see Format section for details
}
\description{
Toy example data list (one item for each of two conditions) for 100 genes
 to illustrate how to use the function
 \code{\link{preprocess}}.
}
\examples{

# load toy example data list 
data(scDatExList)

}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Cluster_actions.R
\name{findOutliers}
\alias{findOutliers}
\title{findOutliers}
\usage{
findOutliers(clustering, min.size = 3)
}
\arguments{
\item{clustering}{Numeric vector of cluster membership (1st item (named
\code{class}) in list returned by \code{\link{mclustRestricted}})}

\item{min.size}{Numeric value for the minimum number of samples a cluster
must have to be considered in the robust count.  Default is 3.}
}
\value{
The robust count of the number of unique clusters excluding those 
with less than \code{min.size} samples.
}
\description{
Find the clusters that are considered outliers
}
\details{
Function to obtain a count of the number of clusters that is 
robust to outliers.  Requires at least \code{min.size} samples to 
be considered
 in the robust count.
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helper.R
\name{results}
\alias{results}
\title{results}
\usage{
results(SCdat, type = c("Genes", "Zhat.c1", "Zhat.c2", "Zhat.combined"))
}
\arguments{
\item{SCdat}{An object of class \code{SingleCellExperiment} that contains 
normalized single-cell expression and metadata, and the output of the
\code{scDD} function.}

\item{type}{A character variable specifying which output is desired, 
 with possible values "Genes", "Zhat.c1", "Zhat.c2", and 
 "Zhat.overall".  The default value is "Genes", which contains a 
 a data frame with nine columns: 
gene name (matches rownames of SCdat), permutation p-value for testing of 
independence of 
 condition membership with clustering, Benjamini-Hochberg adjusted version 
 of the previous column, p-value for test of difference in dropout rate
  (only for non-DD genes), 
 Benjamini-Hochberg adjusted version of the previous column, name of the 
 DD (DE, DP, DM, DB) pattern or DZ (otherwise NS = not significant), the 
 number of clusters identified overall, the number of clusters identified in 
 condition 1 alone, and the number of clusters identified in condition 
 2 alone.
 
 If \code{type} is "Zhat.c1", then a \code{matrix} is returned
 that contains the fitted cluster memberships (partition estimates Z)
 for each sample (cluster number given by 1,2,3,...) in columns and
 gene in rows only for condition 1.  The same information is returned 
 only for condition 2, and for the overall clustering, when \code{type}
 is set to "Zhat.c2" or "Zhat.overall", respectively.  
  Zeroes, which are not involved in the clustering, are
  labeled as zero.}
}
\value{
A \code{data.frame} which contains either the gene classification 
 and p-value results, or cluster membership information, as detailed in the
 description of the \code{type} input parameter.
}
\description{
extract results objects after running scDD analysis
}
\details{
Convenient helper function to extract the results (gene 
classifications, pvalues, and clustering information). Results 
data.frames/matrices are stored in the 
\code{metadata} slot and can also be accessed without the help of this 
convenience function by calling \code{metadata(SCdat)}.
}
\examples{
 
# load toy simulated example SingleCellExperiment object to find DD genes  
data(scDatExSim)

# set arguments to pass to scDD function

prior_param=list(alpha=0.01, mu0=0, s0=0.01, a0=0.01, b0=0.01)

# call the scDD function to perform permutations and classify DD genes

scDatExSim <- scDD(scDatExSim, prior_param=prior_param, testZeroes=FALSE)

# extract main results object

RES <- results(scDatExSim)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SidebySideViolins.R
\name{sideViolin}
\alias{sideViolin}
\title{sideViolin}
\usage{
sideViolin(y, cond, MAP = NULL, logT = TRUE, title.gene = "",
  conditionLabels = unique(cond), axes.titles = TRUE)
}
\arguments{
\item{y}{Numeric vector of data to plot.}

\item{cond}{Vector of condition labels corresponding to elements of \code{x}.}

\item{MAP}{List of MAP partition estimates with conditions as list items and
samples as elements 
(integer indicating which cluster each observation belongs to; zeroes 
belong to cluster 1)}

\item{logT}{Logical that indicates whether to take the log(x+1)
transformation.}

\item{title.gene}{Character vector that contains the gene name
that you are plotting.}

\item{conditionLabels}{Character vector containing the names of
the two conditions.}

\item{axes.titles}{Logical indicating whether or not to include
axes labels on plots.}
}
\value{
ggplot object
}
\description{
Plots two histograms side by side with smoothed density overlay
}
\examples{

# load toy simulated example ExpressionSet to find DD genes

data(scDatExSim)


# load SingleCellExperiment package to facilitate subset operations 

library(SingleCellExperiment)


# plot side by side violin plots for Gene 1 (DE)

sideViolin(normcounts(scDatExSim)[1,], scDatExSim$condition, 
           title.gene=rownames(scDatExSim)[1])


# plot side by side violin plots for Gene 6 (DP)

sideViolin(normcounts(scDatExSim)[6,], scDatExSim$condition, 
           title.gene=rownames(scDatExSim)[6])


# plot side by side violin plots for Gene 11 (DM)

sideViolin(normcounts(scDatExSim)[11,], scDatExSim$condition, 
           title.gene=rownames(scDatExSim)[11])


# plot side by side violin plots for Gene 16 (DB)

sideViolin(normcounts(scDatExSim)[16,], scDatExSim$condition, 
           title.gene=rownames(scDatExSim)[16])

# plot side by side violin plots for Gene 21 (EP)

sideViolin(normcounts(scDatExSim)[21,], scDatExSim$condition, 
           title.gene=rownames(scDatExSim)[21])


# plot side by side violin plots for Gene 26 (EE)

sideViolin(normcounts(scDatExSim)[26,], scDatExSim$condition, 
           title.gene=rownames(scDatExSim)[26])


}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Single_Cell_Simu.R
\name{calcMV}
\alias{calcMV}
\title{calcMV}
\usage{
calcMV(a, FC = 1, FC.thresh = NA, threshold = Inf,
  include.zeroes = FALSE)
}
\arguments{
\item{a}{Numeric vector of values to calculate empirical mean and variance.}

\item{FC}{Fold change for the mean and standard deviation.  Default value 
is 1.}

\item{FC.thresh}{Alternate fold change for the mean and standard deviation 
when the (log nonzero) mean is above the value of \code{threshold}.  
 Default value is \code{FC}.}

\item{threshold}{Mean threshold value which dictates which fold change value
to use for multiplying mean and standard deviation.
Default value is Inf (so \code{FC} is always used).}

\item{include.zeroes}{Logical value indicating whether the zero values 
should be included in the calculations of the empirical means 
   and variances.}
}
\value{
MV Vector of two elements, first contains the empirical mean 
estimate, second contains the empirical variance estimate (optionally 
  multiplied by a fold change).
}
\description{
Calculate empirical means and variances of selected genes in a given 
 dataset.
}
\details{
Calculate empirical means and variances of selected genes in a 
given dataset. Optionally, multiply
 the means and standard deviations by a fold change value, which can also 
 vary by mean value.  If the mean is
 below some specified threshold \code{threshold}, use one fold change value 
 \code{FC}.  If above the threshold, use the alternate 
 fold change value \code{FC.thresh}.  Estimates of mean and variance are 
 robust to outliers.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mclust.restricted.R
\name{mclustRestricted}
\alias{mclustRestricted}
\title{mclustRestricted}
\usage{
mclustRestricted(y, restrict = TRUE, min.size)
}
\arguments{
\item{y}{Numeric vector of values to fit to a normal mixture model with 
Mclust.}

\item{restrict}{Logical indicating whether or not to enforce the restriction
on cluster separation based on bimodal index
 and ratio of largest to smallest variance (see details).  If False, 
 then Mclust results as is are returned.}

\item{min.size}{a positive integer that specifies the minimum size of a 
cluster (number of cells) for it to be used
 during the classification step. A clustering with all clusters of 
 size less than \code{min.size} is not valid and clusters will be merged if 
 this happens.}
}
\value{
List object with (1) vector of cluster membership, 
(2) cluster means, (3) cluster variances, (4) number of model parameters,
 (5) sample size, (6) BIC of selected model, and 
 (6) loglikelihood of selected model.
}
\description{
Function to determine how many normal mixture components are present.
}
\details{
Robust to detecting multiple components that are close together 
by enforcing that the distance between two clusters 
 of appreciable size (at least 4 samples), have sufficiently high bimodal 
 index (cluster mean difference standardized by average
 standard deviation and multiplied by a balance factor which is one when 
 clusters are perfectly balanced) and not have variances
 that differ by more than a ratio of 20. Bimodal index threshold is 
 dependent on sample size to ensure consistent performance
 in power and type I error of detection of multiple components.
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222.
 \url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
 1077-y}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/findIndex.R
\name{findIndex}
\alias{findIndex}
\title{findIndex}
\usage{
findIndex(SCdat, condition = "condition")
}
\arguments{
\item{SCdat}{An object of class \code{SingleCellExperiment} that contains 
normalized single-cell expression and metadata. The \code{assays} 
  slot contains a named list of matrices, where the normalized counts are 
  housed in the one named \code{normcounts}.  This matrix should have one
   row for each gene and one sample for each column.  
  The \code{colData} slot should contain a data.frame with one row per 
  sample and columns that contain metadata for each sample.  This data.frame
  should contain a variable that represents biological condition, which is 
  in the form of numeric values (either 1 or 2) that indicates which 
  condition each sample belongs to (in the same order as the columns of 
  \code{normcounts}).  Optional additional metadata about each cell can also
  be contained in this data.frame, and additional information about the 
  experiment can be contained in the \code{metadata} slot as a list.}

\item{condition}{A character object that contains the name of the column in 
\code{colData} that represents 
 the biological group or condition of interest (e.g. treatment versus 
 control).  Note that this variable should only contain two 
 possible values since \code{scDD} can currently only handle two-group 
 comparisons.  The default option assumes that there
 is a column named "condition" that contains this variable.}
}
\value{
Vector of indices for a reasonable set of genes that can be used 
for simulation.
}
\description{
Find a reasonable set of genes (one mode and at least 25% nonzero values) 
to use for simulation.
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Validation.R
\name{validation}
\alias{validation}
\title{validation}
\usage{
validation(MV, DEIndex, Zeropercent_Base, Simulated_Data, numGenes)
}
\arguments{
\item{MV}{Mean and Variance matrix for observed data}

\item{DEIndex}{Index for genes chosen to be DE (can be NULL)}

\item{Zeropercent_Base}{Zero percentage for corresponding gene expression 
values}

\item{Simulated_Data}{Simulated dataset}

\item{numGenes}{numeric value for the number of genes to simulate}
}
\value{
Validation plots
}
\description{
Draw validation plots to show that the simulated dataset emulates 
characteristics of observed dataset.
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scDD.R
\name{scDD}
\alias{scDD}
\title{scDD}
\usage{
scDD(SCdat, prior_param = list(alpha = 0.1, mu0 = 0, s0 = 0.01, a0 = 0.01, b0
  = 0.01), permutations = 0, testZeroes = TRUE, adjust.perms = FALSE,
  param = bpparam(), parallelBy = c("Genes", "Permutations"),
  condition = "condition", min.size = 3, min.nonzero = NULL,
  level = 0.05, categorize = TRUE)
}
\arguments{
\item{SCdat}{An object of class \code{SingleCellExperiment} that contains 
normalized single-cell expression and metadata. The \code{assays} 
  slot contains a named list of matrices, where the normalized counts are 
  housed in the one named \code{normcounts}.  This matrix should have one
   row for each gene and one sample for each column.  
  The \code{colData} slot should contain a data.frame with one row per 
  sample and columns that contain metadata for each sample.  This data.frame
  should contain a variable that represents biological condition, which is 
  in the form of numeric values (either 1 or 2) that indicates which 
  condition each sample belongs to (in the same order as the columns of 
  \code{normcounts}).  Optional additional metadata about each cell can also
  be contained in this data.frame, and additional information about the 
  experiment can be contained in the \code{metadata} slot as a list.}

\item{prior_param}{A list of prior parameter values to be used when modeling
each gene as a mixture of DP normals.  Default 
  values are given that specify a vague prior distribution on the 
  cluster-specific means and variances.}

\item{permutations}{The number of permutations to be used in calculating 
empirical p-values.  If set to zero (default),
  the full Bayes Factor permutation test will not be performed.  Instead, 
  a fast procedure to identify the genes with significantly different
  expression distributions will be performed using the nonparametric 
  Kolmogorov-Smirnov test, which tests the null hypothesis that 
  the samples are generated from the same continuous distribution.  
  This test will yield
  slightly lower power than the full permutation testing framework 
  (this effect is more pronounced at smaller sample 
  sizes, and is more pronounced in the DB category), but is orders of 
  magnitude faster.  This option
  is recommended when compute resources are limited.  The remaining 
  steps of the scDD framework will remain unchanged
  (namely, categorizing the significant DD genes into patterns that 
  represent the major distributional changes, 
  as well as the ability to visualize the results with violin plots 
  using the \code{sideViolin} function).}

\item{testZeroes}{Logical indicating whether or not to test for a 
difference in the proportion of zeroes. This will only be done for genes 
that have at least one zero value (genes where all cells have a nonzero value
will have a `zero.pvalue` of NA).}

\item{adjust.perms}{Logical indicating whether or not to adjust the 
permutation tests for the sample
  detection rate (proportion of nonzero values).  If true, the 
  residuals of a linear model adjusted for 
  detection rate are permuted, and new fitted values are 
  obtained using these residuals.}

\item{param}{a \code{MulticoreParam} or \code{SnowParam} object of 
the \code{BiocParallel}
package that defines a parallel backend.  The default option is 
\code{BiocParallel::bpparam()} which will automatically creates a cluster 
appropriate for 
the operating system.  Alternatively, the user can specify the number
of cores they wish to use by first creating the corresponding 
\code{MulticoreParam} (for Linux-like OS) or \code{SnowParam} (for Windows)
object, and then passing it into the \code{scDD}
function. This could be done to specify a parallel backend on a Linux-like
OS with, say 12 
cores by setting \code{param=BiocParallel::MulticoreParam(workers=12)}}

\item{parallelBy}{For the permutation test (if invoked), the manner in 
which to parallelize.  The default option
 is \code{"Genes"} which will spawn processes that divide up the genes 
 across all cores defined in \code{param} cores, and then loop through the 
 permutations. 
 The alternate option is \code{"Permutations"} which
 loop through each gene and spawn processes that divide up the permutations 
 across all cores defined in \code{param}.  
 The default option is recommended when analyzing more genes than the number
  of permutations.}

\item{condition}{A character object that contains the name of the column in 
\code{colData} that represents 
 the biological group or condition of interest (e.g. treatment versus 
 control).  Note that this variable should only contain two 
 possible values since \code{scDD} can currently only handle two-group 
 comparisons.  The default option assumes that there
 is a column named "condition" that contains this variable.}

\item{min.size}{a positive integer that specifies the minimum size of a 
cluster (number of cells) for it to be used
 during the classification step.  Any clusters containing fewer than 
 \code{min.size} cells will be considered an outlier
 cluster and ignored in the classfication algorithm.  The default value
  is three.}

\item{min.nonzero}{a positive integer that specifies the minimum number of
nonzero cells in each condition required for the test of differential 
distributions.  If a gene has fewer nonzero cells per condition, it will
still be tested for DZ (if \code{testZeroes} is TRUE). Default value is
NULL (no minimum value is enforced).}

\item{level}{numeric value between 0 and 1 that specifies the alpha level
for significance of a differential gene test (default value 0.05). This is 
used to decide whether to classify a gene into one of the differential
patterns. If `testZeroes` is FALSE and the adjusted p-value for a given gene 
is below `level`, then the gene is categorized. Alternatively, if `testZeroes` 
is TRUE, then the adjusted p-value must be below `level/2` in order to be
considered significant and categorized. This is done to control for multiple
testing since `testZeroes=TRUE` means that each gene is tested for a 
difference in nonzeroes and zeroes separately.}

\item{categorize}{a logical indicating whether to determine which 
categories (DE, DP, DM, DB) each gene belongs to (default = TRUE). This
can only be set to FALSE if `permutations` is set to zero, since the full
model fitting will automatically be carried out if permutations are run.}
}
\value{
A \code{SingleCellExperiment} object that contains the data and 
sample information from the input object, but where the results objects
are now added to the \code{metadata} slot. The metadata slot is now a
list with four items: the first (main results object) is a data.frame 
with the following columns: 
\itemize{
  \item `gene`: gene name (matches rownames of SCdat)
  \item `DDcategory`: name of the DD (DE, DP, DM, DB, DZ) pattern (or NS = not significant) 
  \item `Clusters.combined`: the number of clusters identified overall
  \item `Clusters.C1`: the number of clusters identified in condition 1 alone
  \item `Clusters.C2`: the number of clusters identified in condition 2 alone
  \item `nonzero.pvalue`: permutation (or KS) p-value for testing difference
  in nonzero expression values
  \item `nonzero.pvalue.adj`: Benjamini-Hochberg adjusted version of the 
    `nonzero.pvalue`column
  \item `zero.pvalue`: p-value for test of difference in dropout rate 
  (only if `testZeroes` is TRUE) 
  \item `zero.pvalue`: Benjamini-Hochberg adjusted version of the previous column 
  (only if `testZeroes` is TRUE) 
  \item `combined.pvalue`: Fisher's combined p-value for a difference in nonzero or zero values
  (only if `testZeroes` is TRUE). 
  \item `combined.pvalue.adj`: Benjamini-Hochberg adjusted version of the previous column 
  (only if `testZeroes` is TRUE) 
}
 
The remaining three elements are matrices (first for condition
  1 and 2 combined, 
 then condition 1 alone, then condition 2 alone) that contains the cluster
  memberships for each sample (cluster 1,2,3,...) in columns and
 genes in rows.  Zeroes, which are not involved in the clustering, are
  labeled as zero.  See the \code{results} function for a convenient
  way to extract these results objects.
}
\description{
Find genes with differential distributions (DD) across two conditions
}
\details{
Find genes with differential distributions (DD) across two 
conditions.  Models each log-transformed gene as a Dirichlet 
  Process Mixture of normals and uses a permutation test to determine 
  whether condition membership is independent of sample clustering.
  The FDR adjusted (Benjamini-Hochberg) permutation p-value is returned 
  along with the classification of each significant gene 
  (with p-value less than 0.05 (or 0.025 if also testing for a difference
   in the proportion of zeroes)) into one of four categories 
  (DE, DP, DM, DB).  For genes that do not show significant influence, 
  of condition on clustering, an optional test of whether the 
  proportion of zeroes (dropout rate) is different across conditions is 
  performed (DZ).
}
\examples{
 
# load toy simulated example SingleCellExperiment object to find DD genes

data(scDatExSim)


# check that this object is a member of the SingleCellExperiment class
# and that it contains 200 samples and 30 genes

class(scDatExSim)
show(scDatExSim)


# set arguments to pass to scDD function
# we will perform 100 permutations on each of the 30 genes

prior_param=list(alpha=0.01, mu0=0, s0=0.01, a0=0.01, b0=0.01)
nperms <- 100


# call the scDD function to perform permutations, classify DD genes, 
# and return results
# we won't perform the test for a difference in the proportion of zeroes  
# since none exists in this simulated toy example data
# this step will take significantly longer with more genes and/or 
# more permutations

scDatExSim <- scDD(scDatExSim, prior_param=prior_param, permutations=nperms, 
            testZeroes=FALSE)
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SimuDP.R
\name{simuDP}
\alias{simuDP}
\title{simuDP}
\usage{
simuDP(Dataset1, Simulated_Data, DEIndex, samplename, Zeropercent_Base, f, FC,
  coeff, RP, modeFC, DP, generateZero, constantZero, varInflation)
}
\arguments{
\item{Dataset1}{Numeric matrix of expression values with genes in rows and 
samples in columns.}

\item{Simulated_Data}{Required input empty matrix to provide structure 
information of 
 output matrix with simulated data}

\item{DEIndex}{Index for DE genes}

\item{samplename}{The name for genes that chosen for simulation}

\item{Zeropercent_Base}{Zero percentage for corresponding gene 
expression values}

\item{f}{Fold change values (number of SDs) for each gene}

\item{FC}{Fold Change values for DE Simulation}

\item{coeff}{Relationship coefficients for Mean and Variance}

\item{RP}{matrix for NB parameters for genes in samplename}

\item{modeFC}{Vector of values to use for fold changes between modes for DP,
DM, and DB.}

\item{DP}{Differetial Proportion vector}

\item{generateZero}{Specification of how to generate the zero values.
If "\code{empirical}" (default), the
 observed proportion of zeroes in each gene is used for the simuated data, 
 and the nonzeroes are simulated from a 
 truncated negative binomial distribution.  If "\code{simulated}", all 
 values are simulated out of
 a negative binomial distribution, includling the zeroes.  
 If "\code{constant}", then each gene has a fixed 
 proportion of zeroes equal to \code{constantZero}.}

\item{constantZero}{Numeric value between 0 and 1 that indicates the fixed 
proportion of zeroes for every gene.
 Ignored if \code{generateZero} method is not equal to "\code{constant}".}

\item{varInflation}{Optional numeric vector with one element for each 
condition that corresponds to the multiplicative 
 variance inflation factor to use when simulating data.  Useful for 
 sensitivity studies to assess the impact of 
 confounding effects on differential variance across conditions. Currently 
 assumes all samples within a 
 condition are subject to the same variance inflation factor.}
}
\value{
Simulated_Data Simulated dataset for DP
}
\description{
Simulation for Differential Proportion Case
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/permutations.R
\name{permMclust}
\alias{permMclust}
\title{permMclust}
\usage{
permMclust(y, nperms, condition, remove.zeroes = TRUE, log.transf = TRUE,
  restrict = FALSE, alpha, m0, s0, a0, b0, ref, min.size)
}
\arguments{
\item{y}{Numeric data vector for one gene}

\item{nperms}{Number of permutations of residuals to evaulate}

\item{condition}{Vector of condition indicators for each sample}

\item{remove.zeroes}{Logical indicating whether 
zeroes need to be removed from \code{y}}

\item{log.transf}{Logical indicating whether the data is 
in the raw scale (if so, will be log-transformed)}

\item{restrict}{Logical indicating whether to perform restricted Mclust
clustering where close-together clusters are joined.}

\item{alpha}{Value for the Dirichlet concentration parameter}

\item{m0}{Prior mean value for generating distribution of cluster means}

\item{s0}{Prior precision value for generating distribution of cluster means}

\item{a0}{Prior shape parameter value for the generating distribution of 
cluster precision}

\item{b0}{Prior scale parameter value for the generating distribution of 
cluster precision}

\item{ref}{one of two possible values in condition; 
represents the referent category.}

\item{min.size}{a positive integer that specifies the minimum size of a 
cluster (number of cells) for it to be used
 during the classification step.  Any clusters containing fewer than 
 \code{min.size} cells will be considered an outlier
 cluster and ignored in the classfication algorithm.  The default value
  is three.}
}
\value{
Bayes factor numerator for the current permutation
}
\description{
Function to  obtain bayes factor numerator for permutations of one gene
}
\details{
Obtains bayes factor numerator for data vector
 \code{y} representing one gene
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R,
 Kendziorski C. A statistical approach for identifying differential 
 distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ex-data.R
\docType{data}
\name{scDatExSim}
\alias{scDatExSim}
\title{Data: Toy example of simulated data}
\format{An object of class \code{SingleCellExperiment} containing 
data for 30 genes for 200 samples
 (100 from condition 1 and 100 from condition 2).  Condition labels (1 or 2)
  are stored in the colData slot.  
 Row names of the assayData slot contain the two letter category label that
  the gene was simulated from (e.g.  'EE', 'DB', ...)
 along with the row number (1-30).}
\usage{
data(scDatExSim)
}
\value{
An RData object, see Format section for details
}
\description{
Toy example data in \code{SingleCellExperiment} format for 500 
genes to illustrate how to generate simulated data from example data
 using \code{\link{simulateSet}}.  Contains 5 genes from each category 
 (DE, DP, DM, DB, EE, and EP).
}
\examples{

# load toy example of simulated data
data(scDatExSim)
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Find_FC.R
\name{findFC}
\alias{findFC}
\title{findFC}
\usage{
findFC(SCdat, index, sd.range = c(1, 3), N = 4, overExpressionProb = 0.5,
  plot.FC = FALSE, condition = "condition")
}
\arguments{
\item{SCdat}{An object of class \code{SingleCellExperiment} that contains 
normalized single-cell expression and metadata. The \code{assays} 
  slot contains a named list of matrices, where the normalized counts are 
  housed in the one named \code{normcounts}.  This matrix should have one
   row for each gene and one sample for each column.  
  The \code{colData} slot should contain a data.frame with one row per 
  sample and columns that contain metadata for each sample.  This data.frame
  should contain a variable that represents biological condition, which is 
  in the form of numeric values (either 1 or 2) that indicates which 
  condition each sample belongs to (in the same order as the columns of 
  \code{normcounts}).  Optional additional metadata about each cell can also
  be contained in this data.frame, and additional information about the 
  experiment can be contained in the \code{metadata} slot as a list.}

\item{index}{Reasonable set of genes for simulation}

\item{sd.range}{Numeric vector of length two which describes the interval
(lower, upper) of standard deviations
of fold changes to randomly select.}

\item{N}{Integer value for the number of bins to divide range of fold 
changes for calculating standard deviations}

\item{overExpressionProb}{Numeric value between 0 and 1 which describes 
the ratio of over to under expression 
 values to sample.}

\item{plot.FC}{Logical indicating whether or not to plot the observed 
and simulated log2 fold changes.}

\item{condition}{A character object that contains the name of the column in 
\code{colData} that represents 
 the biological group or condition of interest (e.g. treatment versus 
 control).  Note that this variable should only contain two 
 possible values since \code{scDD} can currently only handle two-group 
 comparisons.  The default option assumes that there
 is a column named "condition" that contains this variable.}
}
\value{
FC.vec Return Fold Change Vectors
}
\description{
Find the appropriate Fold Change vectors for simulation that will be use in
 classic differential expression case.
}
\details{
This code is a modified version of Sam Younkin's simulate FC 
function.  Major things that were changed are 
  (1) standard deviations are calculated only on the nonzeroes, (2) the
   sampling of FCs is uniform on the log scale 
  instead of the raw scale, and (3) the binning is done by quantiles 
  instead of evenly spaced along the average expression
  values.
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Simulate_set.R
\name{simulateSet}
\alias{simulateSet}
\title{simulateSet}
\usage{
simulateSet(SCdat, numSamples = 100, nDE = 250, nDP = 250, nDM = 250,
  nDB = 250, nEE = 5000, nEP = 4000, sd.range = c(1, 3), modeFC = c(2,
  3, 4), plots = TRUE, plot.file = NULL, random.seed = 284,
  varInflation = NULL, condition = "condition", param = bpparam())
}
\arguments{
\item{SCdat}{An object of class \code{SingleCellExperiment} that contains 
normalized single-cell expression and metadata. The \code{assays} 
  slot contains a named list of matrices, where the normalized counts are 
  housed in the one named \code{normcounts}.  This matrix should have one
   row for each gene and one sample for each column.  
  The \code{colData} slot should contain a data.frame with one row per 
  sample and columns that contain metadata for each sample.  This data.frame
  should contain a variable that represents biological condition, which is 
  in the form of numeric values (either 1 or 2) that indicates which 
  condition each sample belongs to (in the same order as the columns of 
  \code{normcounts}).  Optional additional metadata about each cell can also
  be contained in this data.frame, and additional information about the 
  experiment can be contained in the \code{metadata} slot as a list.}

\item{numSamples}{numeric value for the number of samples in each condition 
to simulate}

\item{nDE}{Number of DE genes to simulate}

\item{nDP}{Number of DP genes to simulate}

\item{nDM}{Number of DM genes to simulate}

\item{nDB}{Number of DB genes to simulate}

\item{nEE}{Number of EE genes to simulate}

\item{nEP}{Number of EP genes to simulate}

\item{sd.range}{Numeric vector of length two which describes the interval
(lower, upper) of standard deviations
of fold changes to randomly select.}

\item{modeFC}{Vector of values to use for fold changes between modes for DP,
DM, and DB.}

\item{plots}{Logical indicating whether or not to generate fold change and 
validation plots}

\item{plot.file}{Character containing the file string if the plots are to be
sent to a pdf instead of to the standard output.}

\item{random.seed}{Numeric value for a call to \code{set.seed} for 
reproducibility.}

\item{varInflation}{Optional numeric vector with one element for each 
condition that corresponds to the multiplicative 
 variance inflation factor to use when simulating data.  Useful for 
 sensitivity studies to assess the impact of 
 confounding effects on differential variance across conditions. Currently 
 assumes all samples within a 
 condition are subject to the same variance inflation factor.}

\item{condition}{A character object that contains the name of the column in 
\code{colData} that represents 
 the biological group or condition of interest (e.g. treatment versus 
 control).  Note that this variable should only contain two 
 possible values since \code{scDD} can currently only handle two-group 
 comparisons.  The default option assumes that there
 is a column named "condition" that contains this variable.}

\item{param}{a \code{MulticoreParam} or \code{SnowParam} object of 
the \code{BiocParallel}
package that defines a parallel backend.  The default option is 
\code{BiocParallel::bpparam()} which will automatically creates a cluster 
appropriate for 
the operating system.  Alternatively, the user can specify the number
of cores they wish to use by first creating the corresponding 
\code{MulticoreParam} (for Linux-like OS) or \code{SnowParam} (for Windows)
object, and then passing it into the \code{scDD}
function. This could be done to specify a parallel backend on a Linux-like
OS with, say 12 
cores by setting \code{param=BiocParallel::MulticoreParam(workers=12)}}
}
\value{
An object of class \code{SingleCellExperiment} that contains 
simulated single-cell expression and metadata. The \code{assays} 
  slot contains a named list of matrices, where the simulated counts are 
  housed in the one named \code{normcounts}.  This matrix should have one
   row for each gene (\code{nDE + nDP + nDM + nDB + nEE
   + nEP} rows) and one sample for each column (\code{numSamples} columns).  
  The \code{colData} slot contains a data.frame with one row per 
  sample and a column that represents biological condition, which is 
  in the form of numeric values (either 1 or 2) that indicates which 
  condition each sample belongs to (in the same order as the columns of 
  \code{normcounts}). The \code{rowData} slot contains information about the
  category of the gene (EE, EP, DE, DM, DP, or DB), as well as the simulated
  foldchange value.
}
\description{
Simulation of a complete dataset, where the number of each type of 
differential distributions and equivalent distributions is specified.
}
\examples{

# Load toy example ExpressionSet to simulate from

data(scDatEx)


# check that this object is a member of the ExpressionSet class
# and that it contains 142 samples and 500 genes

class(scDatEx)
show(scDatEx)


# set arguments to pass to simulateSet function
# we will simuate 30 genes total; 5 genes of each type;
# and 100 samples in each of two conditions

nDE <- 5
nDP <- 5
nDM <- 5
nDB <- 5
nEE <- 5
nEP <- 5
numSamples <- 100
seed <- 816


# create simulated set with specified numbers of DE, DP, DM, DM, EE, and 
# EP genes,
# specified number of samples, DE genes are 2 standard deviations apart, and 
# multimodal genes have modal distance of 4 standard deviations

SD <- simulateSet(scDatEx, numSamples=numSamples, nDE=nDE, nDP=nDP, nDM=nDM,
                  nDB=nDB, nEE=nEE, nEP=nEP, sd.range=c(2,2), modeFC=4, 
                  plots=FALSE, 
                  random.seed=seed)
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Single_Cell_Simu.R
\name{singleCellSimu}
\alias{singleCellSimu}
\title{singleCellSimu}
\usage{
singleCellSimu(Dataset1, Method, index, FC, modeFC, DP, Validation = FALSE,
  numGenes = 1000, numDE = 100, numSamples = 100,
  generateZero = c("empirical", "simulated", "constant"),
  constantZero = NULL, varInflation = NULL)
}
\arguments{
\item{Dataset1}{Numeric matrix of expression values with genes in rows and 
samples in columns.}

\item{Method}{Type of simulation should choose from "DE" "DP" "DM" "DB"}

\item{index}{Reasonable set of genes for simulation}

\item{FC}{Fold Change values for DE Simulation}

\item{modeFC}{Vector of values to use for fold changes between modes for DP,
DM, and DB.}

\item{DP}{Differetial Proportion vector}

\item{Validation}{Show Validation plots or not}

\item{numGenes}{numeric value for the number of genes to simulate}

\item{numDE}{numeric value for the number of genes that will differ between
two conditions}

\item{numSamples}{numeric value for the number of samples in each condition 
to simulate}

\item{generateZero}{Specification of how to generate the zero values.
If "\code{empirical}" (default), the
 observed proportion of zeroes in each gene is used for the simuated data, 
 and the nonzeroes are simulated from a 
 truncated negative binomial distribution.  If "\code{simulated}", all 
 values are simulated out of
 a negative binomial distribution, includling the zeroes.  
 If "\code{constant}", then each gene has a fixed 
 proportion of zeroes equal to \code{constantZero}.}

\item{constantZero}{Numeric value between 0 and 1 that indicates the fixed 
proportion of zeroes for every gene.
 Ignored if \code{generateZero} method is not equal to "\code{constant}".}

\item{varInflation}{Optional numeric vector with one element for each 
condition that corresponds to the multiplicative 
 variance inflation factor to use when simulating data.  Useful for 
 sensitivity studies to assess the impact of 
 confounding effects on differential variance across conditions. Currently 
 assumes all samples within a 
 condition are subject to the same variance inflation factor.}
}
\value{
Simulated_Data A list object where the first element contains a 
matrix of 
the simulated dataset, the second element contains the DEIndex, and the 
third 
element contains the fold change (between two conditions for DE, between 
two modes 
for DP, DM, and DB).
}
\description{
Called by \code{\link{simulateSet}} to simulate a specified number of genes 
from 
  one DD category at a time.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classify.dd.R
\name{feDP}
\alias{feDP}
\title{feDP}
\usage{
feDP(pe_mat, condition, sig_genes, oa, c1, c2, log.nonzero = TRUE,
  testZeroes = FALSE, adjust.perms = FALSE, min.size = 3)
}
\arguments{
\item{pe_mat}{Matrix with genes in rows and samples in columns.
Column names indicate condition.}

\item{condition}{Vector of condition indicators (with two possible values).}

\item{sig_genes}{Vector of the indices of significantly DD genes 
(indicating the row number of \code{pe_mat})}

\item{oa}{List item with one item for each gene where the first element 
contains the cluster membership for 
 each nonzero sample in the overall (pooled) fit.}

\item{c1}{List item with one item for each gene where the first element 
contains the cluster membership for 
 each nonzero sample in condition 1 only fit}

\item{c2}{List item with one item for each gene where the first element 
contains the cluster membership for 
 each nonzero sample in condition 2 only fit}

\item{log.nonzero}{Logical indicating whether to perform log 
transformation of nonzero values.}

\item{testZeroes}{Logical indicating whether or not to test for a 
difference in the proportion of zeroes. This will only be done for genes 
that have at least one zero value (genes where all cells have a nonzero value
will have a `zero.pvalue` of NA).}

\item{adjust.perms}{Logical indicating whether or not to adjust the 
permutation tests for the sample
  detection rate (proportion of nonzero values).  If true, the 
  residuals of a linear model adjusted for 
  detection rate are permuted, and new fitted values are 
  obtained using these residuals.}

\item{min.size}{a positive integer that specifies the minimum size of a 
cluster (number of cells) for it to be used
 during the classification step.  Any clusters containing fewer than 
 \code{min.size} cells will be considered an outlier
 cluster and ignored in the classfication algorithm.  The default value
  is three.}
}
\value{
cat Character vector of the same length as \code{sig_genes} 
that indicates which nonsignificant genes by
 the permutation test belong to the DP category
}
\description{
Function to identify additional DP genes, since clustering process can be 
consistent within each condition 
  and still have differential proportion within each mode.  
  The Bayes factor score also tends to be small when
  the correct number of clusters is not correctly detected; 
  in that case differential proportion will manifest
  as a mean shift.
}
\details{
The Fisher's Exact test is used to test for independence of 
condition membership and clustering when 
  the clustering is the same across conditions as it is overall 
  (and is multimodal). When clustering within 
  condition is not multimodal or is different across conditions 
  (most often the case), an FDR-adjusted t-test
  is performed to detect overall mean shifts.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/permutations.R
\name{permMclustCov}
\alias{permMclustCov}
\title{permMclustCov}
\usage{
permMclustCov(y, nperms, C, condition, remove.zeroes = TRUE,
  log.transf = TRUE, restrict = FALSE, alpha, m0, s0, a0, b0, ref, min.size)
}
\arguments{
\item{y}{Numeric data vector for one gene}

\item{nperms}{Number of permutations of residuals to evaulate}

\item{C}{Matrix of confounder variables, where there is one row for each
sample and one column for each covariate.}

\item{condition}{Vector of condition indicators for each sample}

\item{remove.zeroes}{Logical indicating whether zeroes need to be removed 
from \code{y}}

\item{log.transf}{Logical indicating whether the data is in the raw scale 
(if so, will be log-transformed)}

\item{restrict}{Logical indicating whether to perform restricted Mclust 
clustering where close-together clusters are joined.}

\item{alpha}{Value for the Dirichlet concentration parameter}

\item{m0}{Prior mean value for generating distribution of cluster means}

\item{s0}{Prior precision value for generating distribution of cluster means}

\item{a0}{Prior shape parameter value for the generating distribution of 
cluster precision}

\item{b0}{Prior scale parameter value for the generating distribution of 
cluster precision}

\item{ref}{one of two possible values in condition; represents the 
referent category.}

\item{min.size}{a positive integer that specifies the minimum size of a 
cluster (number of cells) for it to be used
 during the classification step.  Any clusters containing fewer than 
 \code{min.size} cells will be considered an outlier
 cluster and ignored in the classfication algorithm.  The default value
  is three.}
}
\value{
Bayes factor numerator for the current permutation
}
\description{
Function to  obtain bayes factor for permutations of one gene's residuals
}
\details{
Obtains bayes factor numerator for data vector \code{y} 
representing one gene
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222. 
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Preprocess.R
\name{preprocess}
\alias{preprocess}
\title{preprocess}
\usage{
preprocess(SCdat, condition = "condition", zero.thresh = 0.9,
  scran_norm = FALSE, median_norm = FALSE)
}
\arguments{
\item{SCdat}{An object of class \code{SingleCellExperiment} that contains 
single-cell expression and metadata. The \code{assays} 
 slot contains a named list of matrices, where the normalized counts are 
 housed in the one named \code{normcounts}, and unnormalized counts are 
 stored in the one names \code{counts}. If either \code{scran_norm} or 
 \code{median_norm} is set to TRUE, the \code{normcounts} slot will be 
 created from the \code{counts} slot. The counts and normalized counts 
 matrices should have one
  row for each gene and one sample for each column.  
 The \code{colData} slot should contain a data.frame with one row per 
 sample and columns that contain metadata for each sample.  This data.frame
 should contain a variable that represents biological condition, which is 
 in the form of numeric values (either 1 or 2) that indicates which 
 condition each sample belongs to (in the same order as the columns of 
 \code{normcounts}).  Optional additional metadata about each cell can also
 be contained in this data.frame, and additional information about the 
 experiment can be contained in the \code{metadata} slot as a list.}

\item{condition}{A character object that contains the name of the column in 
\code{colData} that represents 
 the biological group or condition of interest (e.g. treatment versus 
 control).  Note that this variable should only contain two 
 possible values since \code{scDD} can currently only handle two-group 
 comparisons.  The default option assumes that there
 is a column named "condition" that contains this variable.}

\item{zero.thresh}{A numeric value between 0 and 1 that represents
the maximum proportion
of zeroes per gene allowable in the processed dataset}

\item{scran_norm}{Logical indicating whether or not to normalize the data
using scran Normalization from \code{scran}}

\item{median_norm}{Logical indicating whether or not to normalize the data
using Median Normalization from \code{EBSeq}}
}
\value{
An object of class \code{SingleCellExperiment} with genes removed if
they have more than \code{zero.thresh} zeroes, and the \code{normcounts} 
assay added if either \code{scran_norm} or \code{median_norm} is set to TRUE
and only \code{counts} is provided. If \code{normcounts} already exists and
either \code{scran_norm} or \code{median_norm} is set to TRUE, then the new
normalized counts are placed in the \code{normcounts} assay slot, and the
original values are moved to a new slot called \code{normcounts-orig}.
}
\description{
Function to preprocess SingleCellExperiment object (1) to
only keep genes with a certain number of nonzero entries,
and (2) optionally apply a normalization procedure.
}
\examples{
 
 # load toy example SingleCellExperiment object
 
 data(scDatEx)
 
 # apply the preprocess function to filter out genes if they have more than
 # 75\% zero
 
 scDatEx <- preprocess(scDatEx, zero.thresh=0.75)
 
 # apply the preprocess function again, but this time threshold on the 
 # proportion of zeroes and apply scran normalization
 # set the zero.thresh argument to 0.75 so that genes with more than 75\% 
 # zeroes are filtered out 
 # set the scran_norm argument to TRUE to return scran normalized counts
 
 scDatEx.scran <- preprocess(scDatEx, zero.thresh=0.75, scran_norm=TRUE)
 
 # set the median_norm argument to TRUE to return Median normalized counts
 
 scDatEx.median <- preprocess(scDatEx, zero.thresh=0.75, median_norm=TRUE)
}
\references{
Korthauer KD, Chu LF, Newton MA, Li Y, Thomson J, Stewart R, 
Kendziorski C. A statistical approach for identifying differential 
distributions
in single-cell RNA-seq experiments. Genome Biology. 2016 Oct 25;17(1):222.
\url{https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-
1077-y}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classify.dd.R
\name{testZeroes}
\alias{testZeroes}
\title{testZeroes}
\usage{
testZeroes(dat, cond, these = 1:nrow(dat))
}
\arguments{
\item{dat}{Matrix of single cell expression data with genes in rows and 
samples in columns.}

\item{cond}{Vector of condition labels}

\item{these}{vector of row numbers (gene numbers) to test for a difference
in the proportion of zeroes.}
}
\value{
Vector of FDR adjusted p-values
}
\description{
Test for a difference in the proportion of zeroes between conditions 
for a specified set of genes
}
\details{
Test for a difference in the proportion of zeroes between 
conditions that is not explained by the 
  detection rate.  Utilizes Bayesian logistic regression.
}
